#!/bin/bash

 ##############################################################################
 # Filename: bash/language.sh
 #
 # This file is part of the JAS project.
 # Copyright 2003-2013 by Matthijs Schuurman
 #
 # The JAS project is free software under the terms of the
 # GNU Lesser General Public License version 3 or any later version.
 #
 # For information about the license please refer to:
 # LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 ##############################################################################


if [ "$1" != "" ]; then
 FILES="$@"
else
 FILES=`grep -Rl "\->add(" *`
fi

for k in $FILES
do
 echo
 echo "  <!-- $k -->"
 #find all add statements
 grep -i "\->add(" $k | \
  #get error message
  sed -e "s/^.*add(\([^,]*\).*/\\1/" | \
  #remove all errors without text
  sed -e "s/^[^\"]\+$//" | \
  #remove end );
  sed -e "s/);$//g" | \
  #trim quotes
  sed -e "s/^\"\|\"$//g" | \
  #replace escaped quotes with xml quotes and |notranslate|
  sed -e "s/\\\\\"\(.\+\)\\\\\"/\&quot;|notranslate|\&quot;/g" | \
  #replace everything between normal quotes with |notranslate|
  sed -e "s/\"\([^\"]\+\)\"/|notranslate|/g" | \
  #replace double pipes, potentially introduced by previous line
  sed -e "s/||/|/g" | \
  #add xml tags
  sed -e "s/^\(.\+\)/  <translation original=\"\\1\" translated=\"\\1\" \/>/" 
done
