<?

 /*****************************************************************************
 * Filename: data.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 //die bitch
 if(!isset($_REQUEST["project"])||!preg_match("/^([a-z0-9]{1,25})$/i", $_REQUEST["project"]))
  exit;

 $_jseskey="data";
 $_project=$_REQUEST["project"];
 
 $_path["root"]="";
 require($_path["root"]."include.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."error.php");
 require_once($_path["include"]."http.php");

 ini_set("display_errors", 0); //don't show PHP errors in API

 $e=new Error();

 if(!isset($_config["api"]["data"])||!$_config["api"]["data"]) //API disabled
  $e->add("Data API disabled");
 else
 {
  if(isset($_REQUEST["username"])&&isset($_REQUEST["password"]))
  {
   $d=new Data($_config["usermodule"], "user", "login"); 

   foreach($d->check("properties", "username") as $k)
    $d->setValue($k, $_REQUEST["username"]);
    
   foreach($d->check("properties", "password") as $k)
    $d->setValue($k, $_REQUEST["password"]);

   if(!$d->submit())
    $e->add($d->e);
  }

  if(!isset($_REQUEST["data"])||!is_array($_REQUEST["data"]))
   $e->add("No data variable in request");
 }

 $data=Array();

 if(isset($_REQUEST["dataCompression"]))
 {
  if(!in_array($_REQUEST["dataCompression"], DataHTTP::compression()))
  {
   $this->e->add("Compression method: ".strip_tags($_REQUEST["dataCompression"])." not supported");
   $compression=false;
  }
  else
  {
   $compression=$_REQUEST["dataCompression"];
   $data[]="dataCompression=".$compression;
  }
 }
 else
  $compression=false;

 if(!$e->any("fatal"))
 {
  foreach($_REQUEST["data"] as $key => $d)
  {
   switch($compression)
   {
    case "BZ2":
    {
     $d=unserialize(bzdecompress($d));
     break;
    }
    case "GZ":
    {
     $d=unserialize(gzuncompress($d));
     break;
    }
    default:
    {
     $d=unserialize($d);
     break; 
    }
   }

   if(!preg_match("/data/i", get_class($d)))
    $e->add("No data object for entry: ".$key." in request");
   else
   {
    switch($d->action)
    {
     case "view":
     {
      if($d->extra=="item")
       $type="ViewItem";
      else if($d->extra=="list")
       $type="ViewList";
      else //all
       $type="ViewAll";
  
      if(!$_config["api"]["data".$type])
       $e->add("Data API ".$d->action." ".$d->extra." disabled");
      else if(!$_config["api"][$type."AllModules"]&&!in_array($d->module, $_config["api"][$type."Modules"]))
       $e->add("Data API ".$d->module." ".$d->action." ".$d->extra." disabled");

      break;
     }
     case "add":
     case "edit":
     case "delete":
     {
      $type=ucfirst($d->action);
  
      if(!$_config["api"]["data".$type])
       $e->add("Data API ".$d->action." disabled");
      else if(!$_config["api"][$type."AllModules"]&&!in_array($d->module, $_config["api"][$type."Modules"]))
       $e->add("Data API ".$d->module." ".$d->action." disabled");

      break;
     }
     default: 
     {
      $e->add("Data API ".$d->action." not supported");
      break;
     }
    }

    if(!$e->any("fatal"))
    {
     if($d->getValue("s"))
      $d->submit();
     else
      $d->get();
     
     switch($compression)
     {
      case "BZ2":
      {
       $data[]="data[]=".urlencode(bzcompress(serialize($d)));
       break;
      }
      case "GZ":
      {
       $data[]="data[]=".urlencode(gzcompress(serialize($d)));
       break;
      }
      default:
      {
       $data[]="data[]=".urlencode(serialize($d));
       break; 
      }
     }
    }
   }
  }
 }

 switch($compression)
 {
  case "BZ2":
  {
   $data[]="error=".urlencode(bzcompress(serialize($e)));
   break;
  }
  case "GZ":
  {
   $data[]="error=".urlencode(gzcompress(serialize($e)));
   break;
  }
  default:
  {
   $data[]="error=".urlencode(serialize($e));
   break; 
  }
 }

 $data=implode("&", $data);

 header("Content-Length: ".strlen($data));
 print $data;
?>
