<?

 /*****************************************************************************
 * Filename: export.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(preg_match("/MSIE/i", $_SERVER["HTTP_USER_AGENT"]))
 {
  session_cache_limiter("private");
  session_cache_expire(60);

  if(!session_id())
   session_start();

  header("Pragma: public");
 }

 $_path["root"]="";
 require($_path["root"]."include.php");

 //hack for JAS project, switch to correct jses+path
 if($_jses["project"]=="jas"&&isset($_jses["currentProject"])&&$_jses["currentProject"]!="jas")
 {
  $_jasPath=$_path;
  require($_jasPath["project"]["include"]."switch.php"); //currentProject
 }

 ini_set("display_errors", 0); //don't show PHP errors in API

 require_once($_path["include"]."error.php");

 $e=new Error();
 $e->l->read("export");

 if(!isset($_config["api"]["export"])||!$_config["api"]["export"]) //API disabled
  exportError("Export API disabled");

 if(!($method=request("method")))
  exportError("Method parameter not set");
 else
 {
  $methods=Array();
  foreach($_config["api"]["exportMethods"] as $method)
   $methods[]=strtoupper($method);

  $method=strtoupper($method);
  if(!in_array($method, $methods))
   exportError("Unknown export method");
 }

 if($fields=request("fields"))
  $fields=explode(";", $fields);
 else
  $fields=false;

 if($method=="CSV")
 {
  require_once($_path["include"]."csv.php");

  $csv=new CSV();
  $d=new Data(false, "view", false, Array("format" => "text"));

  if($d->extra=="item")
   $type="ViewItem";
  else if($d->extra=="list")
   $type="ViewList";
  else //all
   $type="ViewAll";

  if(!$_config["api"]["export".$type])
   exportError("Export API ".$d->action." ".$d->extra." disabled");

  if(!$_config["api"][$type."AllModules"]&&!in_array($d->module, $_config["api"][$type."Modules"]))
   exportError("Export API ".$d->module." ".$d->extra." disabled");

  if($fields)
   $d->setShowFields($fields);

  if(!$d->get(1))
   exportError($d->e);
  else if($d->e->any("warning"))
   exportError($d->e);

  $csv->data($d, $fields, true);
  print $csv->output();
  exit;
 }


 function exportError($error)
 {
  global $e;

  if(is_object($error)&&strtolower(get_class($error))=="error")
   print $error->show();
  else
  {
   $e->add($error);
   print $e->show();
  }

  exit;
 }
?>
