<?

 /*****************************************************************************
 * Filename: file.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(preg_match("/MSIE/i", $_SERVER["HTTP_USER_AGENT"]))
 {
  session_cache_limiter("private");
  session_cache_expire(60);

  if(!session_id())
   session_start();

  header("Pragma: public");
 }

 if(!isset($_path["root"]))
  $_path["root"]="";

 require($_path["root"]."include.php");

 //hack for JAS project, switch to correct jses+path
 if($_jses["project"]=="jas"&&isset($_jses["currentProject"])&&$_jses["currentProject"]!="jas")
 {
  $_jasPath=$_path;
  require($_jasPath["project"]["include"]."switch.php"); //currentProject
 }

 ini_set("display_errors", 0); //don't show PHP errors in API

 require_once($_path["include"]."data.php");
 require_once($_path["include"]."error.php");

 $e=new Error();

 //select module
 if($module=strip_tags(request("m")))
  $d=new Data($module, "view", "item");
 else //use file module by default
  $d=new Data("files", "view", "item");

 //identifier
 $d->setValue("nr", request("nr"));

 //module field to download
 if($field=request('field'))
 {
  if(!$d->check("type", "file", $field)&&!$d->check("type", "localfile", $field))
   $e->add("Incorrect file field for module: \"".$module."\"", "hack");
 }
 else // autodetect
 {
  //get first file field
  foreach($d->check("type", "file") as $field)
   break;

  if(!$field)
  {
   //get first local file field
   foreach($d->check("type", "localfile") as $field)
    break;

   if(!$field)
    $e->add("No file field for module: \"".$module."\"", "hack");
  }
 }

 if(!$e->any("fatal"))
 {
  $d->setShowFields($field, $field."Data", $field."Type", $field."Size");

  if(!$d->get())
   $e->add($d->e);
  else if(!$d->next())
   $e->add("No file data for module: \"".$module."\"", "error");
 }

 if($e->any("fatal"))
 {
  print $e->show("fatal");
  print "<a href=\"javascript: back();\">Back</a>";
 }
 else
 {
  header("Content-type: ".$d->v[$field."Type"]);

  if(strstr($d->v[$field."Type"], "image"))
   header('Content-Disposition: inline; filename="'.$d->v[$field].'"');
  else
   header('Content-Disposition: attachment; filename="'.$d->v[$field].'"');

  header("Content-Length: ".$d->v[$field."Size"]);

  print $d->v[$field."Data"];
  exit;
 }
?>
