#!/usr/bin/php 
<?

 /*****************************************************************************
 * Filename: httpd.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 ini_set("display_errors", 0);

 if(!ini_get("date.timezone"))
  date_default_timezone_set("UTC");

 if(!isset($argv))
 {
  print "Can only run from command line!";
  exit;
 }

 if(preg_match("!^(.+)/([^/]+)$!", $argv[0], $tmp))
 {
  chdir($tmp[1]);

  $_path["root"]="./";
 }
 else
 {
  $_path["root"]="./";
 }
 unset($argv, $argc, $tmp);

 $_jses["project"]="HTTPD NON EXISTING PROJECT";

 $_path["include"]=$_path["root"]."include/";
 $_path["modules"]=$_path["include"]."modules/";

 $_path["project"]=$_path;
 $_path["HTML"]["root"]=$_path["root"];

 declare(ticks=1);
 pcntl_signal(SIGABRT, "sig_handler");
 pcntl_signal(SIGSEGV, "sig_handler");
 pcntl_signal(SIGTERM, "sig_handler");
 pcntl_signal(SIGQUIT, "sig_handler");
 pcntl_signal(SIGHUP,  "sig_handler");
 pcntl_signal(SIGUSR1, "sig_handler");
 pcntl_signal(SIGINT, "sig_handler");
 pcntl_signal(SIGPIPE, "sig_handler");
 pcntl_signal(SIGALRM, "sig_handler");

 require($_path["include"]."httpd.php");

// $_config["language"]="nl";

 $httpd=new HTTPD();

 if(!$httpd->start())
  exit(1);

 while($FORKSCRIPT=$httpd->accept())
 {
  if($FORKSCRIPT!==true)
  {
   require($FORKSCRIPT);
   exit(0);
  }
  $httpd->e->add("Received: ".$httpd->bytesReceived.", send: ".$httpd->bytesSend.", time: ".number_format($httpd->requestTime, 5), "note");
 }

 if($httpd->socket)
  $httpd->stop();

 exit(1);

 function sig_handler($signo)
 {
  global $httpd, $config;

  switch($signo)
  {
   case SIGALRM:
   {
    pcntl_alarm($config["alarm"]);
    break;
   }
   //ignore
   case SIGPIPE:
   {
    break;
   }
   //restart
   case SIGHUP:
   case SIGUSR1: 
   {
    $httpd->e->add("Caught signal: ".$signo.", restarting server", "system");
    $httpd->stop();

    if(!$httpd->start())
     sig_handler(SIGTERM);

    break;
   }

   //quit
   default:
   {
    $httpd->e->add("Caught signal: ".$signo.", stopping server", "system");

    if($httpd->socket)
     $httpd->stop();

    if($signo==SIGTERM)
     exit(0);
    else
     exit(1);

    break;
   }
  }
 }


?>
