<?

 /*****************************************************************************
 * Filename: include.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!ini_get("date.timezone"))
  date_default_timezone_set("UTC");

 if(!isset($_path)||!isset($_path["root"]))
  $_path["root"]="";
 if(!isset($_path["include"]))
  $_path["include"]=$_path["root"]."include/";
 if(!isset($_path["projects"]))
  $_path["projects"]=$_path["root"]."project/";
 if(!isset($_path["images"]))
  $_path["images"]=$_path["root"]."images/";
 if(!isset($_path["script"]))
  $_path["script"]=$_path["root"]."script/";
 if(!isset($_path["modules"]))
  $_path["modules"]=$_path["include"]."modules/";
 if(!isset($_path["plugins"]))
  $_path["plugins"]=$_path["include"]."plugins/";

 if(strstr($_SERVER["SCRIPT_FILENAME"], "/"))
  $_path["file"]=substr($_SERVER["SCRIPT_NAME"], (strrpos($_SERVER["SCRIPT_NAME"], "/")+1));
 else
  $_path["file"]=$_SERVER["SCRIPT_NAME"];

 //set HTML paths
 $re="";
 $l=substr_count($_path["root"], "../");
 for($c=0;$c<$l;$c++)
  $re.="[^/]+/";

 $re="!".$re."$!";

 $_path["HTML"]["current"]=preg_replace("![^/]+$!", "", $_SERVER["SCRIPT_FILENAME"]); //remove script name
 $_path["HTML"]["current"]=preg_replace("!".$_SERVER["DOCUMENT_ROOT"]."!", "", $_path["HTML"]["current"]); //remove document current
 $_path["HTML"]["root"]=preg_replace($re, "", $_path["HTML"]["current"]); //remove directories up till root

 if(isset($_SERVER["REQUEST_URI"])) //not set when run from cli
  $_path["HTML"]["url"]=preg_replace("!\?.*$!", "", $_SERVER["REQUEST_URI"]); //remove arguments

 $_path["HTML"]["relative"]="";
 $_path["HTML"]["prefix"]="";

 unset($c, $l, $r);

 if(!isset($_benchmark))
  $_benchmark=false;

 require($_path["include"]."session.php");

 //send basic headers (after session is initialized)
 require_once($_path["include"]."headers.php");
 Headers::basic();

 if(!isset($_jses["project"])) //detect project 
 {
  if(isset($_project)&&$_project&&preg_match("/^([a-z0-9]{1,25})$/i", $_project)) //$_project?
  {
   $_jses["project"]=$_project;
   unset($_project);
  }
  else if(preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["SCRIPT_FILENAME"], $tmp)) //project dir in script filename?
   $_jses["project"]=$tmp[1];
  else if(isset($_SERVER["PWD"])&&preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["PWD"], $tmp)) //cli: maybe in current path?
   $_jses["project"]=$tmp[1];
  else
   $_jses["project"]="jas";
 }

 if(!isset($_path["project"]["root"]))
  $_path["project"]["root"]=$_path["projects"].$_jses["project"]."/";
 if(!isset($_path["project"]["html"]))
  $_path["project"]["html"]=$_path["project"]["root"]."html/";
 if(!isset($_path["project"]["images"]))
  $_path["project"]["images"]=$_path["project"]["root"]."images/";
 if(!isset($_path["project"]["include"]))
  $_path["project"]["include"]=$_path["project"]["root"]."include/";
 if(!isset($_path["project"]["modules"]))
  $_path["project"]["modules"]=$_path["project"]["include"]."modules/";
 if(!isset($_path["project"]["plugins"]))
  $_path["project"]["plugins"]=$_path["project"]["include"]."plugins/";
 if(!isset($_path["project"]["script"]))
  $_path["project"]["script"]=$_path["project"]["root"]."script/";
 if(!isset($_path["project"]["style"]))
  $_path["project"]["style"]=$_path["project"]["root"]."style/";
 if(!isset($_path["project"]["download"]))
  $_path["project"]["download"]=$_path["project"]["root"]."download/";
 if(!isset($_path["project"]["templates"]))
  $_path["project"]["templates"]=$_path["project"]["root"]."templates/";
 if(!isset($_path["project"]["cache"]))
  $_path["project"]["cache"]=$_path["project"]["root"]."cache/";

//configuration
 if(isset($_REQUEST["reloadConfig"])&&$_REQUEST["reloadConfig"])
 {
  global $_reloadConfigSet;
  if(!$_reloadConfigSet)
  {
   $_jses["config"]["reload"]=true;
   $_reloadConfigSet=true;
  }
 }

 require_once($_path["include"]."config.php");
 @Config::load(); //surpress strict warning

//set script timezone  
 if($_config["timezone"]&&$_config["timezone"]!=date_default_timezone_get())
  date_default_timezone_set($_config["timezone"]);

//php configuration, read after config
 require($_path["include"]."php.ini.php");

//browser and os detection
 require($_path["include"]."browser.php");

//mod_rewrite detection
 require($_path["include"]."rewrite.php");

//setup _benchmark
 if($_config["benchmark"]&&!$_benchmark)
 {
  require_once($_path["include"]."benchmark.php");
  $_benchmark=new Benchmark();
 }

//detect current project from JAS sites config
 if($_jses["project"]=="jas"&&$_jseskey!="jas"&&isset($_config["sites"]))
 {
  foreach($_config["sites"] as $site)
  {
   if($site["current"])
   {
    if($_jses["project"]==$site["project"]) //current project (jas) already active
     unset($_config["sites"]); //don't keep trying to detect current site 
    else
    {
     $_jses["project"]=$site["project"]; //overwrite project variable

     unset($_path["project"]); //clear path definition
     $_jses["config"]=Array(); //clear config

     require($_path["root"]."include.php"); //reinit project
    }
   }
  }
 }

?>
