<?

 /*****************************************************************************
 * Filename: include/browser.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!isset($_jses["browser"]))
 {
  if(isset($_SERVER["HTTP_USER_AGENT"]))
  {

/* OS detection */

   if(preg_match("/(Linux|FreeBSD|NetBSD)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["os"]=$tmp[1];
   }
   else if(preg_match("/Windows\s(3\.1|95|NT|98|ME|2000|XP|2003)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    if($tmp[1]=="98"&&preg_match("/Win 9x 4\.9/", $_SERVER["HTTP_USER_AGENT"]))
     $_jses["os"]="Windows ME";
    else if($tmp[1]=="NT"&&preg_match("/Windows NT 5\.1/", $_SERVER["HTTP_USER_AGENT"]))
     $_jses["os"]="Windows XP";
    else
     $_jses["os"]="Windows ".$tmp[1];
   }
   else
   {
    $_jses["os"]="unknown";
   }

 /* Browser Detection */

   if(preg_match("/Opera.*Version\/([0-9]+)\.([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Opera ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="opera".$tmp[1];
   }
   else if(preg_match("/Opera(\s|\/)([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Opera ".$tmp[2].".".$tmp[3];
    $_jses["stylesheet"]="opera".$tmp[2];
   }
   else if(preg_match("/Opera/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Opera";
    $_jses["stylesheet"]="opera";
   }
   else if(preg_match("/Chrome(\s|\/)([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Chrome ".$tmp[2].".".$tmp[3];
    $_jses["stylesheet"]="chrome".$tmp[2];
   }
   else if(preg_match("/MSIE\s([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Internet Explorer ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="ie".$tmp[1];
   }
   else if(preg_match("/Netscape\/{0,1}([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Netscape ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="netscape".$tmp[1];
   }
   else if(preg_match("/Mozilla\/(4)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Netscape ".$tmp[1];
    $_jses["stylesheet"]="netscape".$tmp[1];
   }
   else if(preg_match("/Konqueror\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Konqueror ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="konqueror".$tmp[1];
   }
   else if(preg_match("/Konqueror/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Konqueror";
    $_jses["stylesheet"]="konqueror";
   }
   else if(preg_match("/SeaMonkey\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="SeaMonkey ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="seamonkey".$tmp[1];
   }
   else if(preg_match("/Firefox\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Firefox ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="firefox".$tmp[1];
   }
   else if(preg_match("/Mozilla\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Mozilla ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="mozilla".$tmp[1];
   }
   else if(preg_match("/Lynx\/([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Lynx ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="text";
   }
   else if(preg_match("/Links \(([0-9]+)\.{0,1}([0-9]*)/i", $_SERVER["HTTP_USER_AGENT"], $tmp))
   {
    $_jses["browser"]="Links ".$tmp[1].".".$tmp[2];
    $_jses["stylesheet"]="text";
   }
   else
   {
    $_jses["browser"]=$_SERVER["HTTP_USER_AGENT"];
    $_jses["stylesheet"]="unknown";
   }
   unset($tmp);
  }
  else
  {
   $_jses["os"]="unknown";
   $_jses["browser"]="useragent not set";
   $_jses["stylesheet"]="unknown";
  }
 }
?>
