<?

 /*****************************************************************************
 * Filename: include/modules/configEmail.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."jas.php");

 class Module_configEmail extends Module
 {
  function init(&$data)
  {
   global $_config;

   Module::init($data);

   if(!isset($_config["modules"][$this->data->module]["field"]["mimeVersion"]))
   {
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["decimals"]=1;
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["decimalseparator"]=".";
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["thousandsseparator"]="";
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["formdecimals"]=1;
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["formdecimalseparator"]=$this->data->format["form"]["decimalseparator"];
    $_config["modules"][$this->data->module]["field"]["mimeVersion"]["formthousandsseparator"]=$this->data->format["form"]["thousandsseparator"];
   }

   $this->data->title=$this->data->l->t("Email configuration");

   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all
   $this->data->addField("faketitle", "text", "show", "title;hidden", 0, false, $this->data->title, "Title");

   $this->data->addField("mimeVersion", "float", "all", false, 0, false, 1.0, "Mime version", "Set to 0 for no mime version");
   $this->data->addField("charSet", "text", "all", false, 5, 15, "ISO-8859-1", "Character set");
   $this->data->addField("userAgent", "text", "all", false, 0, 25, "JAS/".JAS::version(), "User agent", "Leave empty for no user agent header");
   $this->data->addField("defaultDomain", "domain", "all", false, 4, 50, "example.com", "Default domain");

   $this->data->addField("wordwrap", "nr", "all", false, 0, false, 80, "Word wrap", "Set to 0 for no word wrap");

   $this->data->addField("server", "domain", "all", false, 0, 50, "", "Server", "Leave empty for normal PHP mailer");
   $this->data->addField("port", "nr", "all", false, 1, false, 25, "Port");
   $this->data->addField("username", "title", "all", false, 0, 25, "", "Username", "Leave empty for no authentication");
   $this->data->addField("password", "password", "all", "nocrypt", 0, 25, "", "Password", "Leave empty for no authentication");

   $this->data->group("Alternative server", "server", "port", "username", "password", "verifypassword");
  }

  function editPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("password", "", $c);

   return true;
  }

  function viewPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("faketitle", $this->data->title, $c);

   return true;
  }

 }

?>
