<?

 /*****************************************************************************
 * Filename: include/modules/configRepositories.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Module_configRepositories extends Module
 {
  function init(&$data)
  {
   global $_path;

   Module::init($data);

   $this->data->title=$this->data->l->t("Repositories configuration");

   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all

   $this->data->addField("name", "title", "all", "title", 5, 50, "JAS repository", "Name");

   $this->data->addField("url", "url", "all", "", 5, 255, "http://jas.junerules.com/", "Repository URL");
   $this->data->addField("xmliurl", "url", "show", "", 5, 255, "xmli://jas.junerules.com/", "XMLi URL");
   $this->data->addField("content", "multilist", "all", "", 1, 65535, Array("Repositories", "Plugins"), "Content");
   $this->data->listOptions("content", "Repositories", "Plugins");

   $this->data->addUnique("name", "name");
  }

  function viewPreGet()
  {
   if(!$this->data->check("use", "show", "url")&&$this->data->check("use", "show", "xmliurl")) //get url if xmliurl is show field
    $this->data->field["url"]["use"].=";show";

   return true;
  }

  function viewPostGet()
  {
   if($this->data->check("use", "show", "xmliurl"))
   {
    for($c=0;$c<$this->data->vmax;$c++)
    {
     if(preg_match("!^([a-z0-9]+)://(.+)$!i", $this->data->getValue("url", $c), $m))
     {
      $url="xmli://".$m[2];

      if($m[1]=="https")
       $url.="#secure";

      $this->data->setValue("xmliurl", $url, $c);
     }
    }
   }

   return true;
  }
 }

?>
