<?

 /*****************************************************************************
 * Filename: include/modules/history.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Module_history extends Module
 {
  function init(&$data)
  {
   global $_jses, $_config;

   Module::init($data);

   $_config["modules"]["history"]["field"]["time"]=Array(
    "timezone" => "UTC",
    "formtimezone" => "UTC",
    "dateformat" => "d-m-Y",
    "timeformat" => "H:i:s",
    "datetimeformat" => "H:i:s d-m-Y",
    "formdateformat" => "d-m-Y",
    "formtimeformat" => "H:i:s",
    "formdatetimeformat" => "H:i:s d-m-Y",
   );

   $this->data->format["sql"]["timezone"]="UTC";

   $this->data->title=$this->data->l->t("Page history");

   $this->data->addField("uri", "text", "all", false, 0, 65536, false, "Request URI");
   $this->data->addField("time", "datetime", "all", false, false, false, false, "Request time");

   $this->data->addField("method", "enum", "all", "title", 1, 5, false, "Request method");
   $this->data->enumOptions("method", "", "GET", "POST");

   $this->data->addField("project", "project", "all", false, 1, 25, $_jses["project"], "Project");
   $this->data->addField("cms", "boolean", "all", false, false, false, false, "CMS page");

   $this->data->defaultFields();
   $this->data->sortOrder("time-");
  }

  function postInit()
  {
   //set default values
   if(isset($_SERVER["REQUEST_TIME"]))
   {
    $difference=$_SERVER["REQUEST_TIME"]-time();

    if($difference>0) //later
     $this->data->field["time"]["defaultvalue"]="now+".$difference;
    else if($difference<0) //before
     $this->data->field["time"]["defaultvalue"]="now".$difference;
    else
     $this->data->field["time"]["defaultvalue"]="now";
   }
   else
    $this->data->field["time"]["defaultvalue"]="now";

   $this->data->field["uri"]["defaultvalue"]=(isset($_SERVER["REQUEST_URI"])?$_SERVER["REQUEST_URI"]:"");
   $this->data->field["method"]["defaultvalue"]=(isset($_SERVER["REQUEST_METHOD"])?$_SERVER["REQUEST_METHOD"]:"");

   if($this->data->check("valuetype", "none", "uri"))
    $this->data->setDefaultValue("uri");

   if($this->data->check("valuetype", "none", "time"))
    $this->data->setDefaultValue("time");

   if($this->data->check("valuetype", "none", "method"))
    $this->data->setDefaultValue("method");

   return true;
  }
 }
?>
