<?

 /*****************************************************************************
 * Filename: include/modules/log.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Module_log extends Module
 {
  function init(&$data)
  {
   Module::init($data);

   global $_config;

   $this->data->title=$this->data->l->t("Log");
   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden");
   $this->data->addField("title", "text", "all", "title", 0, 255, false, "Error");
   $this->data->addField("text", "text", "all", false, 0, 65536, false, "Extra information");
   $this->data->addField("level", "alphabetic", "all", false, 1, 10, false, "Level");
   $this->data->addField("request", "text", "all", false, 0, 65536, false, "Request variables");

   $this->data->addField("usernr", "nr", "sql;show", "", 1, false, "usernr", "User");
   $this->data->addReference("usernr", $_config["usermodule"], "nr", "*:1");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 512); //add rights for all

   $this->data->addField("ip", "ip", "all", false, false, false, "ip", "IP address");

   $this->data->addField("date", "date", "all", false, false, false, "now", "Date");
   $this->data->addField("time", "time", "all", false, false, false, "now", "Time");

   $this->data->sortOrder("date-", "time-");
  }
 }
?>
