<?

 /*****************************************************************************
 * Filename: include/modules/pluginInfo.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Module_pluginInfo extends Module
 {
  function init(&$data)
  {
   global $_path;

   Module::init($data);

   $this->data->title=$this->data->l->t("Plugin information");

   $this->data->addField("plugin", "plugin", "all", "", 1, 25, false, "Plugin name");
   $this->data->addField("title", "text", "all", "title", 1, 25, false, "Title");
   $this->data->addField("description", "text", "all", "", 0, 65535, false, "Description");
   $this->data->addField("version", "version", "all", "singleField;title", 0, false, false, "Version");
   $this->data->addField("status", "enum", "all", false, false, false, "", "Status");
   $this->data->enumOptions("status", "", "alpha", "beta", "stable", "deprecated");
   $this->data->addField("status2", "text", "show", false, false, false, "", "Status");

   $this->data->addField("license", "text", "all", false, 0, 25, "", "License");
   $this->data->listOptions("license", Array(
    " " => "",
    "APACHE" => "Apache License",
    "BSD" => "BSD License",
    "CCL" => "Creative Common License",
    "GPL" => "GNU General Public License",
    "LGPL" => "GNU Lesser General Public License",
    "MIT" => "MIT License",
    "MOZILLA" => "Mozilla Public License",
    "  " => "",
    "PUBLIC" => "Public domain",
    "PROPRIETARY" => "Proprietary license",
    "   " => "",
    "JAS" => "Part of JAS project",
    "" => "None")
   );
   $this->data->addMutilation("license", "trim");

   $this->data->addField("author", "text", "all", false, 0, 25, false, "Author");
   $this->data->addField("email", "email", "all", false, 0, 25, false, "Email address");

   $this->data->addField("main_file", "text", "all", false, 0, 25, false, "Main file");
   $this->data->addField("main_class", "text", "all", false, 0, 25, false, "Main class");
   $this->data->addField("main_function", "text", "all", false, 0, 25, false, "Main function");
   $this->data->addField("main_output", "text", "all", false, 0, 25, false, "Output function");

   $this->data->addField("backend_file", "text", "all", false, 0, 25, false, "Backend file");
   $this->data->addField("backend_class", "text", "all", false, 0, 25, false, "Backend class");
   $this->data->addField("backend_function", "text", "all", false, 0, 25, false, "Backend function");
   $this->data->addField("backend_output", "text", "all", false, 0, 25, false, "Backend output function");

   $this->data->addField("setup_file", "text", "all", false, 0, 25, false, "Setup file");
   $this->data->addField("setup_class", "text", "all", false, 0, 25, false, "Setup class");
   $this->data->addField("setup_init", "text", "all", false, 0, 25, false, "Setup init function");
   $this->data->addField("setup_preSetup", "text", "all", false, 0, 25, false, "Pre setup function");
   $this->data->addField("setup_postSetup", "text", "all", false, 0, 25, false, "Post setup function");
   $this->data->addField("setup_preDeSetup", "text", "all", false, 0, 25, false, "Pre deSetup function");
   $this->data->addField("setup_postDeSetup", "text", "all", false, 0, 25, false, "Post deSetup function");

   $this->data->group("Author", "author", "email");
   $this->data->group("Main", "main_file", "main_class", "main_function", "main_output");
   $this->data->group("Backend", "backend_file", "backend_class", "backend_function", "backend_output");
   $this->data->group("Setup", "setup_file", "setup_class", "setup_init", "setup_preSetup", "setup_postSetup", "setup_preDeSetup", "setup_postDeSetup");

   $this->data->addUnique("plugin", "plugin");
  }


  function viewPreGet()
  {
   if(!$this->data->check("use", "show", "status")&&$this->data->check("use", "show", "status2")) //get status if status2 is show field
    $this->data->field["status"]["use"].=";show";

   return true;
  }

  function viewPostGet()
  {
   if($this->data->check("use", "show", "status2"))
   {
    $statusConvert=Array("alpha" => "&alpha;", "beta" => "&beta;", "stable" => "&gamma;", "deprecated" => "&delta;");

    for($c=0;$c<$this->data->vmax;$c++)
     if(isset($statusConvert[$this->data->getValue("status", $c)]))
      $this->data->setValue("status2", $statusConvert[$this->data->getValue("status", $c)], $c);
   }

   return true;
  }
 }
?>
