<?

 /*****************************************************************************
 * Filename: include/modules/sync.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Module_sync extends Module
 {
  function init(&$data)
  {
   global $_config;
   Module::init($data);

   $this->data->title=$this->data->l->t("Synchronization");

   $this->data->syncOptions=Array("source" => Array(), "target" => Array());
   $this->data->syncOptions["source"]["not in source"]=Array("add", "nothing");
   $this->data->syncOptions["source"]["not in target"]=Array("delete", "nothing");
   $this->data->syncOptions["source"]["target is newer"]=Array("edit", "nothing");
   $this->data->syncOptions["source"]["source is newer"]=Array("nothing", "edit");
   $this->data->syncOptions["source"]["unchanged"]=Array("nothing");
   $this->data->syncOptions["source"]["changed"]=Array("edit", "nothing");
   $this->data->syncOptions["target"]["not in source"]=Array("delete", "nothing");
   $this->data->syncOptions["target"]["not in target"]=Array("add", "nothing");
   $this->data->syncOptions["target"]["target is newer"]=Array("nothing", "edit");
   $this->data->syncOptions["target"]["source is newer"]=Array("edit", "nothing");
   $this->data->syncOptions["target"]["unchanged"]=Array("nothing");
   $this->data->syncOptions["target"]["changed"]=Array("edit", "nothing");

   $this->data->addField("sync_action", "enum", "show;form", false);
   $this->data->enumOptions("sync_action", "add", "edit", "delete", "nothing");
   $this->data->addField("sync_status", "enum", "show");
   $this->data->enumOptions("sync_status", "not in target", "not in source", "target is newer", "source is newer", "unchanged", "changed");

   $this->data->defaultFields();
   $this->data->sortOrder("sync_status");

   $this->data->addActions("sync");
   $this->data->addExtra("sync", "both", "source", "target");
  }
 }
?>
