<?

 /*****************************************************************************
 * Filename: include/modules/syncSettings.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."http.php");

 class Module_syncSettings extends Module
 {
  function init(&$data)
  {
   global $_config, $_jses;
   Module::init($data);

   $this->data->title=$this->data->l->t("Synchronization settings");

   $this->data->addField("server", "title", "all", "title", 1, 255, false, "Server");
   $this->data->addField("url", "url", "all", false, 5, 255, false, "URL");

   $this->data->addField("method", "enum", "all", false, 6, 6, "Source", "Method");
   $this->data->enumOptions("method", "Source", "Target");

   $this->data->addField("compress", "enum", "all", false, 3, 10, "None", "Compression");

   $this->data->enumOptions("compress", "None");

   foreach(DataHTTP::compression() as $method)
    $this->data->listOptions["compress"][]=$method;

   $this->data->addField("showUnchanged", "boolean", "all", false, false, false, false, "Show unchanged items");

   $this->data->addField("default_add", "boolean", "all", false, false, false, true, "Insert new items by default");
   $this->data->addField("default_edit", "boolean", "all", false, false, false, true, "Update items by default");
   $this->data->addField("default_delete", "boolean", "all", false, false, false, false, "Delete by default");

   $this->data->addField("project", "project", "all", false, 1, 255, $_jses["project"], "Project");
   $this->data->addField("modules", "modules", "all", "exists", 1, 65536, false, "Modules");

   $this->data->addField("username", "title", "all", false, 0, 255, false, "Username");

   $this->data->addField("owner", "nr", "sql;show", "owner;userReference;default", 1, false, "usernr", "By");
   $this->data->addReference("owner", $_config["usermodule"], "nr", "*:1");

   $this->data->addField("updated", "datetime", "sql;show", "forceUpdate;default", 0, false, "now", "Last update");
   
   $this->data->addField("nr", "nr", "sql;form", "identifier;hidden;global;default");
   $this->data->addField("userrights", "rights", "sql", "allusers", 0, false, 768); //view+add rights for all

   $this->data->sortOrder("server");
  }
 }
?>
