<?

 /*****************************************************************************
 * Filename: include/plugins/content_management/content_management.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."history.php");

 class content_management extends BasePlugin
 {
  function main()
  {
   $this->output="";

   if($this->plugin->config)
   {
    //set page as CMS in history
    $hs=new History();
    $hs->cms();
    
    if(!($m=request("m")))
     $m=$this->plugin->config["module"];

    if(!($a=request("a")))
     $a=$this->plugin->config["action"];

    if(!($e=request("e")))
     $e=$this->plugin->config["extra"];

    if(!in_array($m, $this->plugin->config["modules"]))
    {
     $this->e->add("Module: \"".strip_tags($m)."\" not allowed", "error");
     return false;
    }

    if(!in_array($a, $this->plugin->config["actions"]))
    {
     $this->e->add("Action: \"".strip_tags($a)."\" not allowed", "error");
     return false;
    }

    if(!in_array($e, $this->plugin->config["extras"]))
    {
     $this->e->add("Extra option: \"".strip_tags($e)."\" not allowed", "error");
     return false;
    }

    $d=Data::cache($m, $a, $e);

    if($this->config["useConfig"]) //use alternative config
     $cms=new CMS($this->config);
    else //use global CMS config
     $cms=new CMS();

    $cms->setData($d);

    $this->output="<div class=\"cms\">\n".$cms->form()."\n</div>\n";
    return true;
   }

   return false;
  }

  function output()
  {
   if($this->e->any())
    return false;

   return $this->output;
  }
 }
?>
