<?

 /*****************************************************************************
 * Filename: include/plugins/pager/modules/templates.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class pager_templates extends Module
 {
  function init(&$data)
  {
   parent::init($data);

   $this->data->title=$this->data->l->t("Page templates");

   $this->data->defaultFields();

   $this->data->addField("name", "text", "all", "title", 1, 50, "Default", "Template name");
   $this->data->addField("title", "text", "all", "", 0, 50, false, "Website title");

   $this->data->addField("template", "localfile", "all", "recursive", 1, 255, "index.html", "Template");

   $this->data->addField("doctype", "enum", "all", false, false, false, "XHTML 1.1 - Strict", "Doctype");
   $this->data->enumOptions("doctype", "XHTML 1.1 - Strict", "XHTML 1.0 - Strict", "XHTML 1.0 - Transitional", "XHTML 1.0 - Frameset", "HTML 4.01 - Strict", "HTML 4.01 - Transitional", "HTML 4.01 - Quirks mode", "HTML 4.01 - Frameset");

   $this->data->addField("jasscript", "boolean", "all", false, false, false, true, "Add JAS JavaScript");
   $this->data->addField("javascriptglobal", "localfiles", "all", "recursive", false, false, false, "Global JavaScript");
   $this->data->addField("javascript", "localfiles", "all", "recursive", false, false, false, "JavaScript");
   $this->data->addField("stylesheet", "localfiles", "all", "recursive", false, false, false, "Style sheets");

   $this->data->addField("fixscript", "boolean", "all", false, false, false, true, "Fix JavaScript paths");
   $this->data->addField("fixstyle", "boolean", "all", false, false, false, true, "Fix Style sheet paths");
   $this->data->addField("fiximages", "boolean", "all", false, false, false, true, "Fix image paths");

   $this->data->group("JavaScript", "javascriptglobal", "javascript", "jasscript");
   $this->data->group("Style sheet", "stylesheet");
   $this->data->group("Path fixing", "fixscript", "fixstyle", "fiximages");
   $this->data->sortOrder("title");
  }

  function postInit()
  {
   global $_path;

   $this->data->setFileDir("template", $_path["project"]["templates"]);
   $this->data->setFileExtensions("template", "html", "htm");
   $this->data->setFileDir("javascriptglobal", $_path["script"]);
   $this->data->setFileExtensions("javascriptglobal", "js");
   $this->data->setFileDir("javascript", $_path["project"]["script"]);
   $this->data->setFileExtensions("javascript", "js");
   $this->data->setFileDir("stylesheet", $_path["project"]["style"]);
   $this->data->setFileExtensions("stylesheet", "css");

   if(!$this->simpleFields())
    return false;

   return true;
  }

  function simpleFields()
  {
   global $_pager_simple;

   //hide "advanced" fields in simple mode
   if($_pager_simple)
   {
    $this->data->field["catnr"]["properties"].=";hidden";

    $this->data->field["doctype"]["properties"].=";hidden";
    $this->data->field["jasscript"]["properties"].=";hidden";

    $this->data->field["fixscript"]["properties"].=";hidden";
    $this->data->field["fixstyle"]["properties"].=";hidden";
    $this->data->field["fiximages"]["properties"].=";hidden";
   }
   else
   {
    $this->data->resetField("catnr");

    $this->data->resetField("doctype");
    $this->data->resetField("jasscript");

    $this->data->resetField("fixscript");
    $this->data->resetField("fixstyle");
    $this->data->resetField("fiximages");
   }

   return true;
  }
 }
?>
