<?

 /*****************************************************************************
 * Filename: include/plugins/pager/setup.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."data.php");

 class pager_setup extends BasePluginSetup
 {
  function init()
  {
   global $_path, $_jasPath;

   //frontend files
   $this->mkdir($_path["project"]["templates"]);
   $this->mkdir($_path["project"]["style"]);
   $this->mkdir($_path["project"]["images"]);
   $this->mkdir($_path["project"]["script"]);

   $this->file("setup/index.php", $_path["project"]["root"]);

   $this->file("setup/index.html", $_path["project"]["templates"]);
   $this->file("setup/error.html", $_path["project"]["templates"]);
   $this->file("setup/navigation.html", $_path["project"]["templates"]);

   $this->file("setup/default.css", $_path["project"]["style"]);
   $this->file("setup/print.css", $_path["project"]["style"]);
   $this->file("setup/favicon.ico", $_path["project"]["images"]);
   $this->file("setup/logo.png", $_path["project"]["images"]);

   //backend file
   $this->mkdir($_jasPath["project"]["style"]);

   if(!file_exists($_jasPath["project"]["style"]."pager.css")) //could be setup by another project
    $this->file("setup/pager.css", $_jasPath["project"]["style"]);

   $this->modules();

   return true;
  }

  function postSetup()
  {
   //get pager root
   $d=Data::cache("categories", "view", "all");
   $d->clearValues();

   $d->setShowFields("nr");
   $d->setValue("module", "pager_pluginConfigs");
   $d->setOperator("module", "like");

   if(!$d->get()||!$d->next()) //pager root category doesn't exist
   {
    //get root category
    $d->setAction("tree");
    $d->setExtra("down");
    $d->clearValues();

    $d->setShowFields("nr");

    $d->setValue("show_from", 0);
    $d->setValue("show_total", 1);

    $d->setValue("catnr", 0);
    $d->setValue("treedepth", 0);

    if(!$d->get()||!$d->next())
    {
     $this->e->add("Root category not found");
     $this->e->add($d->e);
     return false;
    }

    $rootcatnr=$d->v["nr"];

    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();

    $d->setValue("name", "Website");
    $d->setValue("text", "Website root category");

    $d->setValue("catnr", $rootcatnr);
    $d->setValue("module", Array("pluginConfigs", "pager_pluginConfigs", "pager_categories"));
    $d->setValue("moduleLock", false);

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }

    $this->e->add("Pager root added successfully", "note");
    $pagerrootcatnr=$d->getValue("nr");
   }
   else
    $pagerrootcatnr=$d->v["nr"];


   //get pager home
   $d=Data::cache("pager_categories", "view", "all");
   $d->setShowFields("nr");
   $d->clearValues();

   $d->setValue("show_from", 0);
   $d->setValue("show_total", 1);

   $d->setValue("catnr", $pagerrootcatnr);
   $d->setValue("module", "pager_content");
   $d->setOperator("module", "like");

   if(!$d->get()||!$d->next()) //pager home category doesn't exist
   {
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();

    $d->setValue("templatenr", 1);
    $d->setValue("name", "Home");
    $d->setValue("text", "Home page");

    $d->setValue("catnr", $pagerrootcatnr);
    $d->setValue("module", Array("pluginConfigs", "pager_content"));
    $d->setValue("moduleLock", false);

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }

    $this->e->add("Pager home page added successfully", "note");
   }

   return true;
  }

 }
?>
