<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/modules/pluginConfigs.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class unit_testing_pluginConfigs extends Module
 {
  function init(&$data)
  {
   parent::init($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title=$this->data->l->t("Unit testing plugin configuration");

   $this->data->addField("display", "enum", "all", false, false, false, "", "Display");
   $this->data->enumOptions("display", "list_units", "list_tests");

   $this->data->addField("template", "localfile", "all", "recursive", false, false, "", "Alternative template");

   $this->data->group("Unit testing", "display", "template");
  }

  function postInit()
  {
   global $_path;

   $this->data->setFileDir("template", $_path["project"]["templates"]);
   $this->data->setFileExtensions("template", "html", "htm");

   return $this->customizeFields("init");
  }
  function addPostGet(){return $this->customizeFields(false);}
  function editPostGet(){return $this->customizeFields(false);}

  function customizeFields($alt)
  {
   if($this->data->vmax)
    $max=$this->data->vmax;
   else
    $max=1;

   for($c=0;$c<$max;$c++)
    $this->data->setValue("plugin", "unit_testing", $c);

   return true;
  }

 }
?>
