<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/captcha.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."captcha.php");

 class UT_Captcha extends UT_Classes
 {
  function Constructor()
  {
   $object=new Captcha();

   if(!is_object($object)||get_class($object)!="Captcha")
   {
    $this->e->add("Constructor doesn't return a Captcha object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Object: \"e\" isn't an Error object", "error");
    return UT_FAILED;
   }

   //config merge
   $object=new Captcha(Array("length" => 7, "backgroundTransparent" => false, "backgroundColor" => "255,0,0"));

   if($object->length!=7)
   {
    $this->e->add("Captcha length should be \"7\"");
    return UT_FAILED;
   }

   if($object->config["backgroundTransparent"])
   {
    $this->e->add("Captcha background shouldn't be transparent");
    return UT_FAILED;
   }

   if($object->colors["background"]!=Array(255,0,0))
   {
    $this->e->add("Captcha background color should be \"255,0,0\"");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }

?>
