<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/data.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."data.php");

 class UT_Data extends UT_Classes
 {
  var $_module="unit_testing_testmodule";
  var $_db="default";
  var $_aggregationSetup=false;
  var $_jasPath=false;
  var $_utEnabled=false;
  var $_aggregationValues=Array(
    Array(
     "nr" => 1,
     "catnr" => 1,
     "name" => "A",
     "updated" => "01:00:00 01-01-2001",
    ),
    Array(
     "nr" => 2,
     "catnr" => 1,
     "name" => "B",
     "updated" => "02:00:00 01-01-2001",
    ),
    Array(
     "nr" => 3,
     "catnr" => 1,
     "name" => "C",
     "updated" => "03:00:00 01-01-2001",
    ),
    Array(
     "nr" => 4,
     "catnr" => 1,
     "name" => "D",
     "updated" => "04:00:00 01-01-2001",
    ),
    Array(
     "nr" => 5,
     "catnr" => 2,
     "name" => "A",
     "updated" => "01:00:00 01-01-2002",
    ),
    Array(
     "nr" => 6,
     "catnr" => 2,
     "name" => "B",
     "updated" => "01:30:00 01-01-2002",
    ),
    Array(
     "nr" => 7,
     "catnr" => 2,
     "name" => "C",
     "updated" => "02:00:00 01-01-2002",
    ),
    Array(
     "nr" => 8,
     "catnr" => 2,
     "name" => "D",
     "updated" => "02:30:00 01-01-2002",
    ),
  );


  function _setupAggregation()
  {
   global $_path, $_jses, $_jseskey, $_config;

   if($this->_aggregationSetup) //already setup
    return true; //done

   $this->_jasPath=$_path;

   //create unit_testing_testmodule table
   $d=Data::cache($this->_module, "database", "create", Array("db" => $this->_db, "skipCheckTables" => true));
   $d->clearValues();
   $d->e->clear();

   require($this->_jasPath["project"]["include"]."switch.php"); //project

   if(get_class($d->storageObject())!="MySQLStorage") //must by MySQL
   {
    $this->e->add("Setup aggregation failed, MySQL Storage project needed", "error");
    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return false;
   }

   //create table
   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   if(!$d->tableExists()&&!$d->submit()) //create table
   {
    $_config["usernr"]=$usernr;

    $this->e->add($d->e);
    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return false;
   }
   $_config["usernr"]=$usernr;


   $d->clearValues();
   $d->setAction("delete");
   $d->setExtra("all");

   if(!$d->get()) //get ids
   {
    $this->e->add($d->e);
    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return false;
   }

   //delete entries
   if($d->vmax)
   {
    $usernr=$_config["usernr"]; //sudo
    $_config["usernr"]=$_config["rootnr"];
    if(!$d->submit()) //create table
    {
     $_config["usernr"]=$usernr;

     $this->e->add($d->e);
     require($this->_jasPath["project"]["include"]."switch.php"); //jas
     return false;
    }
    $_config["usernr"]=$usernr;
   }

   $d->clearValues();
   $d->setAction("add");
   $d->setExtra("item");

   $d->field["nr"]["properties"]=str_replace("identifier;", "", $d->field["nr"]["properties"]); //remove nr forced identifier
   $d->field["updated"]["properties"]=str_replace("forceUpdated;", "", $d->field["updated"]["properties"]); //remove updated forced updated
   $d->field["catnr"]["properties"]=str_replace("rightsReference;", "", $d->field["catnr"]["properties"]); //remove rights reference
   unset($d->reference["catnr"]); //remove catnr reference

   foreach($this->_aggregationValues as $c => $values)
    foreach($values as $key => $value)
     $d->setValue($key, $value, $c);

   //submit values
   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   if(!$d->submit()) //create table
   {
    $_config["usernr"]=$usernr;

    d($d->e->show());
    $this->e->add($d->e);
    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return false;
   }
   $_config["usernr"]=$usernr;


   $this->_aggregationSetup=true;
   return true;
  }

  function _desetupAggregation()
  {
   global $_path, $_jses, $_jseskey, $_config;

   if(!$this->_aggregationSetup) //not setup
    return true; //done

   //clear values
   $d=Data::cache($this->_module, "delete", "all", Array("db" => $this->_db));
   $d->clearValues();
   $d->e->clear();

   if($d->get())
   {
    //submit values
    $usernr=$_config["usernr"]; //sudo
    $_config["usernr"]=$_config["rootnr"];
    $d->submit(); //create table
    $_config["usernr"]=$usernr;
   }

   //desetup done
   $this->_aggregationSetup=false;

   require($this->_jasPath["project"]["include"]."switch.php"); //jas
   return true;
  }




  function Constructor()
  {
   $object=new Data();

   if(!is_object($object)||get_class($object)!="Data")
   {
    $this->e->add("Constructor doesn't return a Data object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Object: \"e\" isn't an Error object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Cache()
  {
   $object=Data::cache();

   if(!is_object($object)||get_class($object)!="Data")
   {
    $this->e->add("Cache constructor doesn't return a Data object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Object: \"e\" isn't an Error object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Serialize()
  {
   global $_path, $_jses, $_jseskey, $_config;

   $this->_jasPath=$_path;
   require($this->_jasPath["project"]["include"]."switch.php"); //project

   $d=Data::cache();
   $d->initReferenceData("owner");
   $d->initReferenceData("catnr");

   $object=unserialize(serialize($d));

   //fix d
   $d->moduleObject=unserialize($d->moduleObject);
   $d->moduleObject->data=&$d;


   if(!is_object($object)||get_class($object)!="Data")
   {
    $this->e->add("Deserialized object isn't a Data object", "error");

    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Deserialized object \"e\" isn't an Error object", "error");

    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return UT_FAILED;
   }

   if(!$object->moduleObject||get_class($d->moduleObject)!=get_class($object->moduleObject))
   {
    $this->e->add("Deserialized module object doesn't match", "error");

    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return UT_FAILED;
   }

   if(!$object->reference["catnr"]["data"]||get_class($d->reference["catnr"]["data"])!=get_class($object->reference["catnr"]["data"]))
   {
    $this->e->add("Deserialized object reference \"catnr\" doesn't match", "error");

    require($this->_jasPath["project"]["include"]."switch.php"); //jas
    return UT_FAILED;
   }

   require($this->_jasPath["project"]["include"]."switch.php"); //jas
   return UT_OK;
  }

  function ViewItem()
  {
   global $_config;

   $d=Data::cache("categories", "view", "item", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View item should check identifier field for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", 1);

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", "asdasdasd");

   if($d->get())
   {
    $this->e->add("View item should fail identifier field check for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", 1);
   $d->setValue("catnr", "asdasdasd");

   if(!$d->get())
   {
    $this->e->add("View item not should fail category field check for module: \"".$d->module."\"", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d=Data::cache($_config["usermodule"], "view", "item", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View item should check identifier field for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", 1);

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d=Data::cache("empty", "view", "item", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View item should fail identifier field check for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function ViewList()
  {
   global $_config;

   $d=Data::cache("categories", "view", "list", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View list should check category field for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("catnr", 1);

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("catnr", "asdasdasd");

   if($d->get())
   {
    $this->e->add("View list should fail categories field check for module: \"".$d->module."\"", "error");
    //return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", "asdasdasd");
   $d->setValue("catnr", 1);

   if(!$d->get())
   {
    $this->e->add("View list not should fail identifier field check for module: \"".$d->module."\"", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d=Data::cache($_config["usermodule"], "view", "list", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View list should check category field for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->setValue("catnr", 1);

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d=Data::cache("empty", "view", "list", Array("db" => "stub"));
   $d->clearValues();

   if($d->get())
   {
    $this->e->add("View list should fail category field check for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function ViewAll()
  {
   global $_config;

   $d=Data::cache("categories", "view", "all", Array("db" => "stub"));
   $d->clearValues();

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", 1);

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", "asdasdasd");

   if($d->get())
   {
    $this->e->add("View all should fail identifier field check for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d->e->clear();
   $d->clearValues();
   $d->setValue("nr", "asdasdasd");
   $d->setValue("catnr", 1);

   if($d->get())
   {
    $this->e->add("View all should fail identifier field check for module: \"".$d->module."\"", "error");
    return UT_FAILED;
   }

   $d=Data::cache($_config["usermodule"], "view", "all", Array("db" => "stub"));
   $d->clearValues();

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d=Data::cache("empty", "view", "all", Array("db" => "stub"));
   $d->clearValues();

   if(!$d->get())
   {
    $this->e->add($d->e);
    return UT_FAILED;
   }

   return UT_OK;
  }


  function StorageObject()
  {
   //stub storage
   $d=Data::cache("categories", "view", "item", Array("db" => "stub"));
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="stubStorage")
   {
    $this->e->add("Object: \"storage\" isn't an stubStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //xml storage
   $d=Data::cache("categories", "view", "item", Array("db" => "xml"));
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //mime storage
   $d=Data::cache("categories", "view", "item", Array("db" => "mime"));
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //custom storage
   $d=Data::cache("categories", "view", "item", Array("db" => "xml://test/db.xml"));
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //custom storage
   $d=Data::cache("categories", "view", "item", Array("db" => "lala://host/db"));
   $storage=$d->storageObject();

   if($storage)
   {
    $this->e->add("Object: \"storage\" should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function StorageSwitch()
  {
   //stub storage
   $d=Data::cache("categories", "view", "item", Array("db" => "stub"));
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="stubStorage")
   {
    $this->e->add("Object: \"storage\" isn't an stubStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //xml storage
   $d->storageSwitch("xml");
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //mime storage
   $d->storageSwitch("mime");
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //custom storage
   $d->storageSwitch("xml://test/db.xml");
   $storage=$d->storageObject();

   if(!is_object($storage)||get_class($storage)!="xmlStorage")
   {
    $this->e->add("Object: \"storage\" isn't an xmlStorage object", "error");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   //custom storage
   $d->storageSwitch("lala://host/db");
   $storage=$d->storageObject();

   if($storage)
   {
    $this->e->add("Object: \"storage\" should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Aggregation()
  {
   if(!$this->_setupAggregation())
   {
    $this->_desetupAggregation();
    return UT_SKIPPED;
   }

   $d=Data::cache($this->_module, "view", "all", Array("db" => $this->_db));
   $d->setShowFields("nr", "catnr", "name", "updated");
   $d->sortOrder("nr+");
   $d->clearValues();

   $d->field["nr"]["properties"]=str_replace("identifier;", "", $d->field["nr"]["properties"]); //remove nr forced identifier
   $d->field["catnr"]["properties"]=str_replace("rightsReference;", "", $d->field["catnr"]["properties"]); //remove rights reference
   unset($d->reference["catnr"]); //remove catnr reference



//aggregate by nr
   $d->setValue("aggregation_field", "nr");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=1||
    $d->field["nr"]["value"][1]!=2||
    $d->field["nr"]["value"][2]!=3||
    $d->field["nr"]["value"][3]!=4||
    $d->field["nr"]["value"][4]!=5||
    $d->field["nr"]["value"][5]!=6||
    $d->field["nr"]["value"][6]!=7||
    $d->field["nr"]["value"][7]!=8
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by nr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=1||
    $d->field["catnr"]["value"][2]!=1||
    $d->field["catnr"]["value"][3]!=1||
    $d->field["catnr"]["value"][4]!=2||
    $d->field["catnr"]["value"][5]!=2||
    $d->field["catnr"]["value"][6]!=2||
    $d->field["catnr"]["value"][7]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by nr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["name"]["value"][0]!="A"||
    $d->field["name"]["value"][1]!="B"||
    $d->field["name"]["value"][2]!="C"||
    $d->field["name"]["value"][3]!="D"||
    $d->field["name"]["value"][4]!="A"||
    $d->field["name"]["value"][5]!="B"||
    $d->field["name"]["value"][6]!="C"||
    $d->field["name"]["value"][7]!="D"
   )
   {
    $this->e->add("Name field doesn't match expected output", "error", "aggregate by nr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["updated"]["value"][0]!="01:00:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="02:00:00 01-01-2001"||
    $d->field["updated"]["value"][2]!="03:00:00 01-01-2001"||
    $d->field["updated"]["value"][3]!="04:00:00 01-01-2001"||
    $d->field["updated"]["value"][4]!="01:00:00 01-01-2002"||
    $d->field["updated"]["value"][5]!="01:30:00 01-01-2002"||
    $d->field["updated"]["value"][6]!="02:00:00 01-01-2002"||
    $d->field["updated"]["value"][7]!="02:30:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by nr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by name
   $d->setValue("aggregation_field", "name");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["name"]["value"][0]!="A"||
    $d->field["name"]["value"][1]!="B"||
    $d->field["name"]["value"][2]!="C"||
    $d->field["name"]["value"][3]!="D"
   )
   {
    $this->e->add("Name field doesn't match expected output", "error", "aggregate by name");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by name rows
   $d->setValue("aggregation_field", "name");
   if(!$d->get(false, true))
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["show_count"]["value"][0]!=4
   )
   {
    $this->e->add("Show count field doesn't match expected output", "error", "aggregate by name rows");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by catnr average
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "average");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=2.5||
    $d->field["nr"]["value"][1]!=6.5
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by catnr average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by catnr average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="02:30:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="01:45:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by catnr average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by catnr sum
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "sum");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=10||
    $d->field["nr"]["value"][1]!=26
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by catnr sum");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by catnr sum");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by catnr count
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "count");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=4||
    $d->field["nr"]["value"][1]!=4
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by catnr count");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by catnr count");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by catnr min
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "min");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=1||
    $d->field["nr"]["value"][1]!=5
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by catnr min");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by catnr min");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="01:00:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="01:00:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by catnr min");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by catnr max
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "max");
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=4||
    $d->field["nr"]["value"][1]!=8
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by catnr max");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by catnr max");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="04:00:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="02:30:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by catnr max");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by name average
   $d->setValue("aggregation_field", "name");
   $d->setValue("aggregation_type", "average");
   $d->setValue("aggregation_interval", 0);
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=3||
    $d->field["nr"]["value"][1]!=4||
    $d->field["nr"]["value"][2]!=5||
    $d->field["nr"]["value"][3]!=6
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by name average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1.5||
    $d->field["catnr"]["value"][1]!=1.5||
    $d->field["catnr"]["value"][2]!=1.5||
    $d->field["catnr"]["value"][3]!=1.5
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by name average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="14:00:00 02-07-2001"||
    $d->field["updated"]["value"][1]!="14:45:00 02-07-2001"||
    $d->field["updated"]["value"][2]!="15:30:00 02-07-2001"||
    $d->field["updated"]["value"][3]!="16:15:00 02-07-2001"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by name average");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by updated sum interval after
   $d->setValue("aggregation_field", "updated");
   $d->setValue("aggregation_type", "sum");
   $d->setValue("aggregation_method", "after");
   $d->setValue("aggregation_interval", 60*60*4); //4 hours
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=10||
    $d->field["nr"]["value"][1]!=26
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by updated sum interval after");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=4||
    $d->field["catnr"]["value"][1]!=8
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by updated sum interval after");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="01:00:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="01:00:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by updated sum interval after");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by nr average interval around
   $d->setValue("aggregation_field", "nr");
   $d->setValue("aggregation_type", "average");
   $d->setValue("aggregation_method", "around");
   $d->setValue("aggregation_interval", 2);
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=2||
    $d->field["nr"]["value"][1]!=4||
    $d->field["nr"]["value"][2]!=6||
    $d->field["nr"]["value"][3]!=8
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by nr average interval around");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=1||
    $d->field["catnr"]["value"][1]!=1||
    $d->field["catnr"]["value"][2]!=2||
    $d->field["catnr"]["value"][3]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by nr average interval around");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="01:30:00 01-01-2001"||
    $d->field["updated"]["value"][1]!="03:30:00 01-01-2001"||
    $d->field["updated"]["value"][2]!="01:15:00 01-01-2002"||
    $d->field["updated"]["value"][3]!="02:15:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by nr average interval around");
    $this->_desetupAggregation();
    return UT_FAILED;
   }



//aggregate by nr average interval around where catnr
   $d->setValue("aggregation_field", "nr");
   $d->setValue("aggregation_type", "average");
   $d->setValue("aggregation_method", "around");
   $d->setValue("aggregation_interval", 2);
   $d->setValue("catnr", 2);
   if(!$d->get())
   {
    $this->e->add($d->e);
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["nr"]["value"][0]!=6||
    $d->field["nr"]["value"][1]!=8
   )
   {
    $this->e->add("NR field doesn't match expected output", "error", "aggregate by nr average interval around where catnr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }

   if(
    $d->field["catnr"]["value"][0]!=2||
    $d->field["catnr"]["value"][1]!=2
   )
   {
    $this->e->add("CatNR field doesn't match expected output", "error", "aggregate by nr average interval around where catnr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   if(
    $d->field["updated"]["value"][0]!="01:15:00 01-01-2002"||
    $d->field["updated"]["value"][1]!="02:15:00 01-01-2002"
   )
   {
    $this->e->add("Updated field doesn't match expected output", "error", "aggregate by nr average interval around where catnr");
    $this->_desetupAggregation();
    return UT_FAILED;
   }


   $this->_desetupAggregation();
   return UT_OK;
  }


  function GetReferenceDepth()
  {
   $d=new Data("categories");

//no show fields
   $d->setShowFields();
   if($d->getReferenceDepth()!==false)
   {
    $this->e->add("Data reference depth should be: false", "error", "no show fields");
    return UT_FAILED;
   }

//normal fields
   $d->setShowFields("nr", "name");
   if($d->getReferenceDepth()!==0)
   {
    $this->e->add("Data reference depth should be: 0", "error", "normal fields");
    return UT_FAILED;
   }

//*:1 no fields
   $d->setShowFields("catnr");
   if($d->getReferenceDepth()!==0)
   {
    $this->e->add("Data reference depth should be: 0", "error", "*:1 no fields");
    return UT_FAILED;
   }

//*:1 normal fields
   $d2=$d->getReferenceData("catnr");
   $d2->setShowFields("name");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "*:1 normal fields");
    return UT_FAILED;
   }

//*:1 *:1 no fields
   $d2->setShowFields("catnr");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "*:1 *:1 no fields");
    return UT_FAILED;
   }

   $d3=$d2->getReferenceData("catnr");
   $d3->setShowFields("name");
   if($d->getReferenceDepth()!==2)
   {
    $this->e->add("Data reference depth should be: 2", "error", "*:1 *:1 normal fields");
    return UT_FAILED;
   }


//1:*
   $d=new Data("categories");
   $d->addReference("below", "categories", "catnr", "1:*", "nr"); //add fake reference

//1:* no fields
   $d->setShowFields("below");
   if($d->getReferenceDepth()!==0)
   {
    $this->e->add("Data reference depth should be: 0", "error", "1:* no fields");
    return UT_FAILED;
   }

//1:* normal fields
   $d2=$d->getReferenceData("below");
   $d2->addReference("below", "categories", "catnr", "1:*", "nr"); //add fake reference
   $d2->setShowFields("name");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "1:* normal fields");
    return UT_FAILED;
   }

//1:* 1:* no fields
   $d2->setShowFields("below");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "1:* 1:* no fields");
    return UT_FAILED;
   }

//1:* 1:* normal fields
   $d3=$d2->getReferenceData("below");
   $d3->addReference("below", "categories", "catnr", "1:*", "nr"); //add fake reference
   $d3->setShowFields("name");
   if($d->getReferenceDepth()!==2)
   {
    $this->e->add("Data reference depth should be: 2", "error", "1:* 1:* normal fields");
    return UT_FAILED;
   }


//*:*
   $d=new Data("categories");
   $d->addReference("cross", "categories", "nr", "*:*", "nr"); //add fake reference


//*:* no fields
   $d->setShowFields("cross");
   if($d->getReferenceDepth()!==0)
   {
    $this->e->add("Data reference depth should be: 0", "error", "*:* no fields");
    return UT_FAILED;
   }

//*:* normal fields
   $d2=$d->getReferenceData("cross");
   $d2=$d2->getReferenceData("categories_2");
   $d2->setShowFields("name");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "*:* normal fields");
    return UT_FAILED;
   }

//*:* *:* no fields
   $d2=$d->getReferenceData("cross");
   $d2=$d2->getReferenceData("categories_2");
   $d2->addReference("cross", "categories", "nr", "*:*", "nr"); //add fake reference
   $d2->setShowFields("cross");
   if($d->getReferenceDepth()!==1)
   {
    $this->e->add("Data reference depth should be: 1", "error", "*:* *:* no fields");
    return UT_FAILED;
   }


//*:* *:* normal fields
   $d3=$d2->getReferenceData("cross");
   $d3=$d3->getReferenceData("categories_2");
   $d3->setShowFields("name");
   if($d->getReferenceDepth()!==2)
   {
    $this->e->add("Data reference depth should be: 2", "error", "*:* *:* normal fields");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function SetDataFormat()
  {
   $d=new Data(false, false, false, Array("format" => "html"));

//check constructor
   if($d->dataformat!="html")
   {
    $this->e->add("Data format not set to: \"html\"");
    return UT_FAILED;
   }

//normal set (sql)
   if(!$d->setDataFormat("sql"))
   {
    $this->e->add("Unable to set data format to: \"sql\"");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   if($d->dataformat!="sql")
   {
    $this->e->add("Data format not set to: \"sql\"");
    return UT_FAILED;
   }

//normal set (html)
   if(!$d->setDataFormat("html"))
   {
    $this->e->add("Unable to set data format to: \"html\"");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   if($d->dataformat!="html")
   {
    $this->e->add("Data format not set to: \"html\"");
    return UT_FAILED;
   }

//illegal format
   if($d->setDataFormat("asdasd"))
   {
    $this->e->add("Shouldn't be able to set data format to: \"asdasd\"");
    return UT_FAILED;
   }

   if($d->dataformat!="html")
   {
    $this->e->add("Data format should still be set to: \"html\"");
    return UT_FAILED;
   }

//references
   $d=new Data("categories", false, false, Array("format" => "html"));
   $d2=$d->getReferenceData("catnr");
   $d3=$d->getReferenceData("catnr");
   $d4=$d->getReferenceData("owner");

//check constructor
   if($d->dataformat!="html"||$d2->dataformat!="html"||$d3->dataformat!="html"||$d4->dataformat!="html")
   {
    $this->e->add("Data format not set to: \"html\"");
    return UT_FAILED;
   }

//normal set (sql)
   if(!$d->setDataFormat("form"))
   {
    $this->e->add("Unable to set data format to: \"form\"");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   if($d->dataformat!="form"||$d2->dataformat!="form"||$d3->dataformat!="form"||$d4->dataformat!="form")
   {
    $this->e->add("Data format not set to: \"form\"");
    return UT_FAILED;
   }

//illegal format
   if($d->setDataFormat("asdasd"))
   {
    $this->e->add("Shouldn't be able to set data format to: \"asdasd\"");
    return UT_FAILED;
   }

   if($d->dataformat!="form"||$d2->dataformat!="form"||$d3->dataformat!="form"||$d4->dataformat!="form")
   {
    $this->e->add("Data format should still be set to: \"form\"");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function SetUseFields()
  {
   $d=new Data("users");

//no fields
   $showFields=Array();
   if(!$d->setUseFields("show"))
   {
    $this->e->add("Unable to set use fields", "error", "no fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields");
     return UT_FAILED;
    }
   }

//exiting (single) field
   $formFields=Array("password");
   if(!$d->setUseFields("form", "password"))
   {
    $this->e->add("Unable to set use fields", "error", "exiting (single) field");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing (single) field");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing (single) field");
     return UT_FAILED;
    }
   }


//exiting fields
   $formFields=Array("nr", "catnr");
   if(!$d->setUseFields("form", $formFields))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing field");
     return UT_FAILED;
    }
   }


//reference fields
   $showFields=Array("usersAdditionalGroups");
   if(!$d->setUseFields("show", $showFields))
   {
    $this->e->add("Unable to set use fields", "error", "existing fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr";
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields");
     return UT_FAILED;
    }
   }


//no fields add mode
   $showFields=Array("nr", "catnr");
   if(!$d->setUseFields("show", $showFields))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }
   if(!$d->setUseFields("show", false, true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields add mode");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "no fields add mode");
     return UT_FAILED;
    }
   }


//exiting fields add mode
   $formFields=Array("nr", "catnr");
   if(!$d->setUseFields("form", $formFields))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }
   $formFields[]="password";
   if(!$d->setUseFields("form", "password", true))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields add mode");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields add mode");
     return UT_FAILED;
    }
   }


//reference fields add mode
   $showFields=Array("catnr");
   if(!$d->setUseFields("show", $showFields))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }
   $showFields[]="usersAdditionalGroups";
   if(!$d->setUseFields("show", "usersAdditionalGroups", true))
   {
    $this->e->add("Unable to set use fields", "error", "reference fields add mode");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields add mode");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields add mode");
     return UT_FAILED;
    }
   }


//no fields recursive
   $d2=$d->getReferenceData("catnr");

   $showFields=Array();
   if(!$d->setUseFields("show", false, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "no fields recursive");
     return UT_FAILED;
    }
   }

   foreach($d2->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d2->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d2->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "no fields recursive");
     return UT_FAILED;
    }
   }


//exiting fields recursive
   $formFields=Array("nr", "catnr");
   if(!$d->setUseFields("form", $formFields, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields recursive");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields recursive");
     return UT_FAILED;
    }
   }

   foreach($d2->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d2->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields recursive");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d2->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields recursive");
     return UT_FAILED;
    }
   }


//reference fields recursive
   $d2=$d->getReferenceData("usersAdditionalGroups");
   $oldGroupsShowFields=$d2->check("use", "show");
   $d3=$d2->getReferenceData("categories");

   $showFields=Array("usersAdditionalGroups", "catnr");
   if(!$d->setUseFields("show", $showFields, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "reference fields recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields recursive");
     return UT_FAILED;
    }
   }

   if(array_diff($oldGroupsShowFields, $d2->check("use", "show"))||array_diff($d2->check("use", "show"), $oldGroupsShowFields))
   {
    $this->e->add("UsersAdditionalGroups show fields shouldn't have changed", "error", "reference fields recursive"); //usersAdditionalGroups is a *:* table which shouldn't be touched
    return UT_FAILED;
   }

   foreach($d3->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d3->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields recursive");
     return UT_FAILED;
    }
   }

   foreach(Array("catnr") as $field)
   {
    if(!$d3->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields recursive");
     return UT_FAILED;
    }
   }


//no fields add recursive
   $showFields=Array("nr", "catnr");
   if(!$d->setUseFields("show", $showFields, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d2=$d->getReferenceData("catnr");

   if(!$d->setUseFields("show", false, true , true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "no fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($d2->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d2->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d2->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "no fields add recursive");
     return UT_FAILED;
    }
   }


//exiting fields add recursive
   $formFields=Array("nr");
   if(!$d->setUseFields("form", $formFields, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $formFields[]="catnr";
   if(!$d->setUseFields("form", "catnr", true, true))
   {
    $this->e->add("Unable to set use fields", "error", "exiting fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($d2->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d2->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d2->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields add recursive");
     return UT_FAILED;
    }
   }


//reference fields add recursive
   $showFields=Array("catnr");
   if(!$d->setUseFields("show", $showFields, false, true))
   {
    $this->e->add("Unable to set use fields", "error", "no fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $d2=$d->getReferenceData("usersAdditionalGroups");
   $oldGroupsShowFields=$d2->check("use", "show");
   $d3=$d2->getReferenceData("categories");

   $showFields[]="usersAdditionalGroups";
   if(!$d->setUseFields("show", "usersAdditionalGroups", true, true))
   {
    $this->e->add("Unable to set use fields", "error", "reference fields add recursive");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields add recursive");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields add recursive");
     return UT_FAILED;
    }
   }

   if(array_diff($oldGroupsShowFields, $d2->check("use", "show"))||array_diff($d2->check("use", "show"), $oldGroupsShowFields))
   {
    $this->e->add("UsersAdditionalGroups show fields shouldn't have changed", "error", "reference fields add recursive"); //usersAdditionalGroups is a *:* table which shouldn't be touched
    return UT_FAILED;
   }

   foreach($d3->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d3->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields add recursive");
     return UT_FAILED;
    }
   }

   foreach(Array("catnr") as $field)
   {
    if(!$d3->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields add recursive");
     return UT_FAILED;
    }
   }


//illegal use argument: asdasd
   if($d->setUseFields("asdasd"))
   {
    $this->e->add("Shouldn't be able to set use fields", "error", "illegal use argument: asdasd");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function SetShowFields()
  {
   $d=new Data("users");

//no fields
   $showFields=Array();
   if(!$d->setShowFields())
   {
    $this->e->add("Unable to set show fields", "error", "no fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "no fields");
     return UT_FAILED;
    }
   }


//exiting fields
   $showFields=Array("nr", "catnr");
   if(!$d->setShowFields("nr", "catnr"))
   {
    $this->e->add("Unable to set show fields", "error", "exiting fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "existing fields");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "existing fields");
     return UT_FAILED;
    }
   }


//exiting fields array
   $showFields=Array("nr", "catnr");
   if(!$d->setShowFields($showFields))
   {
    $this->e->add("Unable to set show fields", "error", "exiting fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "existing fields array");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "existing fields array");
     return UT_FAILED;
    }
   }


//reference fields
   $showFields=Array("usersAdditionalGroups");
   if(!$d->setShowFields("usersAdditionalGroups"))
   {
    $this->e->add("Unable to set show fields", "error", "existing fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields");
     return UT_FAILED;
    }
   }


//reference fields array
   $showFields=Array("usersAdditionalGroups");
   if(!$d->setShowFields($showFields))
   {
    $this->e->add("Unable to set show fields", "error", "reference fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $showFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "show") as $field)
   {
    if(!in_array($field, $showFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a show field", "error", "reference fields array");
     return UT_FAILED;
    }
   }

   foreach($showFields as $field)
   {
    if(!$d->check("use", "show", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a show field", "error", "reference fields array");
     return UT_FAILED;
    }
   }


   return UT_OK;
  }


  function SetFormFields()
  {
   $d=new Data("users");

//no fields
   $formFields=Array();
   if(!$d->setFormFields())
   {
    $this->e->add("Unable to set form fields", "error", "no fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "no fields");
     return UT_FAILED;
    }
   }


//exiting fields
   $formFields=Array("nr", "catnr");
   if(!$d->setFormFields("nr", "catnr"))
   {
    $this->e->add("Unable to set form fields", "error", "exiting fields");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields");
     return UT_FAILED;
    }
   }


//exiting fields array
   $formFields=Array("nr", "catnr");
   if(!$d->setFormFields($formFields))
   {
    $this->e->add("Unable to set form fields", "error", "exiting fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "existing fields array");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "existing fields array");
     return UT_FAILED;
    }
   }


//reference fields
   $formFields=Array("usersAdditionalGroups");
   if(!$d->setFormFields("usersAdditionalGroups"))
   {
    $this->e->add("Unable to set form fields", "error", "existing fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $formFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "reference fields");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "reference fields");
     return UT_FAILED;
    }
   }


//reference fields array
   $formFields=Array("usersAdditionalGroups");
   if(!$d->setFormFields($formFields))
   {
    $this->e->add("Unable to set form fields", "error", "reference fields array");
    $this->e->add($d->e);
    return UT_FAILED;
   }

   $formFields[]="nr"; //nr should be forced by usersAdditionalGroups (from) reference
   foreach($d->check("use", "form") as $field)
   {
    if(!in_array($field, $formFields)&&!$d->check("properties", "control", $field))
    {
     $this->e->add("Field: \"".$field."\" shouldn't be set as a form field", "error", "reference fields array");
     return UT_FAILED;
    }
   }

   foreach($formFields as $field)
   {
    if(!$d->check("use", "form", $field))
    {
     $this->e->add("Field: \"".$field."\" should be set as a form field", "error", "reference fields");
     return UT_FAILED;
    }
   }


   return UT_OK;
  }

 }


 class UT_BaseData extends UT_Data
 {
  function Constructor()
  {
   global $_path;

   $data=new BaseData();

   if(!is_object($data)||get_class($data)!="BaseData")
   {
    $this->e->add("Constructor doesn't return a BaseData object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


 }

?>
