<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/functions.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 class UT_Functions extends UT_Core
 {
  function FunctionsFileExists()
  {
   global $_path;

   if(!file_exists($_path["include"]."functions.php"))
    return UT_FAILED;

   require_once($_path["include"]."functions.php");
   return UT_OK;
  }

  function FunctionsExist()
  {
   global $_path;
   $functions=Array(
    "d",
    "modules",
    "plugins",
    "projects",
    "request",
    "array_type",
   );

   $status=UT_OK;

   foreach($functions as $function) 
   {
    if(!function_exists($function))
    {
     $this->e->add("Function: \"".$function."\" doesn't exist");
     $status=UT_FAILED;
    }
   }

   return $status;
  }

  function Debug()
  {
   global $_path;

   if(!function_exists("d"))
    return UT_FAILED;

   ob_start();
   d("test");
   $output=ob_get_clean();

   if($output!="<pre>string(4) \"test\"\n</pre>")
    return UT_FAILED;

   return UT_OK;
  }
 }


 class UT_Modules_function extends UT_Functions
 {
  function isArray()
  {
   if(!is_array(modules()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   if(sizeof(modules("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   if(!in_array("categories", modules("system")))
    return UT_FAILED;

   return UT_OK;
  }
 }


 class UT_Plugins_function extends UT_Functions
 {
  function isArray()
  {
   if(!is_array(plugins()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   if(sizeof(plugins("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   if(!in_array("unit_testing", plugins("system")))
    return UT_FAILED;

   return UT_OK;
  }
 }

 class UT_Projects_function extends UT_Functions
 {
  function isArray()
  {
   if(!is_array(projects()))
    return UT_FAILED;

   return UT_OK;
  }
  function Exists()
  {
   if(!in_array("jas", projects()))
    return UT_FAILED;

   return UT_OK;
  }
 }

 class UT_Array_Type_function extends UT_Functions
 {
  function Indexed()
  {
   $array=Array();
   $array[]="123";
   $array[]="546";
   $array[]="asdsa";
   $array[]="dfg";

   if(array_type($array)!=="indexed")
    return UT_FAILED;

   return UT_OK;
  }
  function Associative()
  {
   $array=Array();
   $array["asd"]="123";
   $array["354"]="546";
   $array["h"]="asdsa";
   $array["123"]="dfg";

   if(array_type($array)!=="associative")
    return UT_FAILED;

   return UT_OK;
  }
  function Data()
  {
   $array=new Data("categories");

   if(array_type($array)!=="data")
    return UT_FAILED;

   return UT_OK;
  }
  function Unknown()
  {
   $array=new Plugin("unit_testing");

   if(array_type($array)!=="unknown")
    return UT_FAILED;

   return UT_OK;
  }

 }
?>
