<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/jas.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."jas.php");

 class JAS_EXTENDS_TEST extends JAS
 {
 }

 class UT_JAS extends UT_Classes
 {
  function Constructor()
  {
   $object=new JAS();

   if(!is_object($object)||get_class($object)!="JAS")
   {
    $this->e->add("Constructor doesn't return a JAS object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function IsInitialized()
  {
   $j=new JAS();

   if(!$j->isInitialized())
   {
    $this->e->add("\$j should be initialized", "error");
    return UT_FAILED;
   }

   if(JAS::isInitialized())
   {
    $this->e->add("JAS:: shouldn't be initialized", "error");
    return UT_FAILED;
   }

   $j=new JAS_EXTENDS_TEST();
   if(!$j->isInitialized())
   {
    $this->e->add("\$j should be initialized", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Version()
  {
   global $_path;

   $j=new JAS();

   if(!($changelog=file_get_contents($_path["include"]."changelog.txt")))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   if(!preg_match("/\nVersion ([0-9\.]+)[ \-]*([A-Z0-9]+)?/i", $changelog, $version))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $development=(preg_match("/\nDevelopment version/", $changelog));

   if(!preg_match("/\n\t(\d{4}-\d{2}-\d{2})/", $changelog, $updated))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $updated=DT::dateConvert($updated[1], "Y-m-d");
   $modified=filemtime($_path["include"]."changelog.txt");

   //version
   if(!$j->version())
   {
    $this->e->add("JAS version failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version()!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   if(!$j->version("version"))
   {
    $this->e->add("JAS version failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("version")!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   //status
   if($j->version("status")===false)
   {
    $this->e->add("JAS version status failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("status")!=(isset($version[2])?$version[2]:""))
   {
    $this->e->add("JAS version status doesn't match", "error");
    return UT_FAILED;
   }

   //development
   if($j->version("development")!=$development)
   {
    $this->e->add("JAS version development doesn't match", "error");
    return UT_FAILED;
   }

   //updated
   if(!$j->version("updated"))
   {
    $this->e->add("JAS version updated failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("updated")!=$updated)
   {
    $this->e->add("JAS version updated doesn't match", "error");
    return UT_FAILED;
   }

   //modified
   if(!$j->version("modified"))
   {
    $this->e->add("JAS version modified failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("modified")!=$modified)
   {
    $this->e->add("JAS version modified doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }

?>
