<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/mutilate.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/dt.php");
 require_once($_path["include"]."mutilate.php");

 class Mutilate_EXTENDS_TEST extends Mutilate
 {
 }

 class UT_Mutilate extends UT_DT
 {
  function Constructor()
  {
   $object=new Mutilate();

   if(!is_object($object)||get_class($object)!="Mutilate")
   {
    $this->e->add("Constructor doesn't return a Mutilate object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Object: \"e\" isn't an Error object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function IsInitialized()
  {
   $m=new Mutilate();

   if(!$m->isInitialized())
   {
    $this->e->add("\$m should be initialized", "error");
    return UT_FAILED;
   }

   if(Mutilate::isInitialized())
   {
    $this->e->add("Mutilate:: shouldn't be initialized", "error");
    return UT_FAILED;
   }

   $m=New Mutilate_EXTENDS_TEST();
   if(!$m->isInitialized())
   {
    $this->e->add("\$m should be initialized", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HumanReadableNumber()
  {
   $m=new Mutilate();

   if($m->humanReadableNumber(123)!="123")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if($m->humanReadableNumber(1234)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234, 0)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234, 1)!="1.2K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableNumber(1234567)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567, 0)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567, 1)!="1.2M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableNumber(1234567890)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890, 0)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890, 1)!="1.2G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableNumber(1234567890123)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890123, 0)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890123, 1)!="1.2T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableNumber(1234567890123456)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890123456, 0)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableNumber(1234567890123456, 1)!="1.2P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableNumberArray()
  {
   $m=new Mutilate();

   if(!($values=$m->humanReadableNumber(Array(123, 1234))))
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(123, 1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="123")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(123, 1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(123, 1234) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->humanReadableNumber(Array(1234567, 1234567890, Array(123, 1234, 1234567)), 2, ",")))
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1,23M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="1,23G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="123,00")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="1,23K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="1,23M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HumanReadableFileSize()
  {
   $m=new Mutilate();

   if($m->humanReadableFileSize(123)!="123B")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if($m->humanReadableFileSize(1234)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234, 0)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234, 1)!="1.2KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableFileSize(1234567)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567, 0)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567, 1)!="1.2MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableFileSize(1234567890)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890, 0)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890, 1)!="1.2GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableFileSize(1234567890123)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890123, 0)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890123, 1)!="1.2TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if($m->humanReadableFileSize(1234567890123456)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890123456, 0)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if($m->humanReadableFileSize(1234567890123456, 1)!="1.2PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableFileSizeArray()
  {
   $m=new Mutilate();

   if(!($values=$m->humanReadableFileSize(Array(123, 1234))))
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(123, 1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="123B")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(123, 1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(123, 1234) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->humanReadableFileSize(Array(1234567, 1234567890, Array(123, 1234, 1234567)), 2, ",")))
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1,23MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="1,23GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="123,00B")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="1,23KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="1,23MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function LeadingZeros()
  {
   $m=new Mutilate();

   if($m->leadingZeros(12, 5)!="00012")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if($m->leadingZeros(12, 2)!="12")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if($m->leadingZeros("1235", 3)!="1235")
   {
    $this->e->add("Mutilation leadingZeros with argument \"1235\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function LeadingZerosArray()
  {
   $m=new Mutilate();

   if(!($values=$m->leadingZeros(Array(123, 1234), 5)))
   {
    $this->e->add("Mutilation leadingZeros with argument Array(123, 1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="00123")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(123, 1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="01234")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(123, 1234) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->leadingZeros(Array(1234567, 1234567890, Array(123, 1234, 1234567)), 10)))
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="0001234567")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="1234567890")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="0000000123")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="0000001234")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="0001234567")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234567, 1234567890, Array(123, 1234, 1234567)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Strip()
  {
   $m=new Mutilate();

   if($m->strip("Abcde", 10)!="Abcde")
   {
    $this->e->add("Mutilation strip with argument \"Abcde\" failed", "error");
    return UT_FAILED;
   }

   if($m->strip("Abcdefghij", 10)!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghij\" failed", "error");
    return UT_FAILED;
   }

   if($m->strip("Abcdefghijk", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijk\" failed", "error");
    return UT_FAILED;
   }

   if($m->strip("Abcdefghijklmnopqrstuvwxyz", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if($m->strip("Abcdefghijklmnopqrstuvwxyz", 10, "")!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if($m->strip("Abcdefghijklmnopqrstuvwxyz", 10, ">")!="Abcdefghi>")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripArray()
  {
   $m=new Mutilate();

   if(!($values=$m->strip(Array("Abcdefghijklmnopqrstuvwxyz", "AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz"))))
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcdefghijklmnopqrstuvwxyz")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="AbcdefghijklmnopqrstuvwxyzAbc...")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->strip(Array("Abcdefg", "Abcdefghij", Array("Abc", "Abcd", "Abcdefg")), 6, ">")))
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde>")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcde>")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="Abc")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="Abcd")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="Abcde>")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }



  function Replace()
  {
   $m=new Mutilate();

   if($m->replace("Abcde fghij", "/Abcde/", "EDCBA")!="EDCBA fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }

   if($m->replace("Abcde fghij", "/Abcde/")!=" fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ReplaceArray()
  {
   $m=new Mutilate();

   if(!($values=$m->replace(Array("Abcdefghijklmnopqrstuvwxyz", "AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz"), "/Abcde/")))
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="fghijklmnopqrstuvwxyz")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="fghijklmnopqrstuvwxyzfghijklmnopqrstuvwxyz")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijklmnopqrstuvwxyz, AbcdefghijklmnopqrstuvwxyzAbcdefghijklmnopqrstuvwxyz) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->replace(Array("Abcdefg", "Abcdefghij", Array("Abc", "Abcd", "Abcdefg")), "/Abc/", "ABC")))
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCdefg")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="ABCdefghij")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="ABC")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="ABCd")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="ABCdefg")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefg, Abcdefghij, Array(Abc, Abcd, Abcdefg)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function ChangeCase()
  {
   $m=new Mutilate();

   if($m->changeCase("Abcde fghij", "lower")!="abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"lower\" failed", "error");
    return UT_FAILED;
   }

   if($m->changeCase("Abcde fghij", "upper")!="ABCDE FGHIJ")
   {
    $this->e->add("Mutilation changeCase with argument \"upper\" failed", "error");
    return UT_FAILED;
   }

   if($m->changeCase("Abcde Fghij", "first")!="Abcde fghij") 
   {
    $this->e->add("Mutilation changeCase with argument \"first\" failed", "error");
    return UT_FAILED;
   }

   if($m->changeCase("abcde fghij", "words")!="Abcde Fghij") 
   {
    $this->e->add("Mutilation changeCase with argument \"words\" failed", "error");
    return UT_FAILED;
   }

   if($m->changeCase("Abcde fghij", "fail")!="Abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"fail\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ChangeCaseArray()
  {
   $m=new Mutilate();

   if(!($values=$m->changeCase(Array("Abcde fghij", "Abcde fghij klmno"), "upper")))
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcde fghij, Abcde fghij klmno) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCDE FGHIJ")
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcde fghij, Abcde fghij klmno) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="ABCDE FGHIJ KLMNO")
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcde fghij, Abcde fghij klmno) argument 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=$m->changeCase(Array("abcde", "abcde fghij", Array("abcde", "abcde fghij", "abcde fghij klmno")), "words")))
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde")
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcde Fghij")
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="Abcde")
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="Abcde Fghij")
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="Abcde Fghij Klmno")
   {
    $this->e->add("Mutilation changeCase with argument Array(abcde, abcde fghij, Array(abcde, abcde fghij, abcde fghij klmno)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function StripTags()
  {
   $m=new Mutilate();

   if($m->stripTags("Abcde<br/><a href=\"\">fghij</a>")!="Abcdefghij")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripTagsArray()
  {
   $m=new Mutilate();

   if(!($values=$m->stripTags(Array("Abcde<br/>", "Abcde<br/>fghij", Array("Abcde<br/>", "Abcde<br/>fghij", "<div>Abcde<br/>fghij klmno</div>")))))
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcdefghij")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="Abcde")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="Abcdefghij")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="Abcdefghij klmno")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLEncode()
  {
   $m=new Mutilate();

   if($m->htmlEncode("Abcde<br/><a href=\"\">fghij</a>")!="Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")
   {
    $this->e->add("Mutilation htmlEncode with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLEncodeArray()
  {
   $m=new Mutilate();

   if(!($values=$m->htmlEncode(Array("Abcde<br/>", "Abcde<br/>fghij", Array("Abcde<br/>", "Abcde<br/>fghij", "<div>Abcde<br/>fghij klmno</div>")))))
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde&lt;br/&gt;")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcde&lt;br/&gt;fghij")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="Abcde&lt;br/&gt;")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="Abcde&lt;br/&gt;fghij")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="&lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>, Abcde<br/>fghij), Array(Abcde<br/>, Abcde<br/>fghij, <div>Abcde<br/>fghij klmno</div>)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLDecode()
  {
   $m=new Mutilate();

   if($m->htmlDecode("Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")!="Abcde<br/><a href=\"\">fghij</a>")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLDecodeArray()
  {
   $m=new Mutilate();

   if(!($values=$m->htmlDecode(Array("Abcde&lt;br/&gt;", "Abcde&lt;br/&gt;fghij", Array("Abcde&lt;br/&gt;", "Abcde&lt;br/&gt;fghij", "&lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;")))))
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde<br/>")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcde<br/>fghij")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="Abcde<br/>")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="Abcde<br/>fghij")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="<div>Abcde<br/>fghij klmno</div>")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij), Array(Abcde&lt;br/&gt;, Abcde&lt;br/&gt;fghij, &lt;div&gt;Abcde&lt;br/&gt;fghij klmno&lt;/div&gt;)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function URLEncode()
  {
   $m=new Mutilate();

   if($m->urlEncode("http://domain.com/")!="http://domain.com/")
   {
    $this->e->add("Mutilation urlEncode with argument \"http://domain.com/\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlEncode("http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")!="http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlEncode("?asd=234&arg[2]=356&asdasd=?asd&lalal")!="?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlEncode("asd=234&arg[2]=356&asdasd=?asd&lalal")!="asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function URLEncodeArray()
  {
   $m=new Mutilate();

   if(!($values=$m->urlEncode(Array("http://domain.com/", "http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal", Array("http://domain.com/", "http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal", "?asd=234&arg[2]=356&asdasd=?asd&lalal")))))
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="http://domain.com/")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="http://domain.com/")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, Array(http://domain.com/, http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal, ?asd=234&arg[2]=356&asdasd=?asd&lalal)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function URLDecode()
  {
   $m=new Mutilate();

   if($m->urlDecode("http://domain.com/")!="http://domain.com/")
   {
    $this->e->add("Mutilation urlDecode with argument \"http://domain.com/\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlDecode("http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlDecode("?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if($m->urlDecode("asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function URLDecodeArray()
  {
   $m=new Mutilate();

   if(!($values=$m->urlDecode(Array("http://domain.com/", "http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal", Array("http://domain.com/", "http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal", "%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")))))
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="http://domain.com/")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="http://domain.com/")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, Array(http://domain.com/, http://domain.com/%3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal, %3Fasd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function ScrambleEmail()
  {
   $m=new Mutilate();

   if($m->scrambleEmail("you@me.come")!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument \"you@me.come\" failed", "error");
    return UT_FAILED;
   }
   if($m->scrambleEmail("n.surname@sub.domain.com")!="n[dot]surname(at)sub[dot]domain[dot]com")
   {
    $this->e->add("Mutilation scrambleEmail with argument \"n.surname@sub.domain.com\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function ScrambleEmailArray()
  {
   $m=new Mutilate();

   if(!($values=$m->scrambleEmail(Array("you@me.come", "y@m.c", Array("you@me.come", "y@m.c", "email@domain.com")))))
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="y(at)m[dot]c")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="y(at)m[dot]c")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="email(at)domain[dot]com")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come, y@m.c, Array(you@me.come, y@m.c, email@domain.com)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function UnScrambleEmail()
  {
   $m=new Mutilate();

   if($m->unscrambleEmail("you(at)me[dot]come")!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument \"you(at)me[dot]come\" failed", "error");
    return UT_FAILED;
   }

   if($m->unscrambleEmail("n[dot]surname(at)sub[dot]domain[dot]com")!="n.surname@sub.domain.com")
   {
    $this->e->add("Mutilation unscrambleEmail with argument \"n[dot]surname(at)sub[dot]domain[dot]com\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function UnScrambleEmailArray()
  {
   $m=new Mutilate();

   if(!($values=$m->unscrambleEmail(Array("you(at)me[dot]come", "y(at)m[dot]c", Array("you(at)me[dot]come", "y(at)m[dot]c", "email(at)domain[dot]com")))))
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) argument 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="y@m.c")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) argument 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) argument 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="y@m.c")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) argument 3, 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][2]!="email@domain.com")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come, y(at)m[dot]c, Array(you(at)me[dot]come, y(at)m[dot]c, email(at)domain[dot]com)) argument 3, 3 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

?>
