<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/mutilate.sro.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/mutilate.php");
 require_once($_path["include"]."mutilate.php");

 class UT_Mutilate_Scope_Resolution_Operator extends UT_Mutilate
 {
  function IsInitialized()
  {
   if(Mutilate::isInitialized())
   {
    $this->e->add("Mutilate:: shouldn't be initialized", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HumanReadableNumber()
  {
   if(Mutilate::humanReadableNumber(123)!="123")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::humanReadableNumber(1234)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234, 0)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234, 1)!="1.2K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumber(1234567)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567, 0)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567, 1)!="1.2M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumber(1234567890)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890, 0)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890, 1)!="1.2G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumber(1234567890123)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890123, 0)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890123, 1)!="1.2T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumber(1234567890123456)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890123456, 0)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumber(1234567890123456, 1)!="1.2P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableNumberArray()
  {
   if(!($values=Mutilate::humanReadableNumber(Array(1234))))
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HumanReadableFileSize()
  {
   if(Mutilate::humanReadableFileSize(123)!="123B")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::humanReadableFileSize(1234)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234, 0)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234, 1)!="1.2KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSize(1234567)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567, 0)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567, 1)!="1.2MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSize(1234567890)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890, 0)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890, 1)!="1.2GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSize(1234567890123)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890123, 0)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890123, 1)!="1.2TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSize(1234567890123456)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890123456, 0)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSize(1234567890123456, 1)!="1.2PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableFileSizeArray()
  {
   if(!($values=Mutilate::humanReadableFileSize(Array(1234))))
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function LeadingZeros()
  {
   if(Mutilate::leadingZeros(12, 5)!="00012")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::leadingZeros(12, 2)!="12")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::leadingZeros("1235", 3)!="1235")
   {
    $this->e->add("Mutilation leadingZeros with argument \"1235\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function LeadingZerosArray()
  {
   if(!($values=Mutilate::leadingZeros(Array(1234), 5)))
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="01234")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }



  function Strip()
  {
   if(Mutilate::strip("Abcde", 10)!="Abcde")
   {
    $this->e->add("Mutilation strip with argument \"Abcde\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::strip("Abcdefghij", 10)!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghij\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::strip("Abcdefghijk", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijk\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::strip("Abcdefghijklmnopqrstuvwxyz", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::strip("Abcdefghijklmnopqrstuvwxyz", 10, "")!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::strip("Abcdefghijklmnopqrstuvwxyz", 10, ">")!="Abcdefghi>")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripArray()
  {
   if(!($values=Mutilate::strip(Array("Abcdefghijk"), 6, ">")))
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde>")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Replace()
  {
   if(Mutilate::replace("Abcde fghij", "/Abcde/", "EDCBA")!="EDCBA fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::replace("Abcde fghij", "/Abcde/")!=" fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ReplaceArray()
  {
   if(!($values=Mutilate::replace(Array("Abcdefghijk"), "/Abc/", "ABC")))
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCdefghijk")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }



  function ChangeCase()
  {
   if(Mutilate::changeCase("Abcde fghij", "lower")!="abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"lower\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCase("Abcde fghij", "upper")!="ABCDE FGHIJ")
   {
    $this->e->add("Mutilation changeCase with argument \"upper\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCase("Abcde Fghij", "first")!="Abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"first\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCase("abcde fghij", "words")!="Abcde Fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"words\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCase("Abcde fghij", "fail")!="Abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"fail\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ChangeCaseArray()
  {
   if(!($values=Mutilate::changeCase(Array("Abcdefghijk"), "upper")))
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCDEFGHIJK")
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function StripTags()
  {
   if(Mutilate::stripTags("Abcde<br/><a href=\"\">fghij</a>")!="Abcdefghij")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripTagsArray()
  {
   if(!($values=Mutilate::stripTags(Array("Abcde<br/>fghijk"))))
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcdefghijk")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLEncode()
  {
   if(Mutilate::htmlEncode("Abcde<br/><a href=\"\">fghij</a>")!="Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLEncodeArray()
  {
   if(!($values=Mutilate::htmlEncode(Array("Abcde<br/>fghijk"))))
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde&lt;br/&gt;fghijk")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLDecode()
  {
   if(Mutilate::htmlDecode("Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")!="Abcde<br/><a href=\"\">fghij</a>")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLDecodeArray()
  {
   if(!($values=Mutilate::htmlDecode(Array("Abcde&lt;br/&gt;fghijk"))))
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde<br/>fghijk")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function URLEncode()
  {
   if(Mutilate::urlEncode("http://domain.com/")!="http://domain.com/")
   {
    $this->e->add("Mutilation urlEncode with argument \"http://domain.com/\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlEncode("http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")!="http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlEncode("?asd=234&arg[2]=356&asdasd=?asd&lalal")!="?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlEncode("asd=234&arg[2]=356&asdasd=?asd&lalal")!="asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument \"asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function URLEncodeArray()
  {
   if(!($values=Mutilate::urlEncode(Array("http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal"))))
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")
   {
    $this->e->add("Mutilation urlEncode with argument Array(http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function URLDecode()
  {
   if(Mutilate::urlDecode("http://domain.com/")!="http://domain.com/")
   {
    $this->e->add("Mutilation urlDecode with argument \"http://domain.com/\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlDecode("http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlDecode("?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"?asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::urlDecode("asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal")!="asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument \"asd=234&arg[2]=356&asdasd=?asd&lalal\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function URLDecodeArray()
  {
   if(!($values=Mutilate::urlDecode(Array("http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal"))))
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="http://domain.com/?asd=234&arg[2]=356&asdasd=?asd&lalal")
   {
    $this->e->add("Mutilation urlDecode with argument Array(http://domain.com/?asd=234&arg%5B2%5D=356&asdasd=%3Fasd&lalal) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function ScrambleEmail()
  {
   if(Mutilate::scrambleEmail("you@me.come")!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument \"you@me.come\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function ScrambleEmailArray()
  {
   if(!($values=Mutilate::scrambleEmail(Array("you@me.come"))))
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function UnScrambleEmail()
  {
   if(Mutilate::unscrambleEmail("you(at)me[dot]come")!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument \"you(at)me[dot]come\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function UnScrambleEmailArray()
  {
   if(!($values=Mutilate::unscrambleEmail(Array("you(at)me[dot]come"))))
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }
?>
