<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/storage.xml.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/storage.php");
 require_once($_path["include"]."storage/xml.php");
 require_once($_path["include"]."data.php");

 class UT_Storage_XML extends UT_Storage
 {
  function Constructor()
  {
   $d=new Data();
   $object=new xmlStorage($d, false);

   if(!is_object($object)||get_class($object)!="xmlStorage")
   {
    $this->e->add("Constructor doesn't return a xmlStorage object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Error")
   {
    $this->e->add("Object: \"e\" isn't an Error object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function _init()
  {
   global $_path;

   $this->_db=$_path["plugins"]."unit_testing/misc/test.xml";

   @unlink($this->_db);

   $d=new Data($this->_module, "database", "create", Array("db" => "xml://".$this->_db, "skipCheckTables" => true));

   if(!$d->submit())
    return false;

   return true;
  }

  function GetAggregation()
  {
   if(!$this->_init())
    return UT_FAILED;

   $d=new Data($this->_module, "view", "all", Array("db" => "xml://".$this->_db));
   $d->setValue("aggregation_field", "catnr");
   $d->setValue("aggregation_type", "average");
   $d->setValue("aggregation_method", "around");
   $d->setValue("aggregation_interval", 1);

   $s=new xmlStorage($d);

   if($s->get())
   {
    $this->e->add("Getting aggregated data should fail, not support in class", "error");
    @unlink($this->_db);
    return UT_FAILED;
   }

   @unlink($this->_db);
   return UT_OK;
  }

 }

?>
