<?

 /*****************************************************************************
 * Filename: project/jas/include/cms.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."history.php");

 class JASCMS extends CMS
 {
  function JASCMS()
  {
   global $_config, $_page, $_useModRewrite;

   parent::CMS(Array("handleSubmit" => false));

   //set page as CMS in history
   $hs=new History();
   $hs->cms();


   $this->submitted=false;

   if($_useModRewrite)
   {
    if(($key=array_search("cms", $_page))===false) //no cms vars in URL
     $this->addVar("cms", "true");
    else //rewrite _REQUEST based on URL, expected is: page/subpage/cms/$module/$action/$extra/$nrOrCatnr/ all are optional
    {
     if(isset($_page[1+$key])) //module
      $module=$_REQUEST["m"]=$_page[1+$key];
     if(isset($_page[2+$key])) //action
      $action=$_REQUEST["a"]=$_page[2+$key];
     if(isset($_page[3+$key])) //extra
      $extra=$_REQUEST["e"]=$_page[3+$key];

     $d=Data::cache($module, $action, $extra, Array("format" => "form"));

     if(isset($_page[4+$key])&&preg_match("/^[0-9]+$/", $_page[4+$key])) //nr/catnr
     {
      if($_page[3+$key]=="list")
       $d->setValue("catnr", $_page[4+$key]);
      else //item, up, down...
       $d->setValue("nr", $_page[4+$key]);
     }

     $this->setData($d);
    }
   }
   else //non rewrite
   {
    $this->addVar("cms", "true");
    $this->addVar("p[0]", $_page[0]);
    $this->addVar("p[1]", $_page[1]);
   }

   if(!$this->formDataSetup())
    return false;
  }


  function submit()
  {
   if($this->submitted=$this->formHandleSubmit())
    return true;

   return false;
  }


  function show()
  {
   if($this->submitted)
   {
    if(!request("cmsContinue")) //no more cms action?
    {
     $r="";

     //normally handled by form function
     if($this->config["showTitles"])
      $r.="<h1>".$this->data->title."</h1>\n";

     if(!isset($this->config["showErrors"])||$this->config["showErrors"]) //show notices
      $r.=$this->formShowErrors();

     if($this->config["reloadPage"]) //reload page
      $r.=$this->handleReloadPage();

     return $r;
    }
   }

   return $this->form();
  }

 }
?>
