<?

 /*****************************************************************************
 * Filename: project/jas/include/functions.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 function showSelectProject()
 {
  global $_jseskey, $_config, $_page, $_useModRewrite;

  $f=new Form();
  print $f->start()."\n";

  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]); 
   print $f->input("hidden", "p[]", $_page[1]); 
  }

  $projects=Array("" => "");
  foreach(projects() as $project)
   if($project!="jas")
    $projects[$project]=$project;

  print $f->select(false, "currentProject", $projects, $_jseskey, "form", false, "onchange=\"this.form.submit();\"")."\n";
  print $f->end()."\n";
 }


 function showLoginForm($frontend=false)
 {
  global $_jseskey, $_config, $lang, $_page, $_useModRewrite;

  $f=new Form();
 
  print $f->start()."\n";

  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]); 
   print $f->input("hidden", "p[]", $_page[1]); 
  }
 
  if($_config["usernr"]==$_config["anonnr"])
  {
   $d=Data::cache($_config["usermodule"], "user", "login");

   $cms=new CMS();
   $cms->setDataForm($d, $f);

   print $f->input("hidden", "e", "login")."\n"; 
   print $f->input("hidden", "doLogin", "1")."\n"; 

   if($frontend) 
   {
    $projects=Array("" => "");
    foreach(projects() as $project)
     if($project!="jas")
      $projects[$project]=ucfirst($project);

    if($projects)
    {
     if(($tmp=request("currentProject"))&&isset($projects[$tmp]))
      $project=$tmp;
     else if($_jseskey!="default")
      $project=$_jseskey;
     else
      $project="";

     print "<div class=\"field\">";
     print "<div class=\"title\">".$lang->t("Project")."</div><div class=\"input\">";
     print $f->select(false, "currentProject", $projects, $project, false, false, "onchange=\"this.form.doLogin.value=''; this.form.submit();\"")."<br/>\n";
     print "</div>\n";
    }

    foreach($d->check("use", "login") as $field)
     if($d->check("properties", "username", $field)||$d->check("properties", "password", $field))
      print $cms->field($field); 
  
    print "<div class=\"field\">";
    print "<div class=\"title\"></div><div class=\"input\">";
    print $f->input("submit", "s", $lang->t("Login"), "submit");
    print "</div>\n";
   }
   else
   {
    foreach($d->check("use", "login") as $field)
    {
     if($d->check("properties", "username", $field))
      print $f->input("text", $field, $d->title($field), "form", false, "onfocus=\"this.value='';\"")."<br/>\n"; 
     else if($d->check("properties", "password", $field))
      print $f->input("password", $field, $d->title($field), "form", false, "onfocus=\"this.value='';\"")."<br/>\n"; 
    }

    print $f->input("submit", "s", $lang->t("Login"), "submit")."<br/>\n";
   }
  }
  else
  {
   print $f->input("hidden", "e", "logout")."\n"; 
   print $f->input("hidden", "doLogin", "1")."\n"; 
   print $f->input("submit", "s", $lang->t("Logout"), "submit")."<br/>\n";
  }
 
  print $f->end()."\n";
 }
 function doLogin()
 {
  global $_config, $e;

  $d=Data::cache($_config["usermodule"], "user");

  if($d->submit())
  {
   $e->add($d->e);

   if($d->extra=="login"&&isset($_config["userbackend"])&&!$_config["userbackend"]&&$_config["usernr"]!=$_config["rootnr"])
    $e->add("This is not a backend user", "warning");

   return true;
  }

  $e->add($d->e);
  return false;
 }
 function backendLoggedIn()
 {
  foreach(array_keys($_SESSION["jses"]) as $project)
   if($_SESSION["jses"][$project]["config"]["usernr"]!=$_SESSION["jses"][$project]["config"]["anonnr"]) //logged in
    if(($_SESSION["jses"][$project]["config"]["usernr"]==$_SESSION["jses"][$project]["config"]["rootnr"])||(isset($_SESSION["jses"][$project]["config"]["userbackend"])&&$_SESSION["jses"][$project]["config"]["userbackend"])) //root or backend user
     return true;

  return false;
 }


 function setJasRootPassword()
 {
  global $_config, $e;

  //get (sql) password for root user
  $d=Data::cache($_config["usermodule"], "view", "item", Array("format" => "sql", "request" => "setRootPassword"));
  $d->setValue("nr", $_config["rootnr"]);
  $d->setShowFields("password");

  if(!$d->get()) //failure getting root password
  {
   $e->add($d->e);
   return false;
  }

  if(!$d->getValue("password", 0)) //password not set
  {
   if(request("setRootPassword")) //set password form submitted, try to set new password
   {
    $d->dataformat="form";
    $d->setAction("edit");
    $d->clearValues();

    $d->setValue("nr", $_config["rootnr"]);
    $d->setRequestValue("username");
    $d->setRequestValue("password");
    $d->setRequestValue("verifypassword");

    //sudo
    $tmp=$_config["usernr"];
    $_config["usernr"]=$_config["rootnr"];
    if(!$d->submit())
    {
     $_config["usernr"]=$tmp;
     $e->add($d->e);
     return false;
    }

    $_config["usernr"]=$tmp;
    $e->add("Root user: \"".$d->getValue("username")."\" successfully set up", "note");
    return true;
   }
   else //check if pass
   {
    $e->add("Please set the root username and password for the JAS Management Tool", "note");
    return false;
   }
  }

  return true;
 }
 function showSetRootPassword()
 {
  global $_config, $lang;

  $f=new Form();
  $d=Data::cache($_config["usermodule"], "edit", "item", Array("request" => "setRootPassword"));
 
  $cms=new CMS();
  $cms->setDataForm($d, $f);

  print $f->start()."\n";
  print $f->input("hidden", "setRootPassword", "1")."\n"; 

  print $cms->field("username");
  print $cms->field("password");
  print $cms->field("verifypassword");

  print "<div class=\"field\">";
  print "<div class=\"title\"></div><div class=\"input\">";
  print $f->input("submit", "s", $lang->t("Set"), "submit");
  print "</div>\n";

  print $f->end()."\n";
 }


 function showBrowser($module)
 {
  global $_config, $_page, $_useModRewrite;

  $f=new Form();
 
  print $f->start()."\n";
  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]); 
   print $f->input("hidden", "p[]", $_page[1]); 
  }
  print $f->input("hidden", "m", "categories"); 

  $d=Data::cache($module, "view", "all");
  if($d->module=="categories")
  {
   $field="catnr"; //hardcoded in other parts
   print $f->dataSelect($module, $field, $d->getValue($field), false, false, "onchange=\"this.form.submit();\"", true)."\n";
  }
  else
  {
   $id=$d->getID();
   print $f->dataSelect($module, $id, $d->getValue($id), false, false, "onchange=\"this.form.submit();\"")."\n";
  }

  print $f->end()."\n";
 }


 function showSearch()
 {
  global $_config, $_path, $lang, $language, $_useModRewrite;

  $f=new Form();

  if(!($module=request("m"))||!in_array($module, modules()))
   $module="categories";

  if($_useModRewrite)
   print $f->start($_path["HTML"]["root"]."data/search/")."\n";
  else
  {
   print $f->start()."\n";
   print $f->input("hidden", "p[]", "data"); 
   print $f->input("hidden", "p[]", "search"); 
  }

  print $f->input("hidden", "m", $module); 
  print $f->input("hidden", "a", "search"); 
  print $f->input("hidden", "e", "full"); 
  print $f->input("text", "search", ""); 
  print $f->input("submit", "s", $lang->t("Search", false, $language)); 

  print $f->end()."\n";
 }
?>
