<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/data/chmod/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."form.php"); 
 require_once($_jasPath["include"]."data.php"); 
 require_once($_jasPath["include"]."cms.php"); 

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if($e->any())
  print $e->show();

 if(isset($_REQUEST["rightsType"])&&$_REQUEST["rightsType"]=="user")
  $rightsType="user";
 else
  $rightsType="group";

 if(!isset($_REQUEST["rights"]))
  $_REQUEST["rights"]=0;

 $d=Data::cache("categories", "tree", "down");

 $f_id=$d->getID();
 $f_refer=$d->getRightsReference();
 $tmp=$d->check("properties", "title");
 $f_title=$tmp[0];

 unset($tmp);

 if(isset($_REQUEST["s"]))
 {
  $dr=Data::cache("categories", "rights", "item");

  if(!isset($_REQUEST["rights"])||!preg_match("/^[01]+$/", $_REQUEST["rights"]))
   $dr->e->add("No rights selected"); 
  else if(!isset($_REQUEST[$f_refer])||!is_array($_REQUEST[$f_refer]))
   $dr->e->add("No categories selected"); 
  else if(!isset($_REQUEST[$f_id])||!is_array($_REQUEST[$f_id]))
   $dr->e->add("No ".$rightsType." selected"); 
  else
  {
   $k=0; 
   foreach($_REQUEST[$f_refer] as $catnr)  //all categories 
   {
    foreach($_REQUEST[$f_id] as $nr)  //all users/groups 
    {
     $dr->setValue($f_id, $catnr, $k);
     if($rightsType=="user")
     {
      $dr->setValue("usernr", $nr, $k);
      $dr->setValue("userrights", $_REQUEST["rights"], $k);
     }
     else
     {
      $dr->setValue("groupnr", $nr, $k);
      $dr->setValue("grouprights", $_REQUEST["rights"], $k);
     }

     $k++;
    }
   }

   $dr->submit();
  }

  if($dr->e->any("fatal"))
   print $dr->e->show();
  else if($dr->e->any("note"))
  {
   $dr->e->clear();
   $dr->e->add("Rights changed", "note");

   print $dr->e->show("note");
  }

  unset($dr, $k, $catnr, $nr);
 }

 $d->clearValues();
 $d->setShowFields($f_id, $f_refer, "treedepth", $f_title);
 $d->setValue($f_refer, 0);

 if($rightsType=="user")
  $dr=Data::cache("userRights", "view", "all");
 else
  $dr=Data::cache("groupRights", "view", "all");

 $dr->clearValues();
 $dr->setShowFields("nr", "catnr", "rights");
 $dr->getReferenceData("catnr")->setShowFields();
 $dr->getReferenceData("nr")->setShowFields($dr->getReferenceData("nr")->check("properties", "title"));

 $cms=new CMS();
 $cms->setData($dr);
 $cms->setForm($f);

 if(!$d->get())
  print $d->e->show();
 else if(!$dr->get(1))
  print $dr->e->show();
 else
 {
  if($_useModRewrite)
   $url=$baseURL."?";
  else
   $url=$baseURL."&amp;";

  $rights=Array();
  while($dr->next()) 
  {
   if(isset($dr->v[$f_id][$f_id])&&isset($dr->v[$f_refer]))
   {
    if(!isset($rights[$dr->v[$f_refer]]))
     $rights[$dr->v[$f_refer]]="";
    else
     $rights[$dr->v[$f_refer]].=", ";
 
    $rights[$dr->v[$f_refer]].="<a href=\"".$url."&amp;rightsType=".$rightsType."&amp;rights=".$dr->v["rights"]."&amp;catnr[]=".$dr->v[$f_refer]."&amp;nr[]=".$dr->v[$f_id][$f_id]."\">".preg_replace("/ [01]+$/", "", $dr->v("title"))."</a>";
   }
  }

  $f=new Form();
  print $f->start()."\n";
  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]);
   print $f->input("hidden", "p[]", $_page[1]);
  }

  print $f->input("hidden", "m", $d->module);
  print $f->input("hidden", "rightsType", $rightsType);
 ?>
 <table><tr>
  <td>
  <?
  while($d->next())
  {
   if($d->v["treedepth"])
    print str_repeat("&nbsp; &nbsp; ", $d->v["treedepth"]-1)."|_ ";

   if(isset($_REQUEST[$f_refer])&&in_array($d->v[$f_id], $_REQUEST[$f_refer]))
    $checked=true;
   else
    $checked=false;

   print $f->checkbox($checked, $d->v[$f_title], "catnr[]", $d->v[$f_id])."\n";

   if(isset($rights[$d->v[$f_id]])){
   ?> (<div class="hilite"><?=$rights[$d->v[$f_id]]?></div>)<?
   }else{
   ?> (<div class="hilite"><?=$lang->t("No ".$rightsType." rights")?></div>)<?
   }

   ?><br/><?
  }
  unset($d, $du);
  ?>
  </td><td>
   <h1><?=$lang->t("Change ".$rightsType." rights")?></h1>
   <h2><?=$lang->t($rightsType."s")?></h2>
   <?
   if($rightsType=="group")
   {
    $groupnrs=Array();

    //get all additional catego
    $d=Data::cache($_config["usermodule"], "view", "all");
    $d->setShowFields($f_id, $f_refer, "usersAdditionalGroups");

    if($d->get())
    {
     while($d->next())
     {
      if(!in_array($d->v[$f_refer], $groupnrs))
       $groupnrs[]=$d->v[$f_refer];

      if(isset($d->v["usersAdditionalGroups"]))
       foreach($d->v["usersAdditionalGroups"] as $catnr)
        if(!in_array($catnr, $groupnrs))
         $groupnrs[]=$catnr;
     }
    }

    $c=0;
    $d=Data::cache("categories", "view", "item");
    foreach($groupnrs as $groupnr)
     $d->setValue($f_id, $groupnr, $c++);

   }
   else 
    $d=Data::cache($_config["usermodule"], "view", "all");

   if(!$d->get())
    print $d->e->show("show");
   else 
   {
    $c=0;
    echo "<table><tr>";
    while($d->next())
    {
     $c++;
     if(isset($_REQUEST[$f_id])&&in_array($d->v("id"), $_REQUEST[$f_id]))
      $checked=true;
     else
      $checked=false;

     print "<td>".$f->checkbox($checked, $d->v("title"), "nr[]", $d->v("id"))."</td>\n";
     if($c>=4)
     {
      print "</tr><tr>";
      $c=0;
     }
    }
    echo "</tr></table>";
   }

   ?>
   <div class="cmsOptions">&nbsp;</div>

   <h2><?=$lang->t("Rights")?></h2>
   <div class="text">
   <?=$cms->rights("rights", $_REQUEST["rights"], "form rights")?><br/>
   <?=$f->input("submit", "s", $lang->t("Submit"), "submit")?>
   </div>
  </td>
 </tr></table>
 <? 
  print $f->end()."\n";
 }
 unset($f, $d, $cms);

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
