<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/data/search/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."form.php");
 require_once($_jasPath["include"]."data.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $search=request("search");

 if(!($m=request("m")))
  $m="categories";

 if(isset($jascms))
  print $jascms->show();
 else
 {
  $f=new Form();
  print $f->start();
  
  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]);
   print $f->input("hidden", "p[]", $_page[1]);
  }
 ?>
  <h1><?=$lang->t("Search")?></h1>
  <?
   if($e->any())
    print $e->show();
  ?>
  <div class="field">
   <div class="title"><?=$lang->t("Search string")?></div>
   <div class="input"><?=$f->input("text", "search", $search, "form text")?></div>
  </div>

  <div class="field">
   <div class="title"><?=$lang->t("Module")?></div>
   <div class="input">
 <?
  $moduleTypes=Array("Plugins", "Project", "System");

  print $f->selectStart(false, "m", "form", false, "onchange=\"this.form.submit();\"")."\n"; 

  $modules=Array();
  foreach($moduleTypes as $type)
  {
   print $f->selectOption("", "")."\n";
   print $f->selectOption("", " - ".$lang->t($type))."\n";

   foreach(modules(strtolower($type)) as $module)
   {
    if(!in_array($module, $modules))
    {
     $d=Data::cache($module, "view", "all", Array("skipCheckTables" => true, "skipSetRequest" => true, "skipPostInit" => true));

     if($d->tableExists())
     {
      $modules[]=$d->module;

      if($d->plugin)
       $title=$d->title.=" - ".$d->plugin->name;
      else
       $title=$d->title;
 
      if(isset($_REQUEST["m"])&&$_REQUEST["m"]==$d->module)
       print $f->selectOption($d->module, $title, "selected")."\n";
      else
       print $f->selectOption($d->module, $title)."\n";
     }
    }
   }
  }

  print $f->selectEnd()."\n";
  ?>
   </div>
  </div>
 <?
  unset($d, $moduleTypes, $modules, $module, $type, $title);

  $d=Data::cache($m, "search", false);
  $d->field["catnr"]["use"].=";show";

  if($d->extra=="index")
  {
   //sort on relevance for index searching
   $fulltextIndex=array_keys($d->fulltextIndex);

   $tmp=Array();
   foreach($fulltextIndex as $index)
    $tmp[]=$index."-";

   $d->sortOrder($tmp);
   unset($tmp);
  }

  $dc=Data::cache("categories", "tree", "up");

  if($_useModRewrite)
   $url=$_path["HTML"]["root"]."data/browse/?";
  else
   $url=$_path["HTML"]["root"]."?p[]=data&amp;p[]=browse&amp;";

 ?>
  <div class="field">
   <div class="title"><?=$lang->t("Type")?></div>
   <div class="input">
 <?
  $extraTypes=Array("title" => $lang->t("Title fields"), "show" => $lang->t("Show fields"), "field" => $lang->t("Selected fields"), "full" => $lang->t("Full text"));

  if($d->validExtra("index"))
   $extraTypes["index"]=$lang->t("Index");

  foreach($extraTypes as $extra => $text)
  {
   if(!isset($_REQUEST["e"]))
    $_REQUEST["e"]=$extra;

   if($_REQUEST["e"]==$extra)
    $checked=true;
   else
    $checked=false;

   print $f->radio($checked, $text, "e", $extra, "form", false, "onchange=\"this.form.submit();\"")."<br/>\n";
  }
  unset($extraTypes, $text, $checked);

 ?>
   </div>
  </div>
 <?
  if($d->extra=="field")
  {
   ?>
   <div class="field">
    <div class="title"><?=$lang->t("Fields")?></div>
    <div class="input">
    <?
     if(!isset($_REQUEST["searchFields"])) 
      $_REQUEST["searchFields"]=Array();

     foreach($d->check("use", "show") as $k)
     {
      if(isset($_REQUEST["searchFields"][0])&&is_array($_REQUEST["searchFields"][0])&&in_array($k, $_REQUEST["searchFields"][0])) 
       print $f->checkbox(true, $d->t[$k], "searchFields[0][]", $k);
      else
       print $f->checkbox(false, $d->t[$k], "searchFields[0][]", $k);
     }
    ?>
    </div>
   </div>
   <?
  }  
 ?>
  <div class="field">
   <div class="title"><?=$lang->t("Results per page")?></div>
   <div class="input">
 <?
  $perpages=Array(5, 10, 25, 50, 100);
  $current=$d->getValue("show_total");

  print $f->selectStart(false, "show_total", "form nr")."\n";
  foreach($perpages as $nr)
  {
   if($current==$nr)
    print $f->selectOption($nr, false, "selected")."\n";
   else
    print $f->selectOption($nr)."\n";
  }

  print $f->selectEnd()."<br/>\n";
  unset($perpage, $nr, $current);
 ?>
   </div>
  </div>
  <div class="field">
   <div class="title"><?=$lang->t("Submit")?></div>
   <div class="input">
   <?
    print $f->input("submit", "s", $lang->t("Search"), "form submit");
   ?>
   </div>
  </div>
  <?

  if(isset($_REQUEST["s"]))
  {
   if(!$d->get(1)&&!$d->e->any("warning")) //ignore warnings
    print $d->e->show("fatal");
   else
   {
    $start=$d->getValue("show_from");
    $total=$d->getValue("show_total");

    print $f->input("hidden", "show_from", $start);
    if($start>0||$d->vmax>=$total)
    {?>
     <div class="field">
      <div class="title">Page</div>
      <div class="input">
      <?
       if($start>0)
        print $f->input("submit", "s", "Previous", "form submit", false, "onclick=\"this.form.show_from.value=".($start-$total).";\"");

       if($d->vmax>=$total)
        print $f->input("submit", "s", "Next", "form submit", false, "onclick=\"this.form.show_from.value=".($start+$total).";\"");
      ?>
      </div>
     </div>
    <?}?>
    
     <div class="separator">&nbsp;</div>

     <h2>Results</h2>
     <div>
     <ul>
    <?
    $c=$d->getValue("show_from");

    while($d->next())
    {
     if(isset($d->v["catnr"]))
     {
      if(isset($d->v["catnr"]["nr"]))
       $catnr=$d->v["catnr"]["nr"];
      else 
       $catnr=$d->v["catnr"];
     }
     else
      $catnr=0;

     ?>
     <li><?=++$c?>. 
      <?if($catnr>0)
       {
        $dc->setValue("catnr", $catnr);

        if($dc->get())
        {
         while($dc->next()) 
         {?>
          <a href="<?=$url?>catnr=<?=$dc->v["nr"]?>" title="<?=$dc->v("title")?>"><?=$dc->v("title")?></a> => 
       <?}
        }
       }?>
       <a href="<?=$url.($d->module!="categories"?"m=".$d->module."&amp;nr=".$d->v["nr"].($d->check("reference", "categories")?"&amp;catnr=".$d->v["catnr"]["nr"]:""):"catnr=".$d->v["nr"])?>" title="<?=$d->v("title")?>"><?=$d->v("title")?></a>

      <ul class="row">
       <li><?=$lang->t("NR")?>: <div class="hilite"><?=(is_array($d->v["nr"])?$d->v["nr"]["nr"]:$d->v["nr"])?></div></li>
       <?if($d->v("owner")){?>
        <li><?=$lang->t("Owner")?>: <div class="hilite"><?=$d->v("owner")?></div></li>
       <?}?>
       <?if(isset($d->v["catnr"])&&isset($d->v["catnr"]["nr"])){?>
        <li><?=$lang->t("Category")?>: <div class="hilite"><?=$d->v["catnr"]["name"]?></div></li>
       <?}?>
       <?if(isset($d->v["updated"])){?>
        <li><?=$lang->t("Updated")?>: <div class="hilite"><?=$d->v["updated"]?></div></li>
       <?}?>
       <?if(isset($fulltextIndex)){?>
        <li><?=$lang->t("Relevance")?>: <?
         foreach($fulltextIndex as $index)      
          print "".$index.": <div class=\"hilite\">". $d->v[$index]."%</div> ";
        ?></li>
       <?}?>
      </ul><br/>
     </li>

     <?
    }
    ?></ul>
   </div>
  <?
   }
  }

  print $f->end()."\n";
  unset($f, $m, $d, $dc);
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
