<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/plugins/logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."fs.php");
 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $_main="overview";

 if($_page[1])
 {
  if(!in_array($_page[1], plugins()))
   $e->add("Unknown plugin: \"".$_page[1]."\"");
  else
  {
   if($_useModRewrite)
   {
    if(($key=array_search("cms", $_page))!==false) //cms vars in URL
    {
     if(isset($_page[1+$key])) //module
      $_POST["m"]=$_REQUEST["m"]=$_page[1+$key];
     if(isset($_page[2+$key])) //action
      $_POST["a"]=$_REQUEST["a"]=$_page[2+$key];
     if(isset($_page[3+$key])) //extra
      $_POST["e"]=$_REQUEST["e"]=$_page[3+$key];
     if(isset($_page[4+$key])&&preg_match("/^[0-9]+$/", $_page[4+$key])) //nr/catnr
     {
      if($_page[3+$key]=="list")
       $_POST["catnr"]=$_REQUEST["catnr"]=$_page[4+$key];
      else //item, up, down...
       $_POST["nr"]=$_REQUEST["nr"]=$_page[4+$key];
     }
    }
   }

   $_p=new Plugin($_page[1]);

   if(!$_useModRewrite)
   {
    $_p->addVar("p[0]", $_page[0]);
    $_p->addVar("p[1]", $_page[1]);
   }

   $_p->readInfo();
   $_pc=$_p->copy();
   $_pc->addVar("backend", 1); //always backend

   if(request("main"))
   {
    $_main="main";

    if(($config=request("config")))
     if($_p->config($config))
      $_p->addVar("config", $config);

    if($_p->initClass()&&$_p->callExists($_p->main_function))
    {
     $_p->addVar("main", 1);
     $_p->main();
    }
   }
   else if(request("backend"))
   {
    $_main="backend";

    if($_p->initBackendClass()&&$_p->callExists($_p->backend_function, "backend"))
    {
     $_p->addVar("backend", 1);
     $_p->backend();
    }
   }
   else if(request("m")&&in_array(request("m"), modules("plugins", $_page[1])))
   {
    $_main="modules";

    if(request("cms")||in_array("cms", $_page))
    {
     $jascms=new JASCMS();
     $jascms->submit();
    }
   }
   else
   {
    $_main="info";

    $_p->readDeps();

    $_p->initClass();
    $_p->callExists($_p->main_function);
    $_p->callExists($_p->main_output);

    if($_p->initBackendClass())
     $_p->callExists($_p->backend_function, "backend");

    if($_p->initSetupClass((request("deSetup")?true:false)))
    {
     if($_p->setup_init)
      $_p->callExists($_p->setup_init, "setup");
     if($_p->setup_preSetup)
      $_p->callExists($_p->setup_preSetup, "setup");
     if($_p->setup_postSetup)
      $_p->callExists($_p->setup_postSetup, "setup");
     if($_p->setup_preDeSetup)
      $_p->callExists($_p->setup_preDeSetup, "setup");
     if($_p->setup_postDeSetup)
      $_p->callExists($_p->setup_postDeSetup, "setup");
    }

    if(request("enable")!==false)
    {
     if(!$_p->setStatus(request("enable")))
      $e->add($_p->e);
    }
    else if(request("setup"))
    {
     if(request("s"))
     {
      if(!$_p->e->any("fatal"))
       $_p->setup((request("force")?true:false));

      $e->add($_p->e);
     }
     else if(request("force"))
      $e->add("Are you sure you wish to force to setup: ".$_p->title." ".$_p->version."?", "warning");
     else
      $e->add("Are you sure you wish to setup: ".$_p->title." ".$_p->version."?", "note");
    }
    else if(request("deSetup"))
    {
     if(request("s"))
     {
      if(!$_p->e->any("fatal"))
       $_p->deSetup();

      $e->add($_p->e);
     }
     else
      $e->add("Are you sure you wish to deSetup: ".$_p->title." ".$_p->version."?", "warning");
    }
    else if(request("export"))
    {
     if($_p->export(request("export")))
      exit;

     $e->add($_p->e);
    }
    else if(request("remove"))
    {
     if(request("s"))
     {
      $_p->e->clear(); //clear errors (so only remove errors are returned)
      if(!$_p->remove())
       $e->add($_p->e);
      else
      {
       $e->add($_p->e);
       $_main="overview";

       if($_useModRewrite)
        $baseURL=str_replace($_p->name."/", "", $baseURL);
       else
        $baseURL=str_replace("&amp;p[]=".$_p->name, "", $baseURL);

       unset($_p, $_pc);
      }
     }
     else
      $e->add("Are you sure you wish to remove: ".$_p->title." ".$_p->version."?", "warning");
    }
    else
     $e->add($_p->e);

   }

   if(isset($_pc)) //plugin not remove
    $_pc->getStatus(); //get control status

   if(isset($_p)) //plugin not remove
   {
    //init setup
    if($_main=="info"&&$_p->isEnabled()&&$_config["rootnr"]==$_config["usernr"])
     if(!$_p->initSetupClass()||!$_p->initSetup((request("force")&&!request("s")?true:false), (request("deSetup")?true:false)))
      $e->add($_p->e);
   }
  }
 }
 else if(request("importOverwrite")&&request("s"))
 {
  $importPlugin=new Plugin(false);
  $importPlugin->e->clear();

  $importPlugin->importOverwrite(request("importOverwrite"));
 }
 else if($import=request("import", "FILES"))
 {
  $importPlugin=new Plugin(false);
  $importPlugin->e->clear();

  if(!FS::rename($import["tmp_name"], $_path["project"]["plugins"].$import["name"]))
   $e->add("Can't move uploaded file \"".$import["tmp_name"]."\" to plugin directory: \"".$_path["project"]["plugins"]."\"", "error");
  else
  {
   $importPlugin->import($_path["project"]["plugins"].$import["name"]);
   FS::delete($_path["project"]["plugins"].$import["name"]);
  }

  unset($import);
 }
 else if(isset($_REQUEST["repository"])&&$_config["rootnr"]==$_config["usernr"])
 {
  $_main="online";

  if($repository=request("repository"))
  {
   if(!isset($_config["repositories"][$repository]))
   {
    $e->add("Unknown repository: \"".$repository."\"", "error");
   }
   else if(!in_array("Plugins", $_config["repositories"][$repository]["content"]))
   {
    $e->add("Repository: \"".$repository."\" isn't a plugins repository", "error");
   }
   else if(($nr=request("install"))||($nr=request("update")))
   {
    $d=Data::cache("onlinePlugins", "view", "item", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
    $d->setShowFields("file", "fileData");
    $d->setValue("nr", $nr);

    if(!$d->get())
     $e->add($d->e);
    else
    {
     $importPlugin=new Plugin(false);
     $importPlugin->e->clear();

     if(!FS::write($_path["project"]["plugins"].$d->getValue("file"), $d->getValue("fileData"), "overwrite"))
      $e->add("Can't save file: \"".$d->getValue("file")."\" to plugin directory: \"".$_path["project"]["plugins"]."\"", "error");
     else
     {
      $importPlugin->import($_path["project"]["plugins"].$d->getValue("file"));
      FS::delete($_path["project"]["plugins"].$d->getValue("file"));
      $_main="overview";
     }
    }

    unset($d);
   }
  }
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
