<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/plugins/main.info.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."plugin.php");

 $cms=new CMS();
 $cms->setDataForm($_p->info, new Form());
 $pi=Data::cache("pluginInfo", "view", "item");

 ?><h1><?=$_p->title?> <?=$lang->t($_p->type." plugin")?> <?=$_p->version?><?=$_p->status2?></h1>

 <?=$e->show();?>

 <div class="field"><div class="title"><?=$lang->t("Author / E-mail")?></div><div class="input"><?=$_p->author?> <?if($_p->email){?>/ <a href="mailto:<?=$_p->email?>" title="Send e-mail to <?=$_p->email?>"><?=$_p->email?></a><?}?></div></div>
 <div class="field"><div class="title"><?=$lang->t("Description")?></div><div class="input"><?=$lang->t($_p->description)?></div></div>
 <div class="field"><div class="title"><?=$lang->t("License")?></div><div class="input"><?=$_p->license?><?=($_p->license?" - ":"").(isset($pi->listOptions["license"][$_p->license])?$pi->listOptions["license"][$_p->license]:"")?></div></div>
 <div class="field"><div class="title"><?=$_p->name."-".$_p->version?></div><div class="input"><a href="<?=$_path["HTML"]["root"].($_useModRewrite?"plugins/?":"?p[]=plugins&amp;")?>repository&search=<?=$_p->name?>" title="Check for updated of <?=$_p->name?>">Check for updates</a></div></div>

 <?
 foreach(array_keys($_p->info->field) as $field)
 {
  if(!$_p->info->check("module", "pluginInfo", $field)&&$_p->info->check("use", "show", $field))
  {
   ?><div class="field"><div class="title"><?=$_p->info->t[$field]?></div><div class="input"><?=$_p->$field?></div></div><?
  }
 }
 ?><br/>

 <?if($_p->deps&&$_p->deps->vmax){?>
 <h2><?=$lang->t("Dependencies")?></h2>
 <table class="overview plugin">
  <tr>
   <th class="plugin"><?=$lang->t("Plugin")?></th>
   <th class="version"><?=$lang->t("Version")?></th>
   <th class="required"><?=$lang->t("Required")?></th>
  </tr>

  <?while($_p->deps->next()){?>
  <tr class="main">
   <td class="plugin">
   <?if(!$_p->deps->v["plugin"]){?>
    JAS
   <?}else if(in_array($_p->deps->v["plugin"], plugins())){?>
    <a href="<?=$_path["HTML"]["root"].($_useModRewrite?"plugins/".$_p->deps->v["plugin"]."/":"?p[]=plugins&amp;p[]=".$_p->deps->v["plugin"])?>" title="<?=$_p->deps->v["plugin"]?>"><?=$_p->deps->v["plugin"]?></a>
   <?}else{?>
    <a href="<?=$_path["HTML"]["root"].($_useModRewrite?"plugins/?":"?p[]=plugins&amp;")?>repository&search=<?=$_p->deps->v["plugin"]?>" title="Search online for: <?=$_p->deps->v["plugin"]?>"><?=$_p->deps->v["plugin"]?></a>
   <?}?>
   </td>
   <td class="version"><?=$_p->deps->v["version"]?></td>
   <td class="required"><?=($_p->deps->v["required"]?$lang->t("Yes"):$lang->t("No"))?></td>
   </tr>
  <?}?>
 </table><br/>
 <?}?>

 <h2><?=$lang->t("Coding")?></h2>
 <table class="overview plugin">
  <tr>
   <th class="type"><?=$lang->t("Type")?></th>
   <th class="file"><?=$lang->t("File")?></th>
   <th class="class"><?=$lang->t("Class")?></th>
   <th class="functions"><?=$lang->t("Functions")?></th>
  </tr>

  <tr class="main">
   <td class="type"><?=$lang->t("Main")?></td>
   <td class="file"><?=$_p->main_file?></td>
   <td class="class"><?=$_p->main_class?></td>
   <td class="function"><?=$_p->main_function?>, <?=$_p->main_output?></td>
  </tr>
  <tr class="backend">
   <td class="type"><?=$lang->t("Backend")?></td>
   <?if($_p->hasBackend()){?>
    <td class="file"><?=$_p->backend_file?></td>
    <td class="class"><?=$_p->backend_class?></td>
    <td class="function"><?=$_p->backend_function?>, <?=$_p->backend_output?></td>
   <?}else{?>
    <td class="na" colspan="3"><?=$lang->t("Not available")?></td>
   <?}?>
  </tr>
  <tr class="setup">
   <td class="type"><?=$lang->t("Additional setup")?></td>
   <?if($_p->hasSetup()){?>
    <td class="file"><?=$_p->setup_file?></td>
    <td class="class"><?=$_p->setup_class?></td>
    <td class="function"><?

     $tmp=Array();
     if($_p->setup_init)
      $tmp[]=$_p->setup_init;
     if($_p->setup_preSetup)
      $tmp[]=$_p->setup_preSetup;
     if($_p->setup_postSetup)
      $tmp[]=$_p->setup_postSetup;
     if($_p->setup_preDeSetup)
      $tmp[]=$_p->setup_preDeSetup;
     if($_p->setup_postDeSetup)
      $tmp[]=$_p->setup_postDeSetup;

     print implode(", ", $tmp);
     unset($tmp);

    ?></td>
   <?}else{?>
    <td class="na" colspan="3"><?=$lang->t("Not available")?></td>
   <?}?>
  </tr>
 </table><br/>

 <h2><?=$lang->t("Setup")?></h2>
 <?
  if(!$_p->isEnabled())
  {
  ?>
   <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$lang->t("Only available if plugin is enabled")?></div></div><br/>
  <?
  }
  else if($_config["rootnr"]!=$_config["usernr"])
  {
  ?>
   <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$lang->t("Only available for root user")?></div></div><br/>
  <?
  }
  else
  {
   if((request("setup")||request("deSetup"))&&($_p->setupClass->directories||$_p->setupClass->files||$_p->setupClass->modules))
   {
    ?>
    <table class="overview plugin">
    <?
     if($_p->setupClass->directories)
     {
      ?>
      <tr>
       <th class="directory" colspan="2"><?=$lang->t("Directories")?></th>
       <th class="status"><?=$lang->t("Status")?></th>
      </tr>
      <?
      foreach($_p->setupClass->directories as $dir)
      {
       ?>
       <tr>
        <td class="directory" colspan="2"><?=$dir["directory"]?></td>
        <td class="status <?=strtolower(str_replace(" ", "", $dir["status"]))?>"><?=$lang->t($dir["status"])?></td>
       </tr>
      <?
      }
     }

     if($_p->setupClass->files)
     {
      ?>
      <tr>
       <th class="file"><?=$lang->t("Files")?></th>
       <th class="destination"><?=$lang->t("Destination")?></th>
       <th class="status"><?=$lang->t("Status")?></th>
      </tr>
      <?
      foreach($_p->setupClass->files as $file)
      {
       ?>
       <tr class="module">
        <td class="file"><?=$file["source"]?></td>
        <td class="destination"><?=$file["destination"]?></td>
        <td class="status <?=strtolower(str_replace(" ", "", $file["status"]))?>"><?=$lang->t($file["status"])?></td>
       </tr>
      <?
      }
     }

     if($_p->setupClass->modules)
     {
      ?>
      <tr>
       <th class="module" colspan="2"><?=$lang->t("Modules")?></th>
       <th class="status"><?=$lang->t("Status")?></th>
      </tr>
      <?
      foreach($_p->setupClass->modules as $module)
      {
       ?>
       <tr>
        <td class="module" colspan="2"><?=$module["module"]?></td>
        <td class="status <?=strtolower(str_replace(" ", "", $module["status"]))?>"><?=$lang->t($module["status"])?></td>
       </tr>
      <?
     }
    }

    ?></table><br/><?
   }

   if(!$_p->setupClass->directories&&!$_p->setupClass->files&&!$_p->setupClass->modules)
   {
   ?>
    <div class="field"><div class="title"><?=$lang->t("Setup plugin")?></div><div class="input">
     <?=$lang->t("Nothing to setup")?>
    </div></div><br/>
   <?
   }
   else if(request("setup")&&!request("s"))
   {
    $f=new Form();
    print $f->start();
    print $f->input("hidden", "setup", 1);

    if(!$_useModRewrite)
    {
     print $f->input("hidden", "p[]", $_page[0]);
     print $f->input("hidden", "p[]", $_page[1]);
    }

   ?>
    <div class="field"><div class="title"><?=$lang->t("Setup plugin")?></div><div class="input">
     <?=$f->input("submit", "s", $lang->t("Yes"));?>
     <?=$f->input("submit", "", $lang->t("No"), "form", false, "onclick=\"this.form.setup.value='';\"");?>
     <?=$f->checkbox((request("force")?true:false), $lang->t("Force"), "force", 1, "form", false, "onchange=\"this.form.submit();\"");?>
    </div></div><br/>
   <?
    print $f->end();
    unset($f);
   }
   else if(request("deSetup")&&!request("s"))
   {
    $f=new Form();
    print $f->start();
    print $f->input("hidden", "deSetup", 1);

    if(!$_useModRewrite)
    {
     print $f->input("hidden", "p[]", $_page[0]);
     print $f->input("hidden", "p[]", $_page[1]);
    }

   ?>
    <div class="field"><div class="title"><?=$lang->t("DeSetup plugin")?></div><div class="input">
     <?=$f->input("submit", "s", $lang->t("Yes"));?>
     <?=$f->input("submit", "", $lang->t("No"), "form", false, "onclick=\"this.form.deSetup.value='';\"");?>
    </div></div><br/>
   <?
    print $f->end();
    unset($f);
   }
   else if($_p->setupClass->done)
   {
   ?>
    <div class="field"><div class="title"><?=$lang->t("Setup plugin")?></div><div class="input">
     <?=$lang->t($_p->title." ".$_p->version." setup correctly")?> (<a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>setup=1&amp;force=1" title="<?=$lang->t("Setup")?> <?=$_p->title?> <?=$_p->version?>"><?=$lang->t("Force setup")?></a> /
     <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>deSetup=1" title="<?=$lang->t("DeSetup")?> <?=$_p->title?> <?=$_p->version?>"><?=$lang->t("DeSetup")?></a>)
    </div></div><br/>
   <?
   }
   else
   {
   ?>
    <div class="field"><div class="title"><?=$lang->t("Setup plugin")?></div><div class="input">
     <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>setup=1" title="<?=$lang->t("Setup")?> <?=$_p->title?> <?=$_p->version?>"><?=$_p->title?> <?=$_p->version?></a>
    (<a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>deSetup=1" title="<?=$lang->t("DeSetup")?> <?=$_p->title?> <?=$_p->version?>"><?=$lang->t("DeSetup")?></a>)
    </div></div><br/>
   <?
   }
  }
 ?>

 <h2><?=$lang->t("Remove")?></h2>
 <?
  if($_p->isEnabled())
  {
  ?>
   <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$lang->t("Only available if plugin is disabled")?></div></div><br/>
  <?
  }
  else if($_config["rootnr"]!=$_config["usernr"])
  {
  ?>
   <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$lang->t("Only available for root user")?></div></div><br/>
  <?
  }
  else
  {
   $f=new Form();
   print $f->start();
   print $f->input("hidden", "remove", 1);

   if(!$_useModRewrite)
   {
    print $f->input("hidden", "p[]", $_page[0]);
    print $f->input("hidden", "p[]", $_page[1]);
   }

   if(request("remove")&&!request("s"))
   {
   ?>
    <div class="field"><div class="title"><?=$lang->t("Remove plugin")?></div><div class="input">
     <?=$f->input("submit", "s", $lang->t("Yes"));?>
     <?=$f->input("submit", "", $lang->t("No"), "form", false, "onclick=\"this.form.remove.value='';\"");?>
    </div></div><br/>
   <?
   }
   else
   {
   ?>
    <div class="field"><div class="title"><?=$lang->t("Remove plugin")?></div><div class="input">
     <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>remove=1" title="<?=$lang->t("Remove")?> <?=$_p->title?> <?=$_p->version?>"><?=$_p->title?> <?=$_p->version?></a>
    </div></div><br/>
   <?
   }
   print $f->end();
   unset($f);
  }
 ?>

 <h2><?=$lang->t("Export")?></h2>
 <div class="field"><div class="title"><?=$lang->t("Export plugin")?></div><div class="input">
  <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>export=tgz" title="Export to TGZ">TGZ</a> /
  <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>export=tar.gz" title="Export to TAR.GZ">TAR.GZ</a> /
  <a href="<?=$baseURL.($_useModRewrite?"?":"&amp;")?>export=tar.bz2" title="Export to TAR.BZ2">TAR.BZ2</a>
 </div></div><br/>
