<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/plugins/main.online.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


?>
 <h1><?=$lang->t("Online plugins")?></h1>
 <?=$e->show();?>
 <?
  $repositories=Array("");
  foreach(array_keys($_config["repositories"]) as $repository)
   if(in_array("Plugins", $_config["repositories"][$repository]["content"]))
    $repositories[]=$repository;

  $f=new Form();
  print $f->start();

  if(!$_useModRewrite)
   print $f->input("hidden", "p[]", $_page[0]);

  print $f->input("hidden", "repository");

  ?>
  <div class="field"><div class="title"><?=$lang->t("Search")?></div><div class="input"><?=$f->input("text", "search", request("search"));?></div></div>
  <div class="field"><div class="title"><?=$lang->t("Repository")?></div><div class="input"><?=$f->select(false, "repository", $repositories, request("repository"), false, false, "onchange=\"this.form.submit();\"");?></div></div>
  <div class="field"><div class="title"><?=$f->checkbox(request("allversions"), "Show old version", "allversions", 1, false, false, "onchange=\"this.form.submit();\"");?> </div><div class="input"><?=$f->input("submit", "", $lang->t("Search"));?></div></div>
  <br/>
  <?

  print $f->end();
  unset($f);
 ?>

 <table class="overview plugins">
  <tr>
   <th class="repository"><?=$lang->t("Repository")?></th>
   <th class="plugin"><?=$lang->t("Plugin")?></th>
   <th class="version"><?=$lang->t("Version")?></th>
   <th class="description"><?=$lang->t("Description")?></th>
   <th class="author"><?=$lang->t("Author")?></th>
   <th class="size"><?=$lang->t("Size")?></th>
   <th class="updated"><?=$lang->t("Updated")?></th>
   <th class="status"><?=$lang->t("Status")?></th>
   <th class="action" colspan="2"><?=$lang->t("Action")?></th>
  </tr>
 <?

 $total=0;
 $plugins=plugins();


 foreach($repositories as $repository)
 {
  if(!$repository||(request("repository")&&$repository!=request("repository")))
   continue;

  if(request("search"))
  {
   $dr=Data::cache("onlinePlugins", "search", "full", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
   $dr->sortOrder("plugin", "version-");
  }
  else
  {
   $dr=Data::cache("onlinePlugins", "view", "all", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
   $dr->sortOrder("updated-");
  }

  $dr->setShowFields("plugin", "title", "description", "version", "version_major", "version_minor", "version_maintenance", "status", "status2", "author", "email", "fileSize", "updated");
  $dr->addMutilation("updated", "dateConvert", $_config["dateformat"]);
  $dr->addMutilation("fileSize", "humanReadableFileSize");

  $dr->clearValues();

  if(request("search"))
   $dr->setValue("search", request("search"));

  if(!request("allversions"))
  $dr->setValue("aggregation_field", "plugin");

  if($_useModRewrite)
  {
   $url=$baseURL."?";
   $urlPlugins=$_path["HTML"]["root"]."plugins/";
   $urlRepos=$_path["HTML"]["root"]."system/configuration/?";
  }
  else
  {
   $url=$baseURL."&amp;";
   $urlPlugins=$_path["HTML"]["root"]."?p[]=plugins&amp;p[]=";
   $urlRepos=$_path["HTML"]["root"]."?p[]=system&amp;p[]=configuration&amp;";
  }

  if(!$dr->get())
  {
   ?>
    <tr class="system">
     <td class="repository">
      <?=$repository?><br/>
      <a href="<?=$_config["repositories"][$repository]["url"]?>" rel="external" title="Go to <?=$repository?>"><?=$_config["repositories"][$repository]["url"]?></a>
     </td>
     <td colspan="8"><?=$dr->e->show()?></td>
     <td class="action"><a href="<?=$urlRepos?>repository&amp;delete=<?=$repository?>" title="Delete <?=$repository?>"><?=icon("delete")?></a></td>
    </tr>
   <?
  }
  else
  {
   $total+=$dr->vmax;
   while($dr->next())
   {
    ?>
    <tr class="system">
     <?if($dr->vc==1){?>
      <td class="repository" rowspan="<?=$dr->vmax?>"><?=$repository?><br/><a href="<?=$_config["repositories"][$repository]["url"]?>" rel="external" title="Go to <?=$repository?>"><?=$_config["repositories"][$repository]["url"]?></a></td>
     <?}?>

     <td class="plugin <?=$dr->v["status"]?>">
     <?if(in_array($dr->v["plugin"], $plugins)){?>
      <a href="<?=$urlPlugins?><?=$dr->v["plugin"]?>" title="<?=$dr->v["title"]?>"><?=$dr->v["title"]?></a>
     <?}else{?>
      <?=$dr->v["title"]?>
     <?}?>
     </td>
     <td class="version <?=$dr->v["status"]?>"><?=$dr->v["version"]?><?=$dr->v["status2"]?></td>
     <td class="description"><?=$dr->v["description"]?></td>
     <td class="maintainer"><a href="mailto:<?=$dr->v["email"]?>" title="Email <?=$dr->v["author"]?>"><?=$dr->v["author"]?></a></td>
     <td class="size"><?=$dr->v["fileSize"]?></td>
     <td class="updated"><?=$dr->v["updated"]?></td>
     <?

     if(in_array($dr->v["plugin"], $plugins)) //match
     {
      $plugin=new Plugin($dr->v["plugin"]);
      $plugin->readInfo();

      if($plugin->version_major!=$dr->v["version_major"]||$plugin->version_minor!=$dr->v["version_minor"]||$plugin->version_maintenance!=$dr->v["version_maintenance"]) //changed
      {
       if($plugin->version_major<$dr->v["version_major"]||
        ($plugin->version_major==$dr->v["version_major"]&&$plugin->version_minor<$dr->v["version_minor"])||
        ($plugin->version_major==$dr->v["version_major"]&&$plugin->version_minor==$dr->v["version_minor"]&&$plugin->version_maintenance<$dr->v["version_maintenance"])
       ) //new available
       {
        print "<td class=\"status\">".$lang->t("Upgrade")."</td>\n";
        print "<td class=\"action\"><a href=\"".$url."repository&amp;repository=".$repository."&amp;update=".$dr->v["nr"]."\" title=\"Upgrade ".$dr->v["title"]." ".$plugin->version." to ".$dr->v["version"]."\">".icon("edit", "pluginConfigs")."</a></td>\n";
       }
       else //older available
       {
        print "<td class=\"status\">".$lang->t("Downgrade")."</td>\n";
        print "<td class=\"action\"><a href=\"".$url."repository&amp;repository=".$repository."&amp;update=".$dr->v["nr"]."\" title=\"Downgrade ".$dr->v["title"]." ".$plugin->version." to ".$dr->v["version"]."\">".icon("edit", "pluginConfigs")."</a></td>\n";
       }

      }
      else
      {
       if($plugin->isEnabled())
       {
        print "<td class=\"status\">".$lang->t("Enabled")."</td>\n";
        print "<td class=\"action\">&nbsp; </td>\n";
       }
       else
       {
        print "<td class=\"status\">".$lang->t("Installed")."</td>\n";
        print "<td class=\"action\"><a href=\"".$urlPlugins.$dr->v["plugin"].($_useModRewrite?"/?":"&amp;")."remove=1\" title=\"Delete ".$dr->v["title"]."\">".icon("delete", "pluginConfigs")."</a></td>\n";
       }
      }
     }
     else
     {
      print "<td class=\"status\">".$lang->t("Not installed")."</td>\n";
      print "<td class=\"action\"><a href=\"".$url."repository&amp;".($dr->action=="search"?"search=".urlencode($dr->getValue("search"))."&amp;":"")."repository=".$repository."&amp;install=".$dr->v["nr"]."\" title=\"Install ".$dr->v["title"]."\">".icon("add", "pluginConfigs")."</a></td>\n";
     }
     ?>

     <?if($dr->vc==1){?>
      <td class="action" rowspan="<?=$dr->vmax?>"><a href="<?=$urlRepos?>repository&amp;delete=<?=$repository?>" title="Delete <?=$repository?>"><?=icon("delete")?></a></td>
     <?}?>

    </tr>
    <?
   }
  }
  unset($dl, $dr);
 }
 ?>
  <tr class="footer">
   <td class="total" colspan="10"><?=$lang->t("Total")?>: <?=$total?></td>
  </tr>
  </table><br/>
 <?

 unset($repositories, $repository);

?>
