<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/plugins/main.overview.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."form.php");
 require_once($_jasPath["include"]."plugin.php");
?>
 <h1>Plugins</h1>

 <?=$e->show();?>

 <table class="overview plugins">
  <tr>
   <th class="enabled"><?=$lang->t("Enabled")?></th>
   <th class="plugin"><?=$lang->t("Plugin")?></th>
   <th class="version"><?=$lang->t("Version")?></th>
   <th class="description"><?=$lang->t("Description")?></th>
   <th class="author"><?=$lang->t("Author")?></th>
   <th class="license"><?=$lang->t("License")?></th>
  </tr>
<?
   foreach(plugins() as $p)
   {
    $plugin=new Plugin($p);
    $plugin->readInfo();
    ?>
    <tr class="<?=$plugin->type?>">
     <?if($plugin->isEnabled()){?>
      <td class="enabled"><a href="<?=$baseURL.($_useModRewrite?$plugin->name."/?":"&amp;p[]=".$plugin->name."&amp;")?>enable=0" title="<?=$lang->t("Disable plugin")?>"><?=icon("pluginEnabled")?></a></td>
     <?}else{?>
      <td class="enabled"><a href="<?=$baseURL.($_useModRewrite?$plugin->name."/?":"&amp;p[]=".$plugin->name."&amp;")?>enable=1" title="<?=$lang->t("Enable plugin")?>"><?=icon("pluginDisabled")?></a></td>
     <?}?>
     <td class="plugin <?=$plugin->status?>"><a href="<?=$baseURL.($_useModRewrite?$plugin->name."/":"&amp;p[]=".$plugin->name)?>" title="<?=$plugin->title?>"><?=$plugin->title?></a></td>
     <td class="version <?=$plugin->status?>"><?=$plugin->version?><?=$plugin->status2?></td>
     <td class="description"><?=$lang->t($plugin->description)?></td>
     <td class="email"><?if($plugin->email){?><a href="mailto:<?=$plugin->email?>" title="Send e-mail to <?=$plugin->email?>"><?=$plugin->author?></a><?}?></td>
     <td class="license"><?=$lang->t($plugin->license)?></td>
    </tr>
    <?
    unset($plugin);
   }

 ?>
 </table><br/>


 <?
 if($_config["rootnr"]!=$_config["usernr"])
 {
 ?>
  <h2><?=$lang->t("Online plugins")?> / <?=$lang->t("Plugin import")?></h2>
  <div class="field"><div class="title">&nbsp;</div><div class="input"><?=$lang->t("Only available for root user")?></div></div><br/>
 <?
 }
 else
 {
 ?>


 <h2><?=$lang->t("Online plugins")?></h2>
 <?
  $f=new Form();
  print $f->start($baseURL);

  if(!$_useModRewrite)
   print $f->input("hidden", "p[]", $_page[0]);

  print $f->input("hidden", "repository");

  ?>
  <div class="field"><div class="title"><?=$lang->t("Search")?></div><div class="input"><?=$f->input("text", "search", request("search"));?></div></div>
  <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$f->input("submit", "", $lang->t("Search"));?></div></div>
  <br/>
  <?

  print $f->end();
  unset($f);
 ?>


 <h2><?=$lang->t("Import plugin")?></h2>
 <?
  if(isset($importPlugin))
   print $importPlugin->e->show();

  $f=new Form();
  print $f->start($baseURL);

  if(!$_useModRewrite)
   print $f->input("hidden", "p[]", $_page[0]);

  if(isset($importPlugin)&&$importPlugin->e->errors()==1&&$importPlugin->e->any("warning"))
  {
   print $f->input("hidden", "importOverwrite", $importPlugin->name);
  ?>
   <div class="field"><div class="title">Install</div><div class="input">
    <?=$f->input("submit", "s", "Yes");?>
    <?=$f->input("submit", "", "No");?>
   </div></div><br/>
  <?
  }
  else
  {
  ?>
   <div class="field"><div class="title"><?=$lang->t("Import file")?></div><div class="input"><?=$f->input("file", "import");?></div></div>
   <div class="field"><div class="title">&nbsp; </div><div class="input"><?=$f->input("submit", "s", $lang->t("Import"));?></div></div>
   <br/>
  <?
  }
  print $f->end();
  unset($f);
 }

?>
