<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/sync/convert/logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."http.php");
 require_once($_path["include"]."form.php");
 require_once($_path["include"]."cms.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject, needed for reading module tree

 $dSync=Data::cache("empty", "view", "item");
 $dSync->addField("_sourceModule", "module", "form", "reload", 1, false, false, "Source module");
 $dSync->addField("_targetModule", "module", "form", "reload", 1, false, false, "Target module");

 $sourceFields=Array("" => "");
 $targetFields=Array();

 if(request("_sourceModule"))
 {
  $ds=Data::cache(request("_sourceModule"), "view", "all", Array("format" => "sql")); //use sql data format to be able to insert IDs

  foreach($ds->check("use", "sql") as $field)
   if(!$ds->check("properties", "default", $field)&&$ds->check("use", "form", $field))
    $sourceFields[$field]=$ds->title($field)." (".$field.")";
 } 

 if(request("_targetModule"))
 {
  $dSync->addField("label", "label", "form", false, false, false, false, "Mapping");
  $dt=Data::cache(request("_targetModule"), "view", "all", Array("format" => "sql")); //use sql data format to be able to insert IDs

  foreach($dt->check("use", "sql") as $field)
  {
   if(!$dt->check("properties", "default", $field)&&$dt->check("use", "form", $field))
   {
    $dSync->addField($field, "list", "form", false, 1, 0, false, $dt->title($field)." (".$field.")");
    $dSync->listOptions($field, $sourceFields);
    $targetFields[$field]=$dt->title($field);
   }
  }

  $dSync->addField("catnr", "nr", "sql;form", "rightsReference;global;default", 1, false, 1, "Category");
  $dSync->addReference("catnr", "categories", "nr", "*:1", "catnr");
 }

 if(request("s"))
 {
  //get default fields
  $ids=$ds->getID();
  $idt=$dt->getID();

  if($owner=$ds->check("properties", "owner"))
   $owner=$owner[0];
  else
   $owner=false;

  if($ds->check("properties", "forceUpdate", "updated"))
   $updated="updated";
  else
   $updated=false;

  if($refer=$dt->getRightsReference())
   $catnr=$dt->reference[$refer]["from"];

  //make sure all mapped fields are gathered from the source data
  $showFields=Array($ids);
  foreach(array_keys($targetFields) as $field)
   $showFields[]=$dSync->getValue($field);

  $ds->setShowFields($showFields);
  unset($showFields);

  //get all values
  $ds->clearValues();
  $ds->get();

  //get all IDs that already exist in target
  $dt->setAction("view");
  $dt->setExtra("item");
  $dt->clearValues();

  $c=0;
  $dt->setShowFields(); //don't get any fields other then ID
  while($ds->next())
  {
   $dt->setValue($idt, $ds->v[$ids], $c);
   $c++;
  }

  $dt->get();
  $existingIDs=Array();
  while($dt->next())
   $existingIDs[]=$dt->v[$idt];

  //added new items
  $dt->setAction("add");
  $dt->setExtra("item");
  $dt->clearValues();

  $c=0;
  while($ds->next())
  {
   if(in_array($ds->v[$ids], $existingIDs)) //already exist, edit below
    continue;

   $dt->setValue($idt, $ds->v[$ids], $c);
   $dt->setValue($catnr, $dSync->getValue("catnr"), $c);

   if($owner)
    $dt->setDefaultValue($owner, $c);

   if($updated)
    $dt->setDefaultValue($updated, $c);

   foreach(array_keys($targetFields) as $field)
    if($dSync->getValue($field))
     $dt->setValue($field, $ds->v[$dSync->getValue($field)], $c);

   $c++;
  }

  if($c)
  {
   $dt->submit();
   $e->add($dt->e);
  }

  //edit existing items
  $dt->setAction("edit");
  $dt->setExtra("item");
  $dt->clearValues();

  $c=0;
  while($ds->next())
  {
   if(!in_array($ds->v[$ids], $existingIDs)) //new, already added before
    continue;

   $dt->setValue($idt, $ds->v[$ids], $c);
   $dt->setValue($catnr, $dSync->getValue("catnr"), $c);

   if($updated)
    $dt->setDefaultValue($updated, $c);

   foreach(array_keys($targetFields) as $field)
    if($dSync->getValue($field))
     $dt->setValue($field, $ds->v[$dSync->getValue($field)], $c);

   $c++;
  }

  $dt->field[$updated]["valuetype"]="set"; //make sure updated time stamp is changed eventhough it's sql format

  if($c)
  {
   $dt->submit();
   $e->add($dt->e);
  }

  unset($ids, $idt, $catnr, $owner, $updated);
 }
 else if(request("analyze"))
 {
  $showFields=Array();
  foreach(array_keys($targetFields) as $field)
  {
   $showFields[]=$dSync->getValue($field);
   $ds->addMutilation($dSync->getValue($field), "strip", 100);
  }

  $ds->setShowFields($showFields);
  unset($showFields);

  $ds->e->clear();
  $ds->clearValues();
  $ds->setValue("show_total", 10); //display first 10 entries

  if(!$ds->get(0, true)) //get count
   $e->add($ds->e);
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
