<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/sync/export/logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."functions.php");
 require_once($_jasPath["include"]."csv.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $methods=Array("csv" => "CSV");
 //$methods=Array("xml" => "XML", "csv" => "CSV", "sql" => "MySQL");
 $outputs=Array("screen" => "Screen", "file" => "File");

 if(in_array(request("export", "method"), array_keys($methods)))
  $method=request("export", "method");
 else
  $method="csv"; //default export method

 if(in_array(request("export", "output"), array_keys($outputs)))
  $output=request("export", "output");
 else
  $output="screen"; //default output

 if(is_array(request("export", "modules")))
  $exportModules=request("export", "modules");
 else
  $exportModules=Array();

 if(request("export", "submit"))
 {
  switch($method)
  {
   case "csv":
   {
    $export="";
    $csv=new CSV();
    $csv->header(true); //use column headers

    foreach($exportModules as $module)
    {
     $d=Data::cache($module, "view", "all", Array("format" => "text"));
     $d->setShowFields(array_merge($d->check("use", "show"), $d->check("use", "sql")));
     $d->clearValues();
     $d->get();

     if(!$csv->data($d)) //use field names as column headers
      $e->add($csv->e);
     else
     {
      $export.=$csv->quote."Module".$csv->quote.$csv->split.$csv->quote.$d->module.$csv->quote.$csv->linebreak;
      $export.=$csv->output(false);
      $export.=$csv->quote.$csv->quote.$csv->linebreak;
     }
    }

    if($output=="file")
    {
     $csv->clear();
     $csv->e->clear();
     $csv->header(false);

     if(sizeof($exportModules)>1) //multi modules
      $csv->filename="export";
     else
      $csv->filename=$exportModules[0];

     $csv->filename.="-".date("Y-m-d").".csv";

     if(!$csv->parse($export))
      $e->add($csv->e);
     else
     {
      print $csv->output();
      exit;
     }
    }

    break; 
   }
   case "xml":
   case "sql":
   default:
   {
    $e->add("Export method not implemented");
    break;
   }
  }
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
