<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/sync/export/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require($_jasPath["project"]["include"]."switch.php"); //currentProject
?>
 <h1>Export</h1>
<?
 if($e->any())
  print $e->show();

 $f=new Form();
 print $f->start();
 
 if(!$_useModRewrite)
 {      
  print $f->input("hidden", "p[]", $_page[0]);
  print $f->input("hidden", "p[]", $_page[1]);
 }      
 ?>

 <div class="field">
  <div class="title">Method</div>
  <div class="input">
   <?
    foreach(array_keys($methods) as $m)
    {
     if($method==$m)
      print $f->radio(true, $methods[$m], "export[method]", $m);
     else
      print $f->radio(false, $methods[$m], "export[method]", $m);
    }
   ?>
  </div>
 </div>

 <div class="field">
  <div class="title">Output</div>
  <div class="input">
   <?
    foreach(array_keys($outputs) as $o)
     if($output==$o)
      print $f->radio(true, $outputs[$o], "export[output]", $o);
     else
      print $f->radio(false, $outputs[$o], "export[output]", $o);
   ?>
  </div>
 </div>

 <?
  $plugin=false;
  $modules=Array();
  $moduleTypes=Array("Plugins", "Project", "System");
  foreach($moduleTypes as $type)
  {
   ?>
   <div class="field">
   <div class="title"><?=$lang->t($type)?> modules</div>
    <div class="input">
   <?
   foreach(modules(strtolower($type)) as $module)
   {
    if(!in_array($module, $modules))
    {
     $d=Data::cache($module, "view", "all", Array("skipCheckTables" => true, "skipSetRequest" => true, "skipPostInit" => true));

     if($d->tableExists())
     {
      $modules[]=$d->module;

      if($d->plugin&&$plugin!=$d->plugin->name)
      {
       if($plugin)
        print "<br/>";

       $d->plugin->readInfo();
       $plugin=$d->plugin->name;

       print $d->plugin->title."<br/>";
      }

      print $f->checkbox(in_array($d->module, $exportModules), $d->title, "export[modules][]", $d->module)."<br/>\n";
     }
    }
   }
   ?>
   </div>
  </div>
  <?
  }
  unset($moduleTypes, $type, $module);
 ?>

 <div class="field">
  <div class="title">Submit</div>
  <div class="input">
  <?
   print $f->input("submit", "export[submit]", "Export", "form submit");
  ?>
  </div>
 </div>

 <div class="separator">&nbsp;</div>
<?
 print $f->end()."\n";
 unset($f);

?>
 <?if($e->any("note")){?>
  <h2>Log</h2>
  <div class="text">
   <?=$e->show("note")?>
  </div>
 <?}?>

 <?if($e->any("note")){?>
  <h2>Errors</h2>
  <div class="text">
   <?=$e->show("error")?>
  </div>
 <?}?>

 <?if(isset($export)&&$export){?>
  <h2>Output</h2>
  <div class="export">
   <pre><?=$export?></pre>
  </div>
 <?}

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
