<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/sync/import/logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."functions.php");
 require_once($_jasPath["include"]."csv.php");
 require_once($_jasPath["include"]."fs.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $methods=Array("auto" => "Auto", "csv" => "CSV");
 //$methods=Array("auto" => "Auto", "xml" => "XML", "csv" => "CSV", "sql" => "MySQL");
 $outputs=Array("file" => "File", "screen" => "Screen");

 if(in_array(request("import", "method"), array_keys($methods)))
  $method=request("import", "method");
 else
  $method="auto"; //default import method

 if(is_array(request("import", "modules")))
  $importModules=request("import", "modules");
 else
  $importModules=Array();

 if(request("import", "submit")||request("import", "analyze"))
 {
  if(request("import", "tmp_name", "file", "FILES"))
  {
   if($method=="auto")
   {
    switch(request("import", "type", "file", "FILES"))
    {
     case "text/xml":
     {
      $method="xml";
      break;
     }
     case "text/csv":
     case "text/comma-separated-values":
     {
      $method="csv";
      break;
     }
     default: break;
    }
   }

   $input=FS::read(request("import", "tmp_name", "file", "FILES"));
  }
  else if(request("import", "text"))
   $input=request("import", "text");
  else
   $e->add("No input provided");

  if(!$e->any("fatal"))
  {
   if($method=="auto")
   {
    $csv=new CSV();

    if(substr($input, 0, 5)=="<?xml")
     $method="xml";
    else if(preg_match("/INSERT INTO/i", $input))
     $method="mysql";
    else if(preg_match("/[\n\r\sa-z0-9\"]+".preg_quote($csv->split)."/", $input))
     $method="csv";
    else
     $e->add("Unable to auto detect method");
   }

   if(!$e->any("fatal"))
   {
    switch($method)
    {
     case "csv":
     {
      if(!isset($csv))
       $csv=new CSV();

      $csv->detectLineBreaks($input);

      if($l=preg_match_all("/".preg_quote($csv->quote)."Module".preg_quote($csv->quote.$csv->split.$csv->quote)."([a-z0-9_]{1,51})".preg_quote($csv->quote.$csv->linebreak)."/i", $input, $m, PREG_OFFSET_CAPTURE)) //multi modules structure (JAS export)
      {
       $importModules=Array();

       for($c=0;$c<$l;$c++)
       {
        $module=$m[1][$c][0];
        $importModules[]=$module;

        $start=$m[0][$c][1]+strlen($m[0][$c][0]);

        if($c+1>=$l) //last entry
         $end=strlen($input);
        else
         $end=$m[0][$c+1][1];

        $csv->clear();
        if($csv->parse(substr($input, $start, $end-$start), true)) //use header line as column names
        {
         $e->add("Importing ".$csv->vmax." values for module: \"".$module."\"", "note");

         if(request("import", "submit"))
         {
          $d=Data::cache($module, "add", "item"); //always add, initial insert may not set IDs reliably therefore updating on ID might overwrite incorrect values
          $d->clearValues();

          $x=0;
          while($csv->next())
          {
           foreach($csv->v as $k => $v)
            $d->setValue($k, $v, $x);

           $x++;
          }

          $d->submit();
          $e->add($d->e);
         }
        }
       }
      }
      else //normal format
      {
       $csv->clear();

       //detect header line
       if(!preg_match("/^(".preg_quote($csv->linebreak).")*(".preg_quote($csv->quote)."[a-z0-9_]{1,25}".preg_quote($csv->quote)."(".preg_quote($csv->split).")?)+".preg_quote($csv->linebreak)."/i", $input, $m)) //only (quoted) field names on first (relevant) line
        $e->add("No header line found, unable to map information to module fields", "error");
       else
       {
        $csv->parse($input, true); //use header line

        if(sizeof($importModules)==1)
         $e->add("Importing ".$csv->vmax." values for module: \"".$importModules[0]."\"", "note");

        if(request("import", "submit"))
        {
         if(sizeof($importModules)!=1)
          $e->add("Please select a module for importing these values", "error");
         else
         {
          $d=Data::cache($importModules[0], "add", "item"); //always add, initial insert may not set IDs reliably therefore updating on ID might overwrite incorrect values
          $d->clearValues();

          $x=0;
          while($csv->next())
          {
           foreach($csv->v as $k => $v)
            $d->setValue($k, $v, $x);

           $x++;
          }

          $d->submit();
          $e->add($d->e);
         }
        }
        else if(sizeof($importModules)!=1)
         $e->add("Please select a module for importing these values", "warning");
       }
      }

      $e->add($csv->e);
      break;
     }
     case "xml":
     case "sql":
     default:
     {
      $e->add("Import method \"".$method."\" not implemented");
      break;
     }
    }
   }
  }
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
