<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/sync/syncData/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."mutilate.php");
 require_once($_path["include"]."http.php");
 require_once($_path["include"]."form.php");
 require_once($_path["include"]."cms.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject, needed for reading module tree

 if(isset($jascms))
  print $jascms->show();
 else
 {
  ?><h1>Synchronisation</h1><?

  if($e->any())
  {
   print $e->show();
   $e->clear();
  }

  $f=new Form();
  $ds=Data::cache("syncSettings", "view", "item");

  if(!request("s")&&!request("analyze"))
  {
   if($ds->getValue("nr"))
    if(!$ds->get())
     $ds->next();
  }
  
  print $f->start();
  print $f->input("hidden", "cms", 0);
  if(!$_useModRewrite)
  {      
   print $f->input("hidden", "p[]", $_page[0]);
   print $f->input("hidden", "p[]", $_page[1]);
  }      

  $cms=new CMS();
  $cms->setDataForm($ds, $f);

  foreach($ds->check("use", "form") as $k)
   print $cms->field($k);

  ?>
   <div class="field">
    <div class="title">Password</div>
    <div class="input"><?=$f->input("password", "password", request("password"))?></div>
   </div>
   <div class="field">
    <div class="title">Submit</div>
    <div class="input">
     <?=$f->input("submit", "analyze", "Analyze", "form submit")?>
     <?=$f->input("submit", "s", "Synchronize", "form submit", false, (request("s")?"disabled":""))?>
     <?=$f->input("submit", "s", "Save", "form submit", false, "onclick=\"this.form.cms.value=1; this.form.a.value='edit';\"")?>
    </div>
   </div>
  <?

  flush(); 

  if((request("s")||request("analyze"))&&isset($_REQUEST["modules"])&&is_array($_REQUEST["modules"]))
  {
   $sync_method=strtolower(request("method"));
   ?>
   <div class="separator">&nbsp; </div>

   <h2>Synchronization: 
   <?
    if($sync_method=="source")
     print preg_replace("!^http://([^/]+).*!", "\\1", request("url"))." =&gt; ".$_SERVER["SERVER_NAME"];
    else
     print $_SERVER["SERVER_NAME"]." =&gt; ".preg_replace("!^http://([^/]+).*!", "\\1", request("url"));
   ?></h2><?

   $http=new DataHTTP(request("url"), request("project"), request("username"), request("password"));

   $total=0;
   $dSource=Array();

   if($modules=request("modules", 0))
   {
    foreach($modules as $module)
    {
     if(request("s")) //don't convert for submitting
     {
      $dSource[$total]=Data::cache($module, "view", "all", Array("format" => "sql"));
      $dSource[$total]->setShowFields($dSource[$total]->check("use", "sql"));

      if($id=$dSource[$total]->getID())
      {
       $dSource[$total]->extra="item";

       $c=0;
       if(isset($_REQUEST[$module]))
       {
        foreach($_REQUEST[$module]["sync_action"] as $k => $v)
        {
         if($v!="nothing")
          $dSource[$total]->setValue($id, $_REQUEST[$module]["sync_id"][$k], $c++);
        }
       }
      }

      $dSource[$total]->setValue("s", false);
     }
     else //analyze
     {
      $dSource[$total]=Data::cache($module, "view", "all");
      unset($_REQUEST[$module]); //reset sync actions 
     }

     $http->addData($dSource[$total]);
   
     $total++;
    }
   }

   if(!$http->send(request("compress"))) //send data request
   {
    $e->add($http->e);
    print "Remote error(s):<br/>\n".$e->show("fatal");
   }
   else
   {
    //compare data request results
    if($http->sizeofData()!=$total)
     $e->add("Number of replied modules does not match");
    else
    {
     for($c=0;$c<$http->sizeofData();$c++)
     {
      $dTarget[$c]=&$http->getData($c);

      if($dTarget[$c]->module!=$dSource[$c]->module)
       $e->add("Reply module \"".$dTarget[$c]->module."\" does not match original module \"".$dSource[$c]->module."\"");
     }
    }

    if($e->any())
     print $e->show();
    else
    {
     unset($e);

     if(request("s")) //submitting data
     {?>
      <h3>Overview</h3>
      <table class="overview sync"> 
       <tr><th>Module</th><th>Added</th><th>Updated</th><th>Delete</th><th>Ignored</th><th>Total</th></tr>
     <?}

     for($c=0;$c<$total;$c++) //loop though all modules
     {
      $dSync[$c]=Data::cache("sync", "sync", $sync_method, Array("request" => $dSource[$c]->module));

      if(!$dSource[$c]->get()) //broken modules ignored
       continue;

      if($dSync[$c]->e->any()||!$dSync[$c]->sync($dSource[$c], $dTarget[$c]))  //compare data objects
      {
       if(request("s")) //submitting data
        print "<tr><td>".$dSource[$c]->title."</td><td colspan=\"5\">".$dSync[$c]->e->show()."</td></tr>";
       else
       {
        ?><h3><?=$dSource[$c]->title?></h3><?
        print $dSync[$c]->e->show();
       }
      }
      else if(request("s")) //submitting data
      {
       $e=new Error();
       $actions=Array("add", "edit", "delete", "nothing");

       foreach($actions as $a)
       {
        $d[$a]=Data::cache($dSource[$c]->module, $a, "item", Array("format" => "sql"));
        $d[$a]->vmax=0;
       }

       $id=$dSource[$c]->getID();

       while($dSync[$c]->next())
       {
        if($id===false)
         $a=$dSync[$c]->v["sync_action"];
        else if(($sync_action_index=array_search($dSync[$c]->v["nr"][$id], $_REQUEST[$dSource[$c]->module]["sync_id"]))!==false)
         $a=$_REQUEST[$dSource[$c]->module]["sync_action"][$sync_action_index];
        else
         $a="nothing";

        if($a=="delete"||$a=="nothing")
        {
         $vmax=$d[$a]->vmax; //vmax handled in setValue
         foreach($d[$a]->check("properties", "identifier") as $id)
          $d[$a]->setValue($id, $dSync[$c]->v["nr"][$id], $vmax);

        }
        else
        {
         if($sync_method=="source")
         {
          for($entry=0;$entry<$dTarget[$c]->vmax;$entry++)
          {
           $found=true;
           foreach($dTarget[$c]->check("properties", "identifier") as $id)
            if($dTarget[$c]->getValue($id, $entry)!=$dSync[$c]->v["nr"][$id])
             $found=false;
           
           if($found)
           {
            $vmax=$d[$a]->vmax; //vmax handled in setValue
            foreach($d[$a]->check("use", "sql") as $name)
             if(array_key_exists($entry, $dTarget[$c]->field[$name]["value"]))
              $d[$a]->setValue($name, $dTarget[$c]->field[$name]["value"][$entry], $vmax);
           }
          }
         }
         else if($sync_method=="target")
         {
          for($entry=0;$entry<$dSource[$c]->vmax;$entry++)
          {
           $found=true;
           foreach($dSource[$c]->check("properties", "identifier") as $id)
            if($dSource[$c]->getValue($id, $entry)!=$dSync[$c]->v["nr"][$id])
             $found=false;
           
           if($found)
           {
            $vmax=$d[$a]->vmax; //vmax handled in setValue
            foreach($d[$a]->check("use", "sql") as $name)
             if(array_key_exists($entry, $dSource[$c]->field[$name]["value"]))
              $d[$a]->setValue($name, $dSource[$c]->field[$name]["value"][$entry], $vmax);
           }
          }
         }
        }
       }
       
       if($sync_method=="source") // submit data changes
       {
        foreach($actions as $a)
        {
         if($a!="nothing"&&$d[$a]->vmax>0)
          if(!$d[$a]->submit())
           $e->add($d[$a]->e);
        }
       }
       else if($sync_method=="target") //send new data objects to target for submit
       {
        $send=false;
        $httpSubmit=new DataHTTP(request("url"), request("project"), request("username"), request("password"));

        foreach($actions as $a)
        {
         if($a!="nothing"&&$d[$a]->vmax>0)
         {
          $d[$a]->addField("s", "text", "form");
          $d[$a]->setValue("s", "submit");

          $httpSubmit->addData($d[$a]);
          $send=true;
         }
        }

        if($send)
        {
         if(!$httpSubmit->send(request("compress"))) 
          $e->add($httpSubmit->e);
         else
         {
          $x=0;
          foreach($actions as $a)
          {
           if($a!="nothing"&&$d[$a]->vmax>0)
            $d[$a]=&$httpSubmit->getData($x++);
          }
         }
        }
       }

       print "<tr><td>".$d[$a]->title."</td>";
       if($e->any("fatal"))
        print "<td colspan=\"5\">".$e->show("fatal")."</td></tr>";
       else
       {
        foreach($actions as $a)
        {
         if($a!="nothing"&&$d[$a]->e->any("fatal"))
          print "<td>".$d[$a]->e->show("fatal")."</td>";
         else
          print "<td>".$d[$a]->vmax."</td>";
        }
        print "<td>".$dSync[$c]->vmax."</td></tr>";
       }

       flush(); //print data to keep connection running

       unset($actions, $a, $d, $x, $e);
      }
      else //don't submit, just show the analysis
      {
       ?>
       <h3><?=$dSource[$c]->title?></h3>

       <table class="overview sync">
       <tr>
        <th class="nr">ID</th>
        <th class="source">Object</th>
        <th class="nr">Cat</th>
        <th class="text">Title</th>
        <th class="date">Updated</th>
        <th class="status">Status</th>
        <th class="action">Action</th>
       </tr>
       <?

       $showing=0;
       while($dSync[$c]->next())
       {
        if($dSync[$c]->v["sync_status"]=="unchanged"&&!request("showUnchanged"))
        {
         print $f->input("hidden", $dSource[$c]->module."[sync_action][]", $dSync[$c]->v["sync_action"]);
         print $f->input("hidden", $dSource[$c]->module."[sync_id][]", join(",", $dSync[$c]->v["nr"]));
         continue;
        }

        if($dSync[$c]->v["sync_status"]=="target is newer"||$dSync[$c]->v["sync_status"]=="not in source")
        {
         $target="hilite";
         $source="lolite";
        }
        else if($dSync[$c]->v["sync_status"]=="unchanged")
        {
         $target="lolite";
         $source="lolite";
        }
        else
        {
         $target="lolite";
         $source="hilite";
        }

        ?>
        <tr>
         <td class="nr" rowspan="2"><?=join(",", $dSync[$c]->v["nr"])?></td>
         <?

         if($dSync[$c]->v["sync_status"]!="not in source")
         {
          $ids=$dSource[$c]->check("properties", "identifier");
          for($dSource[$c]->vc=0;$dSource[$c]->vc<$dSource[$c]->vmax;$dSource[$c]->vc++)
          {
           $found=true;
           for($x=0;$x<sizeof($ids);$x++)
            if($dSource[$c]->field[$ids[$x]]["value"][$dSource[$c]->vc]!=$dSync[$c]->v["nr"][$ids[$x]])
             $found=false;
           
           if(!$found)
            continue;

           $dSource[$c]->next();

           print "<td class=\"source ".$source."\">Source</td>";
           print "<td class=\"nr ".$source."\">".(isset($dSource[$c]->v["catnr"])?$dSource[$c]->v["catnr"]:"")."</td>";
           print "<td class=\"text ".$source."\">".$dSource[$c]->v("title")."</td>";
           print "<td class=\"date ".$source."\">".(isset($dSource[$c]->v["updated"])?$dSource[$c]->v["updated"]:"")."</td>";

           break;
          }
         }
         else
          print "<td colspan=\"4\">&nbsp;</td>";

         ?>
         <td class="status" rowspan="2"><?=$dSync[$c]->v["sync_status"]?></td>
         <td class="action" rowspan="2"><?=$f->input("hidden", $dSource[$c]->module."[sync_id][]", join(",", $dSync[$c]->v["nr"]))?><?=$f->select(false, $dSource[$c]->module."[sync_action][]", $dSync[$c]->syncOptions[$sync_method][$dSync[$c]->v["sync_status"]], $dSync[$c]->v["sync_action"])?></td>
        </tr>
       <?
         if($dSync[$c]->v["sync_status"]!="not in target")
         {
          $ids=$dTarget[$c]->check("properties", "identifier");
          for($dTarget[$c]->vc=0;$dTarget[$c]->vc<$dTarget[$c]->vmax;$dTarget[$c]->vc++)
          {
           $found=true;
           for($x=0;$x<sizeof($ids);$x++)
            if($dTarget[$c]->field[$ids[$x]]["value"][$dTarget[$c]->vc]!=$dSync[$c]->v["nr"][$ids[$x]])
             $found=false;
           
           if(!$found)
            continue;

           $dTarget[$c]->next();

           print "<tr>";
           print "<td class=\"target ".$target."\">Target</td>";
           print "<td class=\"nr ".$target."\">".(isset($dTarget[$c]->v["catnr"])?$dTarget[$c]->v["catnr"]:"")."</td>";
           print "<td class=\"text ".$target."\">".$dTarget[$c]->v("title")."</td>";
           print "<td class=\"date ".$target."\">".(isset($dTarget[$c]->v["updated"])?$dTarget[$c]->v["updated"]:"")."</td>";
           print "</tr>";

           break;
          }
         }
         else
          print "<tr><td colspan=\"4\">&nbsp;</td></tr>";
        $showing++;
       }
      ?>
      <tr><td colspan="7">
      <?
       print "Showing ".$showing." of ".$dSync[$c]->vmax." ";

       if($showing==0&&$dSync[$c]->vmax>0)
        print "(Synchronized)";
       else if($dSync[$c]->vmax==0)
        print "(Empty)";
      ?>
      </td></tr>
      </table>
      <?
      }
     }

     if(request("s")) 
     {
      print "</table>";
     }
     else
     {
     ?>
     <div class="field">
      <div class="title">Submit</div>
      <div class="input">
       <?=$f->input("submit", "analyze", "Analyze", "form submit")?>
       <?=$f->input("submit", "s", "Synchronize", "form submit", false, (request("s")?"disabled":""))?>
      </div>
     </div>
     <?
     }
    }
   }
  }
 
  print $f->end();
  ?>

  <?if(isset($http)){?>
  <h3>Data request</h3>
  Send: <?=Mutilate::humanReadableFileSize($http->bytesSend)?> (<?=Mutilate::humanReadableFileSize($http->bytesSend/$http->requestTime)?>/s)<br/>
  Received: <?=Mutilate::humanReadableFileSize($http->bytesReceived)?> (<?=Mutilate::humanReadableFileSize($http->bytesReceived/$http->requestTime)?>/s)<br/>
  Time: <?=round($http->requestTime, 3)?>s<br/>
  <?}?>

  <?if(isset($httpSubmit)){?>
  <h3>Data submit</h3>
  Send: <?=Mutilate::humanReadableFileSize($httpSubmit->bytesSend)?> (<?=Mutilate::humanReadableFileSize($httpSubmit->bytesSend/$httpSubmit->requestTime)?>/s)<br/>
  Received: <?=Mutilate::humanReadableFileSize($httpSubmit->bytesReceived)?> (<?=Mutilate::humanReadableFileSize($httpSubmit->bytesReceived/$httpSubmit->requestTime)?>/s)<br/>
  Time: <?=round($httpSubmit->requestTime, 3)?>s<br/>
  <?}?>
  <?
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
