<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/config/logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cache.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if(request("cms")||in_array("cms", $_page))
 {
  $jascms=new JASCMS();

  if($jascms->submit())
  {
   Config::reload();
   $jascms->data->e->add("Configuration reloaded", "note");
  }
 }
 else if($_config["rootnr"]==$_config["usernr"])
 {
  if($repository=request("repository"))
  { 
   if(($name=request("install"))&&isset($_config["repositories"][$repository])&&in_array("Repositories", $_config["repositories"][$repository]["content"]))
   {
    $d=Data::cache("onlineRepositories", "view", "all", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
    $d->setValue("name", $name);

    if($d->get()&&$d->next())
    {
     if($d->v["name"]==$name)
     {
      $dc=Data::cache("configRepositories", "add", "item");
      $dc->setValue("name", $d->v["name"]);
      $dc->setValue("url", $d->v["url"]);
      $dc->setValue("content", $d->v["content"]);

      if(!$dc->submit())
      {
       $e->add("Installing repository: \"".$name."\" failed", "error");
       $e->add($dc->e);
      }
      else
      {
       Config::reload();
       $e->add("Repository: \"".$name."\" installed", "note");
       $e->add("Configuration reloaded", "note");
      }

      unset($dc);
     }
    }

    unset($d);
   }
   else if(($name=request("update"))&&isset($_config["repositories"][$repository])&&in_array("Repositories", $_config["repositories"][$repository]["content"]))
   {
    $d=Data::cache("onlineRepositories", "view", "all", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
    $d->setValue("name", $name);

    if($d->get()&&$d->next())
    {
     if($name&&$d->v["name"]==$name)
     {
      $dc=Data::cache("configRepositories", "view", "all");
      $dc->setValue("name", $name);

      if(!$dc->get()||!$dc->next())
      {
       $e->add("Updating repository: \"".$name."\" failed, repository not found", "error");
       $e->add($dc->e);
      }
      else
      {
       $nr=$dc->v["nr"];
       $dc->clearValues();
       $dc->setAction("edit");
       $dc->setExtra("item");

       $dc->setValue("nr", $nr);
       $dc->setValue("url", $d->v["url"]);
       $dc->setValue("content", $d->v["content"]);

       if(!$dc->submit())
       {
        $e->add("Updating repository: \"".$name."\" failed", "error");
        $e->add($dc->e);
       }
       else
       {
        Config::reload();
        $e->add("Repository: \"".$name."\" updated", "note");
        $e->add("Configuration reloaded", "note");
       }

       unset($nr);
      }

      unset($dc);
     }
    }

    unset($d);
   }
  }

  if(($name=request("delete")))
  {
   $dc=Data::cache("configRepositories", "view", "all");
   $dc->setValue("name", $name);

   if(!$dc->get()||!$dc->next())
   {
    $e->add("Deleting repository: \"".$name."\" failed, repository not found", "error");
    $e->add($dc->e);
   }
   else
   {
    $nr=$dc->v["nr"];
    $dc->clearValues();
    $dc->setAction("delete");
    $dc->setExtra("item");

    $dc->setValue("nr", $nr);

    if(!$dc->submit())
    {
     $e->add("Deleting repository: \"".$name."\" failed", "error");
     $e->add($dc->e);
    }
    else
    {
     Config::reload();
     $e->add("Repository: \"".$name."\" deleted", "note");
     $e->add("Configuration reloaded", "note");
    }

    unset($nr);
   }

   unset($dc);
  }

  unset($repository, $name);
 }

 if(request("clearMemoryCacheData"))
 {
  $cache=new Cache("memory");
  foreach($cache->search("DATA::CACHE(".$_jses["project"].",") as $key)
   $cache->remove($key);

  unset($cache, $key);
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
