<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/config/main.repositories.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


?>
 <h1><?=$lang->t("Online repositories")?></h1>
 <?=$e->show();?>
 <table class="overview repositories">
  <tr>
   <th class="repository"><?=$lang->t("Repository")?></th>
   <th class="name"><?=$lang->t("Name")?></th>
   <th class="url"><?=$lang->t("Repository URL")?></th>
   <th class="content"><?=$lang->t("Content")?></th>
   <th class="maintainer"><?=$lang->t("Maintainer")?></th>
   <th class="updated"><?=$lang->t("Last update")?></th>
   <th class="status"><?=$lang->t("Status")?></th>
   <th class="action" colspan="2"><?=$lang->t("Action")?></th>
  </tr>
 <?
 foreach(array_keys($_config["repositories"]) as $repository) 
 {
  if(!in_array("Repositories", $_config["repositories"][$repository]["content"]))
   continue;

  $dl=Data::cache("configRepositories", "view", "all");
  $dl->setShowFields("name", "url", "content");

  $dr=Data::cache("onlineRepositories", "view", "all", Array("db" => $_config["repositories"][$repository]["xmliurl"]));
  $dr->setShowFields("name", "url", "content", "maintainerName", "maintainerEmail", "updated");
  $dr->addMutilation("updated", "dateConvert", $_config["dateformat"]);


  if($_useModRewrite)
   $url=$baseURL."?";
  else
   $url=$baseURL."&amp;";

  if(!$dl->get())
  {
   ?>
    <tr>
     <td class="repository"><?=$repository?><br/><a href="<?=$_config["repositories"][$repository]["url"]?>" rel="external" title="Go to <?=$repository?>"><?=$_config["repositories"][$repository]["url"]?></a></td>
     <td colspan="7"><?=$dl->e->show()?></td>
     <td class="action"><a href="<?=$url?>repository&amp;delete=<?=$repository?>" title="Delete <?=$repository?>"><?=icon("delete")?></a></td>
    </tr>
   <?
  }
  else if(!$dr->get())
  {
   ?>
    <tr>
     <td class="repository">
      <?=$repository?><br/>
      <a href="<?=$_config["repositories"][$repository]["url"]?>" rel="external" title="Go to <?=$repository?>"><?=$_config["repositories"][$repository]["url"]?></a>
     </td>
     <td colspan="7"><?=$dr->e->show()?></td>
     <td class="action"><a href="<?=$url?>repository&amp;delete=<?=$repository?>" title="Delete <?=$repository?>"><?=icon("delete")?></a></td>
    </tr>
   <?
  }
  else
  {
   while($dr->next())
   {
    ?>
    <tr>
     <?if($dr->vc==1){?>
      <td class="repository" rowspan="<?=$dr->vmax?>"><?=$repository?><br/><a href="<?=$_config["repositories"][$repository]["url"]?>" rel="external" title="Go to <?=$repository?>"><?=$_config["repositories"][$repository]["url"]?></a></td>
     <?}?>

     <td class="name"><?=$dr->v["name"]?></td>
     <td class="url"><a href="<?=$dr->v["url"]?>" rel="external" title="Go to <?=$dr->v["name"]?>"><?=$dr->v["url"]?></a></td>
     <td class="content"><?=implode(", ", $dr->v["content"])?></td>
     <td class="maintainer"><a href="mailto:<?=$dr->v["maintainerEmail"]?>" title="Email <?=$dr->v["maintainerName"]?>"><?=$dr->v["maintainerName"]?></a></td>
     <td class="updated"><?=$dr->v["updated"]?></td>
     <?

     $found=false;
     $dl->reset();
     while($dl->next())
     { 
      if($dl->v["name"]==$dr->v["name"]) //match
      {
       if($dl->v["url"]!=$dr->v["url"]||$dl->v["content"]!=$dr->v["content"]) //changed
       {
        print "<td class=\"status\">".$lang->t("Changed")."</td>\n";
        print "<td class=\"action\"><a href=\"".$url."repository=".$repository."&amp;update=".$dr->v["name"]."\" title=\"Update ".$dr->v["name"]."\">".icon("edit", "repository")."</a></td>\n";
       }
       else
       {
        if(isset($_config["repositories"][$dr->v["name"]]))
         print "<td class=\"status\">".$lang->t("Active")."</td>\n";
        else
         print "<td class=\"status\">".$lang->t("Installed")."</td>\n";

        print "<td class=\"action\"><a href=\"".$url."repository=".$repository."&amp;delete=".$dr->v["name"]."\" title=\"Delete ".$dr->v["name"]."\">".icon("delete", "repository")."</a></td>\n";
       }

       $found=true;
       break;
      }
     }

     if(!$found)
     {
      print "<td class=\"status\">".$lang->t("Not installed")."</td>\n";
      print "<td class=\"action\"><a href=\"".$url."repository=".$repository."&amp;install=".$dr->v["name"]."\" title=\"Install ".$dr->v["name"]."\">".icon("add", "repository")."</a></td>\n";
     }
     ?>

     <?if($dr->vc==1){?>
      <td class="action" rowspan="<?=$dr->vmax?>"><a href="<?=$url?>repository&amp;delete=<?=$repository?>" title="Delete <?=$repository?>"><?=icon("delete")?></a></td>
     <?}?>

    </tr>
    <?
   }
  }
  unset($dl, $dr);
 }
 ?></table><?

 unset($repository);
?>
