<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/language/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_jasPath["include"]."plugin.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $translations=Array();
 foreach(Array("normal", "regexp") as $type)
 {
  foreach(array_keys($lang->language[$type]) as $from)
  {
   foreach(array_keys($lang->language[$type][$from]) as $to)
   {
    if(!isset($translations[$from.$to]))
    {
     $translations[$from.$to]["from"]=$from;
     $translations[$from.$to]["to"]=$to;
     $translations[$from.$to]["count"]=sizeof($lang->language[$type][$from][$to]);
    }
    else
     $translations[$from.$to]["count"]+=sizeof($lang->language[$type][$from][$to]);
   }
  }
 }

 $files=Array();
 foreach($lang->loadedFiles as $file => $mtime)
  $files[]=Array("name" => $file, "modtime" => $mtime);

 require($_jasPath["project"]["include"]."switch.php"); //default

 ?>
  <h1><?=$lang->t("Language")?></h1>
  <?
   if($e->any())
    print $e->show();
  ?> 
  <table class="overview language">
  <tr>
   <th><?=$lang->t("Base language")?></th>
   <th><?=$lang->t("Translation language")?></th>
   <th><?=$lang->t("Number of translations")?></th>
  </tr>

  <?foreach($translations as $t){?>
  <tr>
   <td class="from"><?=strtoupper($t["from"])?></td>
   <td class="to"><?=strtoupper($t["to"])?></td>
   <td class="count"><?=$t["count"]?></td>
  </tr>
  <?}?>

  </table><br/>

  <table class="overview language">
  <tr>
   <th><?=$lang->t("File")?></th>
   <th><?=$lang->t("Last update")?></th>
  </tr>

  <?foreach($files as $f){?>
  <tr>
   <td class="file"><?=$f["name"]?></td>
   <td class="modtime"><?=date($_config["datetimeformat"], $f["modtime"])?></td>
  </tr>
  <?}?>

  </table>
 <?
 unset($translations, $files, $t, $f);
?>
