<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/setup/config.logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cms.php");

 require($_jasPath["project"]["include"]."switch.php"); //currentProject
  
 if(request("title")) //submit
 {
  $config=Data::cache("config", "edit", "item");

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $next=$config->submit();
  $_config["usernr"]=$usernr;
  unset($usernr);

  Config::reload(); //reload config, keeping the current user and group

  $e->add($config->e);

  if($next)
   unset($config);
 }
 else
 {
  $config=Data::cache("config", "view", "all");
  $config->clearValues();
  $config->get();

  if($config->next())
  {
   $config->setAction("edit");
   $config->setExtra("item");

   $e->add("This is an existing configuration", "note");
   $e->add("Only change stuff if you know what you're doing", "note");
  }
  else //new config
  {
   $config->e->clear();

   //set default values
   foreach(array_keys($config->field) as $field)
    if($config->check("use", "sql", $field)||$config->check("use", "form", $field))
     $config->setDefaultValue($field);

   $config->setValue("title", $_jses["project"]);

   //enable logging if log table is created
   $log=Data::cache("log");
   if(!$log->e->any("fatal"))
    $config->setValue("logging", true);
   else
    $config->setValue("logging", false);

   unset($log);

   $config->setAction("add");
   $config->setExtra("item");
   
   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   $config->submit();
   $_config["usernr"]=$usernr;
   unset($usernr);

   Config::reload(); //reload config, keeping the current user and group

   $e->add("This is the initial configuration", "note");
   $e->add("Only change stuff if you know what you're doing", "note");
  }
 }

 $cms=new CMS();
 $cms->setData($config);
 $cms->setForm($f);

 if($cms->e->any())
  $e->add($cms->e);

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
