<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/setup/data.logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if(
   ($rootuser=request("rootuser"))&&
   ($rootpass=request("rootpass"))&&
   ($rootpassverify=request("rootpassverify"))&&
   ($anonuser=request("anonuser"))
  ) 
 {
  //update anonymous user information
  $tmp=Data::cache($_config["usermodule"], "edit", "item");
  $f_username=$tmp->check("properties", "username");
  $f_username=$f_username[0];
  $f_password=$tmp->check("properties", "password");
  $f_password=$f_password[0];

  $tmp->setValue("nr", $_config["anonnr"]);
  $tmp->setValue($f_username, $anonuser);

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $success=$tmp->submit();
  $_config["usernr"]=$usernr;

  if($success)
   $e->add("Anonymous user successfully updated", "note");
  else
   $e->add($tmp->e);

  //update root user information
  $tmp->clearValues(); 
  $tmp->setValue("nr", $_config["rootnr"]);
  $tmp->setValue($f_username, $rootuser);
  $tmp->setValue($f_password, $rootpass);
  $tmp->setValue("verify".$f_password, $rootpassverify);

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $success=$tmp->submit();
  $_config["usernr"]=$usernr;

  if($success)
   $e->add("Root user successfully updated", "note");
  else
   $e->add($tmp->e);

  unset($usernr);

  if(!$e->any("fatal"))
   $next=true;

  unset($f_username, $f_password);
 }
 else
 {
  //get top and users category
  $cats=Data::cache("categories", "view", "all");
  $cats->setShowFields("nr", "catnr", "module");

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $cats->get();
  $_config["usernr"]=$usernr;
  
  $usercat=false;
  $topcat=false;
  while($cats->next())
  {
   if($cats->v["catnr"]==0)
    $topcat=$cats->v["nr"]; 
   if((is_array($cats->v["module"])&&in_array($_config["usermodule"], $cats->v["module"]))||$cats->v["module"]==$_config["usermodule"])
    $usercat=$cats->v["nr"]; 
  }

  if(!$topcat||!$usercat)
  {
   $cats->action="add";
   $cats->extra="item";
   $cats->field["catnr"]["min"]=0;

   //add top category
   if(!$topcat)
   {
    $cats->e->clear();
    $cats->clearValues();
    $cats->setValue("nr", 1);
    $cats->setValue("catnr", 0);
    $cats->setValue("name", $_config["title"]);

    $usernr=$_config["usernr"]; //sudo
    $_config["usernr"]=$_config["rootnr"];
    $success=$cats->submit();
    $_config["usernr"]=$usernr;

    if($success)
     $e->add("Top category successfully created", "note");
    else
     $e->add($cats->e);
    
    $topcat=$cats->getValue("nr");
   }

   //add users category
   if(!$usercat)
   {
    $cats->e->clear();
    $cats->clearValues();
    $cats->setValue("catnr", $topcat);
    $cats->setValue("name", "Users");
    $cats->setValue("module", $_config["usermodule"]);

    $usernr=$_config["usernr"]; //sudo
    $_config["usernr"]=$_config["rootnr"];
    $success=$cats->submit();
    $_config["usernr"]=$usernr;

    if($success)
     $e->add("Users category successfully created", "note");
    else
     $e->add($cats->e);
    
    $usercat=$cats->getValue("nr");
   }
  }

  //get anonymous user 
  $users=Data::cache($_config["usermodule"], "view", "item");
  $f_username=$users->check("properties", "username");
  $f_username=$f_username[0];
  $f_password=$users->check("properties", "password");
  $f_password=$f_password[0];

  $users->setShowFields("nr", $f_username);
  $users->setValue("nr", $_config["anonnr"]);

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $users->get();
  $_config["usernr"]=$usernr;

  if($users->next()) //anonymous found
   $anonuser=$users->v[$f_username];
  else 
  {
   //add anonymous user without password
   $anonuser="anonymous";
   $tmp=Data::cache($_config["usermodule"], "add", "item", Array("format" => "sql"));
   $tmp->field["nr"]["properties"]=preg_replace("/owner;/", "", $tmp->field["nr"]["properties"]);

   $tmp->field[$f_password]["min"]=0;
   $tmp->field[$f_password]["type"]="text";
   unset($tmp->field["verify".$f_password]);

   $tmp->setValue("nr", $_config["anonnr"]);
   $tmp->setValue("catnr", $usercat);
   $tmp->setValue($f_username, $anonuser);
   $tmp->setValue($f_password, "");

   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   $success=$tmp->submit();
   $_config["usernr"]=$usernr;

   if($success)
    $e->add("Anonymous user successfully created", "note");
   else
    $e->add($tmp->e);
  }

  //get root user 
  $users->clearValues();
  $users->setShowFields("nr", "catnr", $f_username);
  $users->setValue("nr", $_config["rootnr"]);

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $users->get();
  $_config["usernr"]=$usernr;

  if($users->next()) //root found
  {
   $rootuser=$users->v[$f_username];

   if($usercat!=$users->v["catnr"]) //set usercat to category that holds root user: this to restore root login capability down below
    $usercat=$users->v["catnr"];
  }
  else
  {
   //add root user without password
   $rootuser="root";
   $tmp=Data::cache($_config["usermodule"], "add", "item", Array("format" => "sql"));
   $tmp->field["nr"]["properties"]=preg_replace("/owner;/", "", $tmp->field["nr"]["properties"]);

   $tmp->field[$f_password]["min"]=0;
   $tmp->field[$f_password]["type"]="text";
   unset($tmp->field["verify".$f_password]);

   $tmp->setValue("nr", $_config["rootnr"]);
   $tmp->setValue("catnr", $usercat);
   $tmp->setValue($f_username, $rootuser);
   $tmp->setValue($f_password, "");

   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   $success=$tmp->submit();
   $_config["usernr"]=$usernr;

   if($success)
    $e->add("Root user successfully created", "note");
   else
    $e->add($tmp->e);
  }

  //get login rights for anonymous user
  $tmp=Data::cache("userRights", "view", "all");
  $tmp->setValue("nr", $_config["anonnr"]);
  $tmp->setValue("catnr", $usercat);

  $usernr=$_config["usernr"]; //sudo
  $_config["usernr"]=$_config["rootnr"];
  $tmp->get();
  $_config["usernr"]=$usernr;

  if(!$tmp->next()||!$tmp->v["rights"][13]) //no rights or no login rights ?
  {
   //add login rights to users category (that holds root user) for anonymous user
   $tmp=Data::cache("categories", "rights", "item");
   $tmp->setValue("nr", $usercat);
   $tmp->setValue("usernr", $_config["anonnr"]);
   $tmp->setValue("userrights", "0000000000000100"); //login rights

   $usernr=$_config["usernr"]; //sudo
   $_config["usernr"]=$_config["rootnr"];
   $success=$tmp->submit();
   $_config["usernr"]=$usernr;

   if($success)
    $e->add("Root login rights granted to anonymous user", "note");
   else
    $e->add($tmp->e);
  }

  unset($tmp, $usernr);

  $rootpass="";
  $rootpassverify="";

  $e->add("Please provide the following information", "note");
  $e->add("User passwords will be stored encrypted in the database", "note");

  unset($f_username, $f_password);
 }
 
 require($_jasPath["project"]["include"]."switch.php"); //default
?>
