<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/setup/modules.logic.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!isset($_jses["currentProject"])||$_jses["currentProject"]!=$_jses["setup"]["project"])
   $_jses["currentProject"]=$_jses["setup"]["project"];

 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 $modules=Array();
 $required=Array("config", "userRights", "groupRights", "users", "usersAdditionalGroups", "categories");

 foreach(modules() as $module)
 {
  $modules[$module]=new Data($module, "database", "create", Array("skipCheckTables" => true));

  foreach(array_keys($modules[$module]->reference) as $ref)
   if($modules[$module]->reference[$ref]["type"]=="*:*")
    $modules[$ref]=&$modules[$module]->reference[$ref]["data"];
 }

 if(request("create"))
 {
  if(request("modules"))
   $create=array_merge($required, request("modules"));
  else
   $create=$required;

  foreach(array_keys($modules) as $module)
  {
   if(in_array($modules[$module]->module, $create))
   {
    $modules[$module]->e=new Error();
    $modules[$module]->addActions("database");
    $modules[$module]->setAction("database");

    if(!$modules[$module]->tableExists())
     $modules[$module]->setExtra("create");
    else if($modules[$module]->validExtra("maintenance", "database"))
     $modules[$module]->setExtra("maintenance");
    else 
     $modules[$module]->setExtra("alter");

    $usernr=$_config["usernr"]; //sudo
    $_config["usernr"]=$_config["rootnr"];
    $success=$modules[$module]->submit();
    $_config["usernr"]=$usernr;
    unset($usernr);

    if(!$success) //failure
     $e->add($modules[$module]->e);
    else //success
     if($modules[$module]->e->errors()!=1||!preg_match("/No changes for.*/i", $modules[$module]->e->getError(0))) //don't add no change errors
      $e->add($modules[$module]->e);

    unset($success);
   }
  } 
  $next=true;
 }
 else
 {
  $e->add("Select the modules you like to use", "note");
  $e->add("You might experience some error due the fact the modules don't exist yet", "note");
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
 
?>
