<?

 /*****************************************************************************
 * Filename: project/jas/include/pages/system/tables/main.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if($_config["rootnr"]!=$_config["usernr"])
 {
  $e->add("Table manipulation only available for root user", "error");
  ?>
   <h1>Database tables manipulation</h1>
   <?=$e->show();?>
  <?
 }
 else 
 {
 /* defaut modules */
  $create=Array("categories", "users", "config", "userRights", "groupRights");

  if(isset($_config["log"]))
   $create[]="log";

  $f=new Form();
  print $f->start()."\n";

  if(!$_useModRewrite)
  {
   print $f->input("hidden", "p[]", $_page[0]);
   print $f->input("hidden", "p[]", $_page[1]);
  }

  $moduleTypes=Array("Plugins", "Project", "System");
 ?>
  <h1>Database tables manipulation</h1>
  <?=$e->show();?>
 <?
  foreach($moduleTypes as $type)
  {
   $modules=modules(strtolower($type));
   ?>
   <table class="overview tables">
    <tr>
     <th class="module"><?=$type?></th>
     <th class="create"><?=$lang->t("Create/Alter")?></th>
     <th class="type"><?=$lang->t("Type")?></th>
     <th class="rows"><?=$lang->t("Rows")?></th>
     <th class="insertID"><?=$lang->t("Insert ID")?></th>
     <th class="created"><?=$lang->t("Created")?></th>
     <th class="updated"><?=$lang->t("Updated")?></th>
    </tr>
   <?
   $moduleCounter=0;

   foreach($modules as $m)
   {
    if(strpos($m, "_pluginInfo")!==false||$m=="empty")
     continue;

    if(($key=array_search($m, $create))!==false)
    {
     unset($create[$key]); 
     $checked=true;
    }
    else
     $checked=false;

    $d=Data::cache($m, "database", "create", Array("skipCheckTables" => true));
    $moduleCounter++;

    $tmp=Array(&$d);
    foreach(array_keys($d->reference) as $ref)
     if($d->reference[$ref]["type"]=="*:*")
      $tmp[]=&$d->reference[$ref]["data"];

    unset($d);
    for($x=0;$x<sizeof($tmp);$x++)
    {
     $d=&$tmp[$x];

     //fix for m2m modules
     $d->setAction("database");
     $d->setExtra("create");
     $d->e->clear();

     $show=true;
     if($d->tableExists())
     {
      $d->setExtra("alter");
      $d->get();

      $show=false;
      for($c=0;$c<$d->e->errors;$c++)
      { 
       if($d->e->getLevel($c)=="note"&&
        !preg_match("/No changes for.*/i", $d->e->getError($c))&&
        !preg_match("/Not removing.*/i", $d->e->getError($c))&&
        !preg_match("/Not shrinking.*/i", $d->e->getError($c))&&
        !preg_match("/Leaving unused.*/i", $d->e->getError($c))
       )
       {
        $show=true;
        break;
       }
      }
     }
     else 
      $d->get();
     ?>

     <tr>
      <td class="module"><div class="tool"><?=$d->title?> <div class="tip"><?=$d->e->show();?></div></div></td>

      <td class="create">
       <?if($d->extra=="create"){?>
        <?=$f->checkbox($checked, "Create", "modules[".$d->module."]", "create")?>
       <?}else if($show){?>
        <?=$f->checkbox(false, "Alter", "modules[".$d->module."]", "alter")?>
       <?}else if($d->tableExists()&&$d->validExtra("maintenance", "database")){?>
        <?=$f->checkbox(false, "Maintenance", "modules[".$d->module."]", "maintenance")?>
       <?}?>
      </td>
     <? 
 
     $d->setAction("database");
     $d->setExtra("info");
     $d->e->clear();

     if($d->get()&&$d->next())
     {
     ?>
       <td class="type"><?=$d->v["info_type"]?></td>
       <td class="rows"><?=$d->v["info_rows"]?></td>
       <td class="insertID"><?=$d->v["info_insertID"]?></td>
       <td class="created"><?=$d->v["info_created"]?></td>
       <td class="updated"><?=$d->v["info_updated"]?></td>
     <? 
     }
     else
     {
      ?><td colspan="5">&nbsp;</td><?
     }

     ?></tr><?
     unset($d);
    }
   }
  ?>
    <tr>
     <td colspan="7">Modules: <?=$moduleCounter?></td>
    </tr>
   </table>
  <?
  }
 ?>
  <div class="field">
   <div class="title">Submit</div>
   <div class="input"><?=$f->input("submit", "s", "Submit", "submit")?></div>
  </div>
  
  <?=$f->end()?>

 <?
  unset($f, $moduleTypes, $type, $m, $checked, $create, $key, $modules);
 }

 require($_jasPath["project"]["include"]."switch.php"); //default
?>
