<?

 /*************************************************************************************
 * Filename: skeleton.php
 *
 * This file is part of the skeleton JAS plugin.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The skeleton JAS plugin is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/skeleton/
 *************************************************************************************/


 class skeleton extends BasePlugin
 {
  /*
   * Main
   *
   * All non displaying logic that needs to be performed before the data sets are gathered
   */

  function main()
  {
   //logic

   if($this->e->any())
    return false;

   return true;
  }


  /*
   * Output
   *
   * All displaying logic for gathering and displaying information
   */

  function output()
  {
   $output="";

   //gather output data...

   if($this->e->any())
    return false; //results in errors being displayed

   //render output

   return $output;
  }

  /*
   * Pager plugin cache hook
   *
   * cacheTime: time to which is checked whether cache is still up-to-date
   * cacheKey: unique key used for caching.
   *
   * Both need to be set for successful caching.
   *
   *
   * The cache logic is called right before the output() call.
   * If the cache function doesn't exist the default pager cache logic will be used.
   * To disable caching for this plugin ensure the cache function always returns false
   */

  function cache(&$cacheTime, &$cacheKey)
  {
   //determine last update time

   //determine unique cache key
   //Note that the pager plugin already sets a prefix for user/group specific caching so the unique key should be appended to the cache key ($cacheKey.=$uniqueID) unless this behaviour should be ignored.

   if($this->e->any())
    return false; //results in no caching

   return true;
  }

 }
?>
