<?

 /*************************************************************************************
 * Filename: ut/skeleton.php
 *
 * This file is part of the skeleton JAS plugin.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The skeleton JAS plugin is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/skeleton/
 *************************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");

 class UT_Skeleton extends UT_Plugins
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initClass();

   if(!is_object($p->class)||get_class($p->class)!="skeleton")
   {
    $this->e->add("Class isn't a skeleton object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->class)!="BasePlugin")
   {
    $this->e->add("Class isn't a BasePlugin object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Main()
  {
   $p=new Plugin("skeleton");
   $p->initClass();

   if($p->class->main()!==true)
   {
    $this->e->add("Plugin main function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->class->main()!==false)
   {
    $this->e->add("Plugin main function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   $p=new Plugin("skeleton");
   $p->initClass();

   if($p->class->output()===false)
   {
    $this->e->add("Plugin output function shouldn't return false", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->class->output()!==false)
   {
    $this->e->add("Plugin output function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }


 class UT_SkeletonBackend extends UT_Skeleton
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initBackendClass();

   if(!is_object($p->backendClass)||get_class($p->backendClass)!="skeleton_backend")
   {
    $this->e->add("Backend class isn't a skeleton_backend object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->backendClass)!="BasePluginBackend")
   {
    $this->e->add("Backend class isn't a BasePluginBackend object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Main()
  {
   $p=new Plugin("skeleton");
   $p->initBackendClass();

   if($p->backendClass->main()!==true)
   {
    $this->e->add("Plugin backend main function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->backendClass->main()!==false)
   {
    $this->e->add("Plugin backend main function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   $p=new Plugin("skeleton");
   $p->initBackendClass();

   if($p->backendClass->output("main")===false)
   {
    $this->e->add("Plugin backend output function shouldn't return false", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   $p->e->add("test", "error");
   if($p->backendClass->output("main")!==false)
   {
    $this->e->add("Plugin backend output function should return false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

 class UT_SkeletonSetup extends UT_Skeleton
 {
  function Constructor()
  {
   $p=new Plugin("skeleton");
   $p->initSetupClass();

   if(!is_object($p->setupClass)||get_class($p->setupClass)!="skeleton_setup")
   {
    $this->e->add("Setup class isn't a skeleton_setup object", "error");
    return UT_FAILED;
   }

   if(get_parent_class($p->setupClass)!="BasePluginSetup")
   {
    $this->e->add("Setup class isn't a BasePluginSetup object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Init()
  {
   $p=new Plugin("skeleton");
   $p->initSetupClass();

   if($p->setupClass->init()!==true)
   {
    $this->e->add("Plugin setup init function should return true", "error");
    $this->e->add($p->e);
    return UT_FAILED;
   }

   return UT_OK;
  }
 }

?>
