<?

 /*****************************************************************************
 * Filename: project/jas/include/view.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."data.php");

 function viewItem($module=false, $action=false, $plugin=false)
 {
  global $_path, $_config, $baseURL, $lang, $_useModRewrite;

  if(!$action)
   $action="view";

  $modules=Array();

  $f=new Form();
  $d=Data::cache($module, $action, "item");
  $d->setShowFields(array_merge(Array("catnr"), $d->check("use", "show")));

  $cms=new CMS(Array("useStyling" => false));
  $cms->setDataForm($d, $f);

  if($d->module=="categories")
   $d->setValue("nr", $d->getValue("catnr"));
  else if(!request("nr"))
   return $module;

  if($_useModRewrite)
   $cmsURL=$baseURL."cms/".$d->module."/";
  else
   $cmsURL=$baseURL."&amp;cms=true&amp;m=".$d->module;

  if(!$d->get(1))
  {
   if($d->e->any())
    print $d->e->show();
  }
  else
  {
   while($d->next())
   {
    if(!$module)
    { 
     if($d->module=="categories"&&$d->v["module"]!="")
      $modules=$d->v["module"];
    }
    ?>
    <h1><?=$d->title?></h1>
    <div class="text"><?=$d->v("title")?></div>
    <div class="text fields">
 
     <?
      foreach($d->check("use", "show") as $k)
      if(!$d->check("properties", "default", $k))
      {
       if(isset($d->v[$k]))
       {
        ?>  
         <div class="field">
          <div class="title"><?=$d->t[$k]?></div>
          <div class="input"><?
           if($d->check("type", "file", $k))
            print $cms->field($k, "fake")." ";
           else if($d->check("type", "boolean", $k))
            print ($d->v[$k]?"True":"False");
           else if($d->check("type", "image", $k))
           {
            print $cms->field($k, "fake")." ";
            print $d->v[$k];
           }
           else if(is_array($d->v[$k]))
           {
            if(isset($d->reference[$k]))
            {
             if($d->reference[$k]["type"]=="*:*")
             {
              foreach(array_keys($d->v[$k]) as $k2)
              {
               $values=Array();  
               foreach($d->reference[$k]["data"]->check("use", "show") as $k3)
                if(isset($d->reference[$k]["data"]->reference[$k3]["data"]))
                 foreach($d->reference[$k]["data"]->reference[$k3]["data"]->check("use", "show") as $k4)
                  if(!isset($d->reference[$k]["data"]->reference[$k3]["data"]->reference[$k4]))
                   if(isset($d->v[$k][$k2][$k4]))
                    $values[]="<div class=\"title\">".$d->reference[$k]["data"]->reference[$k3]["data"]->field[$k4]["title"]."</div><div class=\"input\">".(is_array($d->v[$k][$k2][$k4])?implode(", ", $d->v[$k][$k2][$k4]):$d->v[$k][$k2][$k4])."</div>";

               print "<div class=\"subfield\">".implode("</div><div class=\"subfield\">", $values)."</div><br style=\"clear: both;\"/>";
              }
             }
             else if($d->reference[$k]["type"]=="0:*"||$d->reference[$k]["type"]=="1:*")
             {
              foreach(array_keys($d->v[$k]) as $k2)
              {
               $values=Array();  
               foreach($d->reference[$k]["data"]->check("use", "show") as $k3)
                if(!isset($d->reference[$k]["data"]->reference[$k3]))
                 if(isset($d->v[$k][$k2][$k3]))
                  $values[]="<div class=\"title\">".$d->reference[$k]["data"]->field[$k3]["title"]."</div><div class=\"input\">".(is_array($d->v[$k][$k2][$k3])?implode(", ", $d->v[$k][$k2][$k3]):$d->v[$k][$k2][$k3])."</div>";

               print "<div class=\"subfield\">".implode("</div><div class=\"subfield\">", $values)."</div><br style=\"clear: both;\"/>";
              }
             }
             else
             {
              $values=Array();  
              foreach($d->reference[$k]["data"]->check("use", "show") as $k2)
               if(isset($d->v[$k][$k2]))
                $values[]="<div class=\"title\">".$d->reference[$k]["data"]->field[$k2]["title"]."</div><div class=\"input\">".(is_array($d->v[$k][$k2])?implode(", ", $d->v[$k][$k2]):$d->v[$k][$k2])."</div>";
     
              print "<div class=\"subfield\">".implode("</div><div class=\"subfield\">", $values)."</div><br style=\"clear: both;\"/>";
             }
            }
            else
             print implode(", ", $d->v[$k]);
           }
           else if(is_object($d->v[$k])&&strtolower(get_class($d->v[$k]))=="data")
           {
            $values=Array();
            while($d->v[$k]->next())
            {
             $tmp=Array();
             foreach(array_keys($d->v[$k]->v) as $k2)
             {
              if(is_array($d->v[$k]->v[$k2]))
               $tmp[]=$d->v[$k]->field[$k2]["title"].": ".implode(", ", $d->v[$k]->v[$k2]);
              else
               $tmp[]=$d->v[$k]->field[$k2]["title"].": ".$d->v[$k]->v[$k2];
             }

             $values[]=implode(", ", $tmp);
            }

            print $d->v[$k]->title."<br/>";
            print implode("<br/>", $values);
           }
           else if($d->v[$k])
            print $d->v[$k];
           else
            print "&nbsp;";
          ?></div>
         </div>
       <?
       }
      }
     ?>
    </div>

    <div class="info">
     <ul class="row">
      <li><?=$lang->t("NR")?>: <div class="hilite"><?=(is_array($d->v["nr"])?$d->v["nr"]["nr"]:$d->v["nr"])?></div></li> 
      <?if($d->v("owner")){?>
       <li><?=$lang->t("Owner")?>: <div class="hilite"><?=$d->v("owner")?></div></li> 
      <?}?>
      <?if(isset($d->v["catnr"])&&isset($d->v["catnr"]["nr"])){?>
       <li><?=$lang->t("Category")?>: <div class="hilite"><?=$d->v["catnr"]["name"]?></div></li> 
      <?}?>
      <?if(isset($d->v["updated"])){?>
       <li><?=$lang->t("Updated")?>: <div class="hilite"><?=$d->v["updated"]?></div></li> 
      <?}?>
     </ul>
    </div>

   <div class="cmsOptions"><ul>
   <?if($d->action=="deleted"){?>
    <?if($d->r("undelete")){?><li><a href="<?=$cmsURL.($_useModRewrite?"undelete/item/".$d->v["nr"]."/":"&amp;a=undelete&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Undelete item")?>"><?=icon("undelete", $d->module)?></a></li><?}?>
   <?} else if($d->r("add")||$d->r("edit")||$d->r("delete")||$d->r("move")||$d->r("owner")||($d->module=="categories"&&$d->r("rights"))){?>
    <?if($d->r("copy")){?><li><a href="<?=$cmsURL.($_useModRewrite?"copy/item/".$d->v["nr"]."/":"&amp;a=copy&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Copy item")?>"><?=icon("copy", $d->module)?></a></li><?}?>
    <?if($d->r("edit")){?><li><a href="<?=$cmsURL.($_useModRewrite?"edit/item/".$d->v["nr"]."/":"&amp;a=edit&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Edit item")?>"><?=icon("edit", $d->module)?></a></li><?}?>
    <?if($d->r("move")){?><li><a href="<?=$cmsURL.($_useModRewrite?"move/item/".$d->v["nr"]."/":"&amp;a=move&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Move item to another category")?>"><?=icon("move", $d->module)?></a></li><?}?>
    <?if($d->r("delete")){?><li><a href="<?=$cmsURL.($_useModRewrite?"delete/item/".$d->v["nr"]."/":"&amp;a=delete&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Delete item")?>"><?=icon("delete", $d->module)?></a></li><?}?>
    <?if($d->r("owner")){?><li><a href="<?=$cmsURL.($_useModRewrite?"owner/item/".$d->v["nr"]."/":"&amp;a=owner&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Change ownership")?>"><?=icon("owner", $d->module)?></a></li><?}?>
    <?if($d->module=="categories"){?>
     <?if($d->r("rights")){?><li><a href="<?=$cmsURL.($_useModRewrite?"rights/item/".$d->v["nr"]."/":"&amp;a=rights&amp;e=item&amp;nr=".$d->v["nr"])?>" title="<?=$lang->t("Change rights")?>"><?=icon("rights", $d->module)?></a></li><?}?>
    <?}?>
   <?}?>
   </ul></div>
    <?
   }
  ?><div class="separator"></div><?
  }

  if(!$modules&&!$module&&$d->module!="categories")
   $modules[]=$d->module;

  return $modules;
 }


 function contentList($module, $action=false, $extra=false, $plugin=false)
 {
  global $_config, $_path, $baseURL, $lang, $_useModRewrite;

  if(!$action)
   $action="view";

  if(!$extra)
   $extra="list";

  if(is_object($module)&&strtolower(get_class($module))=="data")
  {
   $d=$module;
   $module=$d->module;
  }
  else
   $d=Data::cache($module, $action, $extra);

  $total=25;

  if(!($page=request($d->module."_page"))||!is_numeric($page)||$page<1)
   $page=1;

  $d->setShowFields(array_merge(Array("catnr"), $d->check("properties", "title")));

  $d->setValue("show_total", $total);
  $d->setValue("show_from", ($page-1)*$total);

  if($d->e->any("fatal"))
  {
   print $d->e->show("fatal");
   return;
  }

  if(!$d->check("reference", "categories"))
   $d->extra="all";

  if(!$catnr=$d->getValue("catnr"))
  {
   if(!($catnr=request("catnr"))||!is_numeric($catnr))
    $catnr=0;
  }

  if($d->module=="settings"&&$d->getValue("nr"))
   $d->setValue("setnr", $d->getValue("nr"));

  if($_useModRewrite)
   $url=$baseURL."?";
  else
   $url=$baseURL."&amp;";

  if($_useModRewrite)
   $cmsURL=$baseURL."cms/".$d->module."/";
  else
   $cmsURL=$baseURL."&amp;cms=true&amp;m=".$d->module;

  if(!$d->get(0, true))
   print $d->e->show("fatal");
  else
  {
   ?>
   <div>
    <h2>
     <?
      if($d->module=="categories")
      {
       $tmp=Data::cache("categories", "view", "item");
       $tmp->setShowFields("catnr");
       $tmp->setValue("nr", $catnr);
       if($tmp->get()&&$tmp->next()&&$tmp->v["catnr"])
       {
        ?><a href="<?=$url?>catnr=<?=$tmp->v["catnr"]?>" title="<?=$lang->t("Goto above category")?>"><?=icon("up")?></a><?
       }
       unset($tmp);
      }
     ?>

     <?=$d->title?>
    </h2>
    <?if($d->vmax){?>
    <ul class="list decimal">
   <?

   if(count($d->check("properties", "order")))
    $order=true;
   else
    $order=false;

   while($d->next())
   {
    ?>
    <li>
     <?if($order){?>
      <?if($d->vc==1){?>
       <?=icon("orderup-disabled", $d->module)?>
      <?}else{?>
       <a href="<?=$cmsURL.($_useModRewrite?"order/up/".$d->v["nr"]."/?":"&amp;a=order&amp;e=up&amp;nr=".$d->v["nr"]."&amp;")?>s=1" title="Order <?=$d->v("title")?> up"><?=icon("orderup", $d->module)?></a>
      <?}?>
      <?if($d->vc==$d->vmax){?>
       <?=icon("orderdown-disabled", $d->module)?>
      <?}else{?>
       <a href="<?=$cmsURL.($_useModRewrite?"order/down/".$d->v["nr"]."/?":"&amp;a=order&amp;e=down&amp;nr=".$d->v["nr"]."&amp;")?>s=1" title="Order <?=$d->v("title")?> down"><?=icon("orderdown", $d->module)?></a>
      <?}?>
     <?}?>
     <a href="<?=$url.($d->module!="categories"?"m=".$d->module."&amp;nr=".$d->v["nr"].($d->check("reference", "categories")?"&amp;catnr=".$d->v["catnr"]:""):"catnr=".$d->v["nr"])?>" title="<?=$d->v("title")?>"><?=$d->v("title")?></a>
    </li>
    <?
   }
   ?></ul>
   <?}?>
  </div>

  <div class="separator"></div>
  <?
   $count=$d->getValue("show_count");
   $total=$d->getValue("show_total");

   if($total)
    $pages=ceil($count/$total);
   else
    $pages=0;

   if($page>$pages)
    $page=0;

   if($pages>1)
   {
    if($page>1)
     $previous=$page-1;
    else
     $previous=false;

    if($page<$pages)
     $next=$page+1;
    else
     $next=false;

    if($pages<=25)
     $pagelist=range(1, $pages);
    else
    {
     if($page<=8)
     {
      $pagelist=range(1, $page+5);
      $pagelist[]="...";
      $pagelist[]=$pages;
     }
     else if($pages-$page<=7)
     {
      $pagelist=Array();
      $pagelist[]=1;
      $pagelist[]="...";

      for($c=$pages-(($pages-$page)+5);$c<=$pages;$c++)
       $pagelist[]=$c;
     }
     else
     {
      $pagelist=Array();
      $pagelist[]=1;
      $pagelist[]="...";

      for($c=$page-5;$c<=$page+5;$c++)
       $pagelist[]=$c;

      $pagelist[]="...";
      $pagelist[]=$pages;
     }
    }

    $purl=$url;

    if(($m=request("m"))&&in_array($m, modules())) //module based browsing fix
     $purl.="m=".$m."&amp;";

    if($d->extra=="list") //categories based browsing fix
    {
     if($d->module=="categories")
      $purl.="catnr=".$d->v["catnr"]."&amp;";
     else
      if($d->check("reference", "categories"))
       $purl.="catnr=".$d->v["catnr"]."&amp;";
    }

    $purl.=$d->module."_page=";

   ?>
   <div class="pager"> 
    <?if($previous!==false){?>
     <a href="<?=$purl.$previous?>" title="<?=$lang->t("Previous page")?>"><?=icon("previous")?></a>
    <?}else{?>
     <?=icon("previous-disabled")?>
    <?}?>

    <?=$lang->t("Pages:")?>
    <?foreach($pagelist as $c){?>
     <?if($c!=$page&&$c!="..."){?>
      <a href="<?=$purl.$c?>" title="<?=$lang->t("Page: ".$c)?>"><?=$c?></a>
     <?}else{?>
      <?=$c?>
     <?}?>
    <?}?>

    <?if($next!==false){?>
     <a href="<?=$purl.$next?>" title="<?=$lang->t("Next page")?>"><?=icon("next")?></a>
    <?}else{?>
     <?=icon("next-disabled")?>
    <?}?>
   </div>
   <?
   }
  }

  $url.="&amp;cms=true";
 
  if($d->module=="categories")//category
   $data="category";
  else
   $data="content";

  if($d->extra!="all"&&$d->check("reference", "categories"))
  {
   $dr=Data::cache("categories", "view", "item");
   $dr->unsetValue("catnr");
   $dr->setValue("nr", $catnr); 

   if(!$dr->get())
    print $dr->e->show("fatal");
   else
   {
    while($dr->next())
    {
     ?>
     <div class="cmsOptions"><ul>
     <?if($d->action=="deleted"){?>
      <?if($dr->r("undelete", $data)){?><li><a href="<?=$cmsURL.($_useModRewrite?"undelete/list/?":"&amp;a=undelete&amp;e=list&amp;")?>catnr=<?=$dr->v["nr"]?>" title="<?=$lang->t("Undelete all items in category")?>"><?=icon("undelete", $dr->module)?></a></li><?}?>
     <?} else if($dr->r("add", $data)||$dr->r("delete", $data)||$dr->r("move", $data)){?>
      <?if($dr->r("add", $data)){?><li><a href="<?=$cmsURL.($_useModRewrite?"add/item/?":"&amp;a=add&amp;e=item&amp;")?>catnr=<?=$dr->v["nr"]?>" title="<?=$lang->t("Add item")?>"><?=icon("add", $dr->module)?></a></li><?}?>
      <?if($dr->r("move", $data)){?><li><a href="<?=$cmsURL.($_useModRewrite?"move/list/?":"&amp;a=move&amp;e=list&amp;")?>catnr=<?=$dr->v["nr"]?>" title="<?=$lang->t("Move all items to another category")?>"><?=icon("move", $dr->module)?></a></li><?}?>
      <?if($dr->r("delete", $data)){?><li><a href="<?=$cmsURL.($_useModRewrite?"delete/list/?":"&amp;a=delete&amp;e=list&amp;")?>catnr=<?=$dr->v["nr"]?>" title="<?=$lang->t("Delete all items in category")?>"><?=icon("delete", $dr->module)?></a></li><?}?>
     <?}?>
     </ul></div>

     <div class="separator"></div>
    <?
    }
   }
  }
  else if($d->extra=="all"||$_config["usernr"]==$_config["rootnr"])
  {
   ?>
   <div class="cmsOptions"><ul>
    <?if($d->extra=="all"){?>
     <?if($d->action=="deleted"){?>
      <li><a href="<?=$cmsURL.($_useModRewrite?"undelete/all/":"&amp;a=undelete&amp;e=all")?>" title="<?=$lang->t("Undelete all items")?>"><?=icon("undelete", $d->module)?></a></li>
     <?} else {?>
      <li><a href="<?=$cmsURL.($_useModRewrite?"add/item/?":"&amp;a=add&amp;e=item&amp;")?>catnr=<?=$d->getValue("catnr")?>" title="<?=$lang->t("Add item")?>"><?=icon("add", $d->module)?></a></li>
      <li><a href="<?=$cmsURL.($_useModRewrite?"delete/all/":"&amp;a=delete&amp;e=all")?>" title="<?=$lang->t("Delete all items")?>"><?=icon("delete", $d->module)?></a></li>
     <?}?>
    <?}?>
   </ul></div>

   <div class="separator"></div>
  <?
  }
  else
  {
   ?>
   <div class="cmsOptions">
   </div>

   <div class="separator"></div>
  <?
  }
 }

 function icon($name, $module=false)
 {
  global $_jasPath, $_config;

  if($module&&file_exists($_jasPath["project"]["images"].$_config["style"]."/".$name."_".$module.".png"))
   $file=$_jasPath["project"]["images"].$_config["style"]."/".$name."_".$module.".png";
  else if(file_exists($_jasPath["project"]["images"]."default/".$name."_".$module.".png"))
   $file=$_jasPath["project"]["images"]."default/".$name."_".$module.".png";
  else if(file_exists($_jasPath["project"]["images"].$_config["style"]."/".$name.".png"))
   $file=$_jasPath["project"]["images"].$_config["style"]."/".$name.".png";
  else if(file_exists($_jasPath["project"]["images"]."default/".$name.".png"))
   $file=$_jasPath["project"]["images"]."default/".$name.".png";
  else
   return "";

  return "<img src=\"".$_jasPath["HTML"]["prefix"].$file."\" class=\"icon ".$name."\" alt=\"".ucfirst($name)."\"/>";
 }
?>
