<?

 /*****************************************************************************
 * Filename: project/jas/index.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!isset($_path))
 {
  $_jseskey="jas";

  $_path["root"]="../../";
  require_once($_path["root"]."include.php");
 }

 //incorporate default session into JAS
 if(isset($_SESSION["jses"]["default"])&&isset($_SESSION["jses"]["default"]["project"])&&!isset($_SESSION["jses"][$_SESSION["jses"]["default"]["project"]]))
 {
  $_SESSION["jses"][$_SESSION["jses"]["default"]["project"]]=&$_SESSION["jses"]["default"];
  $_jses["currentProject"]=$_SESSION["jses"]["default"]["project"];
 }

 if($_jseskey!="jas")
 {
  $_jseskey="jas";
  require_once($_path["root"]."include.php");
 }

 if($_benchmark)
  $_benchmark->start("Init");

 require_once($_path["include"]."functions.php");
 require_once($_path["include"]."layout.php");
 require_once($_path["include"]."language.php");
 require_once($_path["include"]."error.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."form.php");
 require_once($_path["include"]."history.php");
 require_once($_path["include"]."jas.php");

 $hs=new History();
 $hs->lockProject(); //lock to JAS
 if(!$hs->isAlreadyStored())
  $hs->store();
 unset($hs);

 require_once($_path["project"]["include"]."view.php");
 require_once($_path["project"]["include"]."cms.php");

 if(isset($_REQUEST["currentProject"])&&(in_array($_REQUEST["currentProject"], projects())||$_REQUEST["currentProject"]==""))
  $_jses["currentProject"]=$_REQUEST["currentProject"];

 $e=new Error();


 if($_config["useModRewrite"]&&!$_jses["modRewriteActive"]) //use mod rewrite force while not active
  $e->add("Mod rewrite used but not availble, either fix mod rewrite support or disable usage in the configuration", "warning");

 $_useModRewrite=$_config["useModRewrite"]; //set global _useModRewrite based on JAS config to make sure the project settings doesn't overwrite it


 $_jasPath=$_path;
 require_once($_jasPath["project"]["include"]."functions.php");


 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if(in_array("w3c_validator", plugins()))
 {
  $w3c=new Plugin("w3c_validator");
  if($w3c->isEnabled())
   $w3c->initClass();
 }
 else
  $w3c=false;

 $language=$_config["language"];

 if(request("doLogin"))
  doLogin();

 require($_jasPath["project"]["include"]."switch.php"); //default


 $lang=new Language();
 $lang->read("data", $language);
 $lang->read("cms", $language);
 $lang->read("jas", $language);

 if($_benchmark)
  $_benchmark->stop("Init");

 $_page=Array("", "");
 $_directory=Array("", "");

 if(backendLoggedIn())
 {
  if(request("p")) //detect page
  {
   $nav=Data::cache("categories", "view", "all");
   $nav->clearValues();
   $nav->setValue("page", request("p", 0));
   $nav->setValue("catnr", 1);
   $nav->setValue("treedepth", 1);
   $nav->setValue("show_total", 2);
   $nav->addReference("temp", "categories", "catnr", "1:*", "nr"); //get sub pages

   $nav->setShowFields("temp", "page", "directory", "nr", "content", "plugin", "pluginDisplay", "pluginConfigControl", "pluginConfigMain");

   if($nav->get(1)&&$nav->next()) //see if page matches request
   {
    $_page[0]=$nav->v["page"];

    if($nav->v["content"]=="Directory")
     $_directory[0]=$nav->v["directory"];
    else if($nav->v["content"]=="Plugin")
    {
     $_plugin=Array(
      "name" => $nav->v["plugin"],
      "display" => $nav->v["pluginDisplay"],
      "control" => $nav->v["pluginConfigControl"],
      "main" => $nav->v["pluginConfigMain"],
     );
    }

    if($_page[0]=="plugins") //get requested plugin for plugins page
    {
     if($page=request("p", 1))
     {
      if(!preg_match(REGEXP_DATA_PLUGIN, $page))
       $e->add("Illegal plugin name");
      else
       $_page[1]=$page;
     }
    }
    else if($nav->v["temp"]) //get sub page
    {
     if(($page=request("p", 1))&&$page!="cms") //check if requested page is valid
     {
      $l=sizeof($nav->v["temp"]);
      for($c=0;$c<$l;$c++)
      {
       if($page==$nav->v["temp"][$c]["page"]||$page==$nav->v["temp"][$c]["nr"])
       {
        $_page[1]=$nav->v["temp"][$c]["page"];

        if($nav->v["temp"][$c]["content"]=="Directory")
         $_directory[1]=$nav->v["temp"][$c]["directory"];
        else if($nav->v["temp"][$c]["content"]=="Plugin")
        {
         $_plugin=Array(
          "name" => $nav->v["temp"][$c]["plugin"],
          "display" => $nav->v["temp"][$c]["pluginDisplay"],
          "control" => $nav->v["temp"][$c]["pluginConfigControl"],
          "main" => $nav->v["temp"][$c]["pluginConfigMain"],
         );
        }

        break;
       }
      }
      unset($c, $l);
     }

     if(!$_page[1]) //sub page not found, use default
     {
      $c=0; //default: first sub page
      $_page[1]=$nav->v["temp"][$c]["page"];

      if($nav->v["temp"][$c]["content"]=="Directory")
       $_directory[1]=$nav->v["temp"][$c]["directory"];
      else if($nav->v["temp"][$c]["content"]=="Plugin")
      {
       $_plugin=Array(
        "name" => $nav->v["temp"][$c]["plugin"],
        "display" => $nav->v["temp"][$c]["pluginDisplay"],
        "control" => $nav->v["temp"][$c]["pluginConfigControl"],
        "main" => $nav->v["temp"][$c]["pluginConfigMain"],
       );
      }
     }
    }

    unset($page);
   }

   unset($nav->reference["temp"]);
  }

  if(!$_page[0]) //page not found, get default page
  {
   $nav=Data::cache("categories", "tree", "down");
   $nav->clearValues();
   $nav->setValue("catnr", 1);
   $nav->setValue("treedepth", 1);
   $nav->setValue("show_total", 2);
   $nav->setShowFields("page", "directory", "nr", "catnr", "content", "plugin", "pluginDisplay", "pluginConfigControl", "pluginConfigMain");

   $_page=Array("", "");
   $_directory=Array("", "");
   if($nav->get()&&$nav->next())
   {
    $_page[0]=$nav->v["page"];

    if($nav->v["content"]=="Directory")
     $_directory[0]=$nav->v["directory"];
    else if($nav->v["content"]=="Plugin")
    {
     $_plugin=Array(
      "name" => $nav->v["plugin"],
      "display" => $nav->v["pluginDisplay"],
      "control" => $nav->v["pluginConfigControl"],
      "main" => $nav->v["pluginConfigMain"],
     );
    }

    if($nav->next()&&$nav->v["catnr"]==$nav->getValue("nr", 0))
    {
     $_page[1]=$nav->v["page"];

     if($nav->v["content"]=="Directory")
      $_directory[1]=$nav->v["directory"];
     else if($nav->v["content"]=="Plugin")
     {
      $_plugin=Array(
       "name" => $nav->v["plugin"],
       "display" => $nav->v["pluginDisplay"],
       "control" => $nav->v["pluginConfigControl"],
       "main" => $nav->v["pluginConfigMain"],
      );
     }
    }
   }
  }

  if(($p=request("p"))&&is_array($p)) //get "sub" pages
  {
   foreach($p as $k => $v)
    if(!isset($_page[$k])||$_page[$k]!=$v)
     $_page[]=$v;

   unset($k, $v);
  }
  unset($p);

  $e->add($nav->e);
  unset($nav);

  if($_useModRewrite)
   $baseURL=$_path["HTML"]["url"];
  else
   $baseURL=$_path["HTML"]["url"]."?p[]=".$_page[0].($_page[1]?"&amp;p[]=".$_page[1]:"");

  if($_benchmark)
   $_benchmark->start("Plugin/page logic");

  if(isset($_plugin)&&$_plugin)
  {
   if($_plugin["display"]=="Frontend")
   {
    if($_plugin["control"])
    {
     $config=$_plugin["control"];
     $_plugin["control"]=new Plugin($_plugin["name"]);

     if(!$_plugin["control"]->isEnabled())
      $_plugin["control"]=false;
     else
     {
      if(!$_useModRewrite)
      {
       $_plugin["control"]->addVar("p[0]", $_page[0]);
       $_plugin["control"]->addVar("p[1]", $_page[1]);
      }

      if($config)
       $_plugin["control"]->config($config, true);

      $_plugin["control"]->main();
     }
    }

    $config=$_plugin["main"];
    $_plugin["main"]=new Plugin($_plugin["name"]);

    if(!$_plugin["main"]->isEnabled())
     $_plugin["main"]=false;
    else
    {
     if(!$_useModRewrite)
     {
      $_plugin["main"]->addVar("p[0]", $_page[0]);
      $_plugin["main"]->addVar("p[1]", $_page[1]);
     }

     if($config)
      $_plugin["main"]->config($config, true);

     $_plugin["main"]->main();
    }

    unset($config);
   }
   else //Backend
   {
    require($_jasPath["project"]["include"]."switch.php"); //currentProject

    $_plugin["control"]=new Plugin($_plugin["name"]);
    if(
     !$_plugin["control"]->isEnabled()||
     !$_plugin["control"]->readInfo()||
     !$_plugin["control"]->hasBackend()||
     !$_plugin["control"]->initBackendClass()||
     !$_plugin["control"]->backend_function||
     !$_plugin["control"]->backend_output
    )
     $_plugin["control"]=false;
    else
    {
     if(!$_useModRewrite)
     {
      $_plugin["control"]->addVar("p[0]", $_page[0]);
      $_plugin["control"]->addVar("p[1]", $_page[1]);
     }
    }


    $_plugin["main"]=new Plugin($_plugin["name"]);
    if(
     !$_plugin["main"]->isEnabled()||
     !$_plugin["main"]->readInfo()||
     !$_plugin["main"]->hasBackend()||
     !$_plugin["main"]->initBackendClass()||
     !$_plugin["control"]->backend_function||
     !$_plugin["control"]->backend_output
    )
     $_plugin["main"]=false;
    else
    {
     if(!$_useModRewrite)
     {
      $_plugin["main"]->addVar("p[0]", $_page[0]);
      $_plugin["main"]->addVar("p[1]", $_page[1]);
     }

     $_plugin["main"]->backend();
    }

    require($_jasPath["project"]["include"]."switch.php"); //default
   }
  }
  else if($_directory[1]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[1]."/logic.php"))
   require($_jasPath["project"]["include"]."pages/".$_directory[1]."/logic.php");
  else if($_directory[0]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[0]."/logic.php"))
   require($_jasPath["project"]["include"]."pages/".$_directory[0]."/logic.php");
  else if(file_exists($_jasPath["project"]["include"]."pages/logic.php"))
   require($_jasPath["project"]["include"]."pages/logic.php");

  if($_benchmark)
   $_benchmark->stop("Plugin/page logic");
 }


 $title=$_config["title"];
 require($_jasPath["project"]["include"]."switch.php"); //currentProject

 if($title!=$_config["title"])
  $title.=" - ".$_config["title"];

 require($_jasPath["project"]["include"]."switch.php"); //default

 $layout=new Layout();
 print $layout->doctype("XHTML 1.1");
 print $layout->header($title, $_page[0].".css;".$_page[1].".css;cms.css;calendar.css", "functions.js;cookies.js;flash.js;getelements.js;navigation.js;groups.js;pager.js;main.js;http.js;language.js;selection.js;wysiwyg.js;fixLinks.js;calendar.js;passwords.js;cms.js", "favicon.ico");
 print $layout->body();
 unset($title);

?>
 <div class="titleBar">
  <div class="title">
   <a href="<?=$_path["HTML"]["current"]?>" title="<?=$_config["title"]?>"><img src="<?=$_path["HTML"]["prefix"].$_path["project"]["images"]?>jas.png" class="logo" alt="<?=$_config["title"]?>"/></a>
   <?=$_config["title"]?>
  </div>
 <?if(backendLoggedIn()){?>
  <div class="version">
   <?=$lang->t("Version").": ".JAS::version().(JAS::version("status")?" ".JAS::version("status"):"").(JAS::version("development")?"*":"")?>
  </div>
<?}?>
<?
 if(!setJasRootPassword())
 {
 ?>
 </div>
 <div class="content">
  <div class="backendLogin">
  <?
   if($e->any())
    print $e->show();

   showSetRootPassword(true);
  ?>
  </div>
 </div>
 <?
 }
 else if(!backendLoggedIn())
 {
 ?>
 </div>
 <div class="content">
  <div class="backendLogin">
  <?
   if($e->any())
    print $e->show();

   require($_jasPath["project"]["include"]."switch.php"); //currentProject
   showLoginForm(true);
   require($_jasPath["project"]["include"]."switch.php"); //default
  ?>
  </div>
 </div>
 <?
 }
 else
 {
?>
  <div class="login">
   <?
    require($_jasPath["project"]["include"]."switch.php"); //currentProject

    $d=Data::cache($_config["usermodule"], "view", "item");
    $d->setValue("nr", $_config["usernr"]);

    print "<table><tr><td style=\"text-align: right;\">";

    if($d->get()&&$d->next())
     print $d->v("title");
    else
     print $lang->t("Unknown");

    unset($d);

    print "</td><td>@</td><td>";

    if($_jses["project"]!="jas")
    {
     if(isset($_SESSION["jses"]["default"])&&isset($_SESSION["jses"]["default"]["project"])&&$_SESSION["jses"]["default"]["project"]==$_jses["project"]) //default project, open root index
     {
      ?><a href="<?=$_jasPath["HTML"]["root"]?>" rel="external" title="<?=$lang->t("Open Project")?>"><?=$_config["title"]?></a><?
     }
     else
     {
      ?><a href="<?=$_jasPath["HTML"]["current"].$_jasPath["project"]["root"]?>project/" rel="external" title="<?=$lang->t("Open Project")?>"><?=$_config["title"]?></a><?
     }
    }
    else
     print $_config["title"];

    print "</td></tr><tr><td>";
    showLoginForm();
    print "</td><td>&nbsp; </td><td>";
    showSelectProject();
    print " </td></tr></table>";

    require($_jasPath["project"]["include"]."switch.php"); //default
   ?>
  </div>
 </div>

 <div class="nav">
 <?
  if($_benchmark)
   $_benchmark->start("Navigation display");

  $nav=Data::cache("categories", "tree", "down");
  $nav->setAction("tree");
  $nav->setExtra("down");
  $nav->clearValues();
  $nav->setValue("catnr", 1);
  $nav->setValue("treedepth", 1);
  $nav->setShowFields("name", "text", "page", "directory", "nr", "catnr", "treedepth", "content", "url", "urlrel");

  if($nav->get())
  {
   ?>
    <ul class="navigation">
    <?while($nav->next())
    {
     if($nav->v["treedepth"]==0) //next level 1
     {
      $page=$nav->v["page"];

      if($nav->v["content"]=="URL")
      {
      ?>
       <li<?=($_page[0]==$nav->v["page"]?" class=\"active\"":"")?>>
        <a href="<?=$nav->v["url"]?>" title="<?=$nav->v["text"]?>"<?=($nav->v["urlrel"]?" rel=\"".$nav->v["urlrel"]."\"":"")?>><?=$nav->v["name"]?></a>
       <?
      }
      else
      {
      ?>
       <li<?=($_page[0]==$nav->v["page"]?" class=\"active\"":"")?>>
        <a href="<?=$_path["HTML"]["current"].($_useModRewrite?$page."/":"?p[]=".$page)?>" title="<?=$nav->v["text"]?>"><?=$nav->v["name"]?></a>
       <?
        if($page=="plugins")
        {
         ?><ul class="subnavigation"><?

         require($_jasPath["project"]["include"]."switch.php"); //currentProject
         foreach(plugins() as $p)
         {
          $tmp=ucfirst(str_replace("_", " ", $p));
          ?><li<?=($p==$_page[1]?" class=\"active\"":"")?>><a href="<?=$_path["HTML"]["current"].($_useModRewrite?$page."/".$p."/":"?p[]=".$page."&amp;p[]=".$p)?>" title="<?=$tmp?>"><?=$tmp?></a></li><?
         }
         require($_jasPath["project"]["include"]."switch.php"); //default

         ?></ul></li><?
        }
        else
        {
         $list="";
         $anyleft=false;
         while($nav->next())
         {
          $anyleft=true;
          if($nav->v["treedepth"]==0) //next level 1
          {
           $nav->vc--;
           break;
          }

          if($nav->v["content"]=="URL")
           $list.="<li".($_page[1]==$nav->v["page"]?" class=\"active\"":"")."><a href=\"".$nav->v["url"]."\" title=\"".$nav->v["text"]."\"".($nav->v["urlrel"]?" rel=\"".$nav->v["urlrel"]."\"":"").">".$nav->v["name"]."</a></li>";
          else
           $list.="<li".($_page[1]==$nav->v["page"]?" class=\"active\"":"")."><a href=\"".$_path["HTML"]["current"].($_useModRewrite?$page."/".$nav->v["page"]."/":"?p[]=".$page."&amp;p[]=".$nav->v["page"])."\" title=\"".$nav->v["text"]."\">".$nav->v["name"]."</a></li>";
         }

         if($list)
         {
          ?><ul class="navigation"><?=$list?></ul><?
         }

         ?></li><?

         if($nav->vc==0||!$anyleft)
          break;
        }
       }
      }
     }
   ?>
   </ul>
  <?
  }
  unset($nav, $page, $anyleft);

  if($_benchmark)
   $_benchmark->stop("Navigation display");
 ?>
 </div>

 <div class="content">
  <div class="control">
   <?
    if($_benchmark)
     $_benchmark->start("Control display");

    if(isset($_plugin)&&$_plugin)
    {
     if($_plugin["control"])
     {
      if($_plugin["display"]=="Frontend")
      {
       if(($output=$_plugin["control"]->output())===false)
        $output=$_plugin["control"]->e->show();

       print $output;
       unset($output);
      }
      else
      {
       require($_jasPath["project"]["include"]."switch.php"); //currentProject
       
       ?><div class="pluginBackend <?=$_plugin["main"]->name?>"><?

       if(($output=$_plugin["control"]->backendOutput("control"))===false)
        $output=$_plugin["control"]->e->show();

       print $output;
       unset($output);

       ?></div><?

       require($_jasPath["project"]["include"]."switch.php"); //default
      }
     }
    }
    else if($_directory[1]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[1]."/control.php"))
     require($_jasPath["project"]["include"]."pages/".$_directory[1]."/control.php");
    else if($_directory[0]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[0]."/control.php"))
     require($_jasPath["project"]["include"]."pages/".$_directory[0]."/control.php");
    else if(file_exists($_jasPath["project"]["include"]."pages/control.php"))
     require($_jasPath["project"]["include"]."pages/control.php");

   ?>
   <h3><?=$lang->t("Data search", false, $language)?></h3>
   <div class="text">
   <?
    showSearch();
   ?>
   </div>
   <div class="footer">&nbsp; </div>

   <?
    require($_jasPath["project"]["include"]."switch.php"); //currentProject
    if($w3c&&$w3c->isEnabled())
    {
     if($_useModRewrite)
      $w3c->baseURL($_path["HTML"]["current"]."plugins/".$w3c->name."/");
     else
     {
      $w3c->addVar("p[0]", "plugins");
      $w3c->addVar("p[1]", $w3c->name);
     }

     $w3c->addVar("main", "1");

     ?><div class="text"><?
     print $w3c->output("xhtml-1.1")."\n";
     print $w3c->output("css-3.0")."\n";
     ?></div><?
    }
    require($_jasPath["project"]["include"]."switch.php"); //default

    if($_benchmark)
     $_benchmark->stop("Control display");
   ?>
  </div>

  <div class="main">
  <?
   if($_benchmark)
    $_benchmark->start("Main display");

   if(isset($_plugin)&&$_plugin)
   {
    if($_plugin["main"])
    {
     if($e->any())
      print $e->show();

     if($_plugin["display"]=="Frontend")
     {
      if(($output=$_plugin["main"]->output())===false)
       $output=$_plugin["main"]->e->show();

      print $output;
      unset($output);
     }
     else
     {
      require($_jasPath["project"]["include"]."switch.php"); //currentProject

      ?><div class="pluginBackend <?=$_plugin["main"]->name?>"><?

      if(($output=$_plugin["main"]->backendOutput("main"))===false)
       $output=$_plugin["main"]->e->show();

      print $output;
      unset($output);

      ?></div><?

      require($_jasPath["project"]["include"]."switch.php"); //default
     }
    }
   }
   else if($_directory[1]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[1]."/main.php"))
    require($_jasPath["project"]["include"]."pages/".$_directory[1]."/main.php");
   else if($_directory[0]&&file_exists($_jasPath["project"]["include"]."pages/".$_directory[0]."/main.php"))
    require($_jasPath["project"]["include"]."pages/".$_directory[0]."/main.php");
   else if(file_exists($_jasPath["project"]["include"]."pages/main.php"))
    require($_jasPath["project"]["include"]."pages/main.php");

   if($_benchmark)
    $_benchmark->stop("Main display");
  ?>
  </div>
 </div>
<?
 if($_benchmark)
  print $_benchmark->show();
 }

 print $layout->footer();
 $lang->store();
?>
