

 /*****************************************************************************
 * Filename: script/fixLinks.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else
 onload("fixLinks();");

function fixLinks()
{
 var links=document.getElementsByTagName("a");
 for(c=0;c<links.length;c++)
 {
  if(links[c].rel=="external") //new window
  {
   var type="external";
   var target=links[c].href.replace(/\w+:\/\/([^\/]+).*/gi, "$1").replace(/\./g, "_"); //ensure same domain is (re)opened in same window

   links[c].onclick=function(){openWindow(this.href, target, type); return false;};
  }
  else if(links[c].rel.match(/popup/)) //popup window
  {
   var type="popup";
   var target="popup";

   var width=undefined;
   var height=undefined;

   var popup=false;
   if(popup=links[c].rel.match(/(\d+)x(\d+)/)) //width x height set
   {
    width=popup[1];
    height=popup[2];
   }

   links[c].onclick=function(){openWindow(this.href, target, type, width, height); return false;};
  }
 }
}

function openWindow(url, target, type, width, height)
{
 var options={
  "location": "yes",
  "menubar": "yes",
  "resizable": "yes",
  "scrollbars": "yes",
  "status": "yes",
  "titlebar": "yes",
  "toolbar": "yes"
 };

 switch(type)
 {
  case "external": //external window, full size
  {
   //remove all options
   options={};

   break; 
  }
  default: //popup, either predefined size or 90% of the current window
  {
   var windowWidth=0;
   var windowHeight=0;

   if(window.innerWidth)
   {
    windowWidth=window.innerWidth;
    windowHeight=window.innerHeight;
   }
   else //ie < 9
   {
    windowWidth=document.documentElement.clientWidth;
    windowHeight=document.documentElement.clientHeight;
   }

   if(width==undefined)
    options["width"]=Math.round(windowWidth*0.9);
   else
    options["width"]=Math.round(width);

   if(height==undefined)
    options["height"]=windowHeight*0.9;
   else
    options["height"]=height;

   //align window in the middle of the screen
   options["left"]=Math.round((windowWidth-options["width"])/2);
   options["top"]=Math.round((windowHeight-options["height"])/2);

   //overwrite defaults
   options["location"]="no";
   options["menubar"]="no";
   options["resizable"]="no";
   options["status"]="no";
   options["titlebar"]="no";
   options["toolbar"]="no";

   break;
  }
 }

 //generate options string
 var optionsString="";
 for(option in options)
  if(option&&options[option])
   optionsString+=option+"="+options[option]+",";

 optionsString=optionsString.slice(0, -1); //remove last ,

 return window.open(url, target, optionsString);
}

