

 /*****************************************************************************
 * Filename: script/language.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2013 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(browser)=="undefined"||typeof(path)=="undefined"||typeof(rootpath)=="undefined")
 alert("JAS Script not loaded");
else if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");

function Language(set)
{
 var self=this;

 self.init=init;
 self.read=read;

 self.t=t;

 self.init(set);

 function init(set)
 {
  self.error="";

  self.language=Array();
  self.language["normal"]=Array();
  self.language["lowercase"]=Array();
  self.language["regexp"]=Array();

  self.from="en";
  self.to=false;

  if(typeof(set)!="undefined")
   self.read(set, "");
 }

 function read(set, language)
 {
  if(typeof(HTTP)=="undefined")
  {
   self.error="Unable to load language: HTTP script not found, make sure you\'ve included http.js";
   return false;
  }

  if(typeof(language)=="undefined")
   language="";
 
  var http=new HTTP();

  var xml='<?xml version="1.0" encoding="ISO-8859-1"?>\n';
  xml+='<jas version="1.0">\n';
  xml+=' <language set="'+set+'" language="'+language+'"/>\n';
  xml+='</jas>\n';

  if(!http.xmliRequest(xml))
   self.error=http.error;

  if(browser.match(/internet explorer/i))
   var jas=http.xml.childNodes[1];
  else
   var jas=http.xml.childNodes[0];

  if(!jas)
  {
   if(!http.error.match(/Request[\s\S]*successful/))
    self.error=http.error;

   return false;
  }

  if(jas.getElementsByTagName("errors").length) //non fatal errors, probably default language 
   return true;

  var languages=jas.getElementsByTagName("language");

  if(languages.length==0) 
  {
   self.error="Unknown XML returned: "+http.txt.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\n/g, "<br/>").replace(/  /g, "&nbsp; ");
   return false;
  }

  for(var c=0;c<languages.length;c++)
  {
   var originalLanguage=languages[c].getAttribute("original");
   var translatedLanguage=languages[c].getAttribute("translated");

   if(typeof(self.language["normal"][originalLanguage])=="undefined")
     self.language["normal"][originalLanguage]=Array();
   if(typeof(self.language["normal"][originalLanguage][translatedLanguage])=="undefined")
    self.language["normal"][originalLanguage][translatedLanguage]=Array();

   if(typeof(self.language["lowercase"][originalLanguage])=="undefined")
     self.language["lowercase"][originalLanguage]=Array();
   if(typeof(self.language["lowercase"][originalLanguage][translatedLanguage])=="undefined")
    self.language["lowercase"][originalLanguage][translatedLanguage]=Array();

   if(typeof(self.language["regexp"][originalLanguage])=="undefined")
     self.language["regexp"][originalLanguage]=Array();
   if(typeof(self.language["regexp"][originalLanguage][translatedLanguage])=="undefined")
    self.language["regexp"][originalLanguage][translatedLanguage]=Array();

   if(self.to==false)
    self.to=translatedLanguage;

   var translations=languages[c].getElementsByTagName("translation");

   for(var x=0;x<translations.length;x++)
   {
    if(translations[x].getAttribute("original").match("\\|translate\\|"))
    {
     var rgxp="/"+translations[x].getAttribute("original").replace("|translate|", "(.*)")+"/";
     self.language["regexp"][originalLanguage][translatedLanguage][rgxp]=translations[x].getAttribute("translated");
    }
    else
    {
     self.language["normal"][originalLanguage][translatedLanguage][translations[x].getAttribute("original")]=translations[x].getAttribute("translated");
     self.language["lowercase"][originalLanguage][translatedLanguage][translations[x].getAttribute("original").toLowerCase()]=translations[x].getAttribute("translated").toLowerCase();
    }
   }
  }

  return true;
 
 }

 function t(text, from, to)
 {
  if(typeof(from)=="undefined")
   from=self.from;

  if(typeof(to)=="undefined")
   to=self.to;

  if(from==to||to==false)
   return text;

  if(self.language["normal"][from][to][text])
   return self.language["normal"][from][to][text];

  if(self.language["lowercase"][from][to][text.toLowerCase()])
   return self.language["lowercase"][from][to][text.toLowerCase()];

  if(typeof(initInArrayFunction)=='undefined')
   return text;

  for(var rgxp in self.language["regexp"][from][to])
  {
   if(rgxp!="in_array")
   {
    var tmp;
    if(tmp=text.match(eval(rgxp)))
    {
     var newText=self.language["regexp"][from][to][rgxp];
     for(c=1;c<tmp.length;c++)
     {
      if(tmp[c].match(/^\d+$/)||self.language["normal"][from][to].in_array(tmp[c])||self.language["lowercase"][from][to].in_array(tmp[c]))
       newText=newText.replace("\|"+c+"\|", tmp[c]);
      else
       newText=newText.replace("\|"+c+"\|", self.t(tmp[c], from, to));
     }

     return newText;
    }
   }
  }

  return text;
 }

}
